2026-02-20  Werner Koch  <wk@gnupg.org>

	Release 1.12.1.
	+ commit 7e91b2a334d568297b7d81e05acd74e1d841b69d


2026-02-16  NIIBE Yutaka  <gniibe@fsij.org>

	cipher:ecc: Fix Weierstrass curve with PUBKEY_FLAG_PARAM.
	+ commit 4aa07eeca100512e87117db8ef4b41cce12b10cb
	* cipher/ecc-curves.c (point_from_keyparam): Handle the case where
	EC==NULL.
	* cipher/ecc-misc.c (_gcry_ecc_sec_decodepoint): Care about
	EC==NULL.

	mpi:ec: Use mpi_new with NBITS, instead of mpi_alloc.
	+ commit 740915ea5f20cfce21d182391389b26a462075c8
	* mpi/ec.c (ec_get_two_inv_p): Use mpi_new with NBITS.
	* cipher/ecc-ecdsa.c (_gcry_ecc_ecdsa_sign): Likewise.
	(_gcry_ecc_ecdsa_verify): Likewise.
	* cipher/ecc-gost.c (_gcry_ecc_gost_sign): Likewise.
	(_gcry_ecc_gost_verify): Likewise.

	mpi:ec: Make sure to have MPI limbs in ECC.
	+ commit 1468aaaa473d7f73623247580441bcc4aef07ee1
	* src/mpi.h (_gcry_mpi_point_init): Add NBITS argument.
	* mpi/ec.c (point_init): Follow the change.
	(_gcry_mpi_point_log): Fix mpi_new with NBITS.
	(_gcry_mpi_point_new): Fix _gcry_mpi_point_init with NBITS.
	(_gcry_mpi_point_init): Initialize with mpi_new with NBITS.
	(_gcry_mpi_ec_get_affine): Fix mpi_new with NBITS.
	(montgomery_mul_point): Fix point_init with NBITS.
	(mpi_ec_mul_point_lli): Fix point_init and mpi_new with NBITS.
	(_gcry_mpi_ec_mul_point): Fix point_init with NBITS.
	(_gcry_mpi_ec_curve_point): Fix mpi_new with NBITS.
	* mpi/ec-hw-s390x.c (_gcry_s390x_ec_hw_mul_point): Likewise.
	(s390_mul_point_montgomery): Likewise.
	* cipher/ecc-common.h (point_init): Follow the change of
	_gcry_mpi_point_init.
	* cipher/ecc-curves.c (_gcry_ecc_get_curve): Likewise.
	(point_from_keyparam): Fix mpi_point_new with NBITS.
	(mpi_ec_get_elliptic_curve): Follow the change of
	_gcry_mpi_point_init.
	(_gcry_ecc_set_mpi): Fix mpi_point_new with NBITS.
	* cipher/ecc-ecdh.c (_gcry_ecc_curve_keypair)
	(_gcry_ecc_curve_mul_point): Fix point_init with NBITS.
	* cipher/ecc-ecdsa.c (_gcry_ecc_ecdsa_sign): Likewise.
	(_gcry_ecc_ecdsa_verify): Likewise.
	* cipher/ecc-eddsa.c (_gcry_ecc_eddsa_encodepoint, ecc_ed448_recover_x)
	(_gcry_ecc_eddsa_recover_x): Fix mpi_new with NBITS.
	(_gcry_ecc_eddsa_genkey): Remove unused X and Y.  Fix point_init with
	NBITS.
	(_gcry_ecc_eddsa_sign): Fix mpi_new with NBITS.  Fix point_init with
	NBITS.
	(_gcry_ecc_eddsa_verify): Fix point_init with NBITS.
	* cipher/ecc-gost.c (_gcry_ecc_gost_sign, _gcry_ecc_gost_verify):
	Likewise.
	* cipher/ecc-misc.c (_gcry_ecc_curve_copy): Follow the change of
	_gcry_mpi_point_init.
	(_gcry_mpi_ec_ec2os, _gcry_ecc_sec_decodepoint): Fix mpi_new with
	NBITS.
	(_gcry_ecc_compute_public): Fix mpi_point_new with NBITS.
	* cipher/ecc-sm2.c (_gcry_ecc_sm2_encrypt): Fix point_init with NBITS.
	Fix mpi_new with NBITS.
	(_gcry_ecc_sm2_decrypt, _gcry_ecc_sm2_sign, _gcry_ecc_sm2_verify):
	Likewise.
	* cipher/ecc.c (nist_generate_key): Fix point_init with NBITS.
	(test_keys): Likewise.
	(test_ecdh_only_keys): Fix point_init and mpi_new with NBITS.
	(check_secret_key): Likewise.
	(ecc_generate): Fix mpi_new with NBITS.
	(ecc_encrypt_raw): Fix mpi_new and point_init with NBITS.
	(ecc_decrypt_raw): Fix point_init and mpi_new with NBITS.
	(compute_keygrip): Fix mpi_new with NBITS.

2026-02-15  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	configure.ac: fix HAVE_COMPATIBLE_GCC_AMD64_PLATFORM_AS on x32 targets.
	+ commit 722c5894ea8e08f668246add7332c2503d4b856c
	* configure.ac (gcry_cv_compiler_defines__x86_64__): New.
	(HAVE_COMPATIBLE_GCC_AMD64_PLATFORM_AS): Enable if __x86_64__ macro is
	defined by compiler and size of long is 4 (x32) or 8 (amd64).

2026-02-05  Rudi Heitbaum  <rudi@heitbaum.com>

	sexp: Fix for use of strchr wrt const qualifier.
	+ commit 581478c9ef9a77a0dd7c2abf6fe31cc35f730fe2
	* src/misc.c (_gcry_log_printsxp): Use const char * for PEND.

	cipher: remove unused variable idx in _gcry_pk_get_keygrip.
	+ commit b7ea9e3afc9fe9ee4e39e2663fbbe3ab5484eaea
	* cipher/pubkey.c (_gcry_pk_get_keygrip): Remove IDX.

2026-02-03  NIIBE Yutaka  <gniibe@fsij.org>

	mpi:ec: Don't modify POINT in _gcry_mpi_ec_get_affine.
	+ commit 949557945cf806dfbc646c8919a398ae637f7c25
	* mpi/ec.c (_gcry_mpi_ec_get_affine): Don't modify POINT.

2026-02-01  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	rijndael-vaes-avx512: add PIC @PLT for AVX2 function jumps.
	+ commit 927850875c6254282697dbbed8aff65275bdeff5
	* cipher/asm-common-amd64.h (AT_PLT): New.
	* cipher/rijndael-vaes-avx512-amd64.S: Use AT_PLT for jumps to
	AVX2/VAES functions.

2026-01-29  Werner Koch  <wk@gnupg.org>

	Release 1.12.0.
	+ commit efd5e1e7b4e7861b53eafdbf197fd6d4ff6f45e1
	* configure.ac (NEED_GPG_ERROR_VERSION): Bump to 1.56

	tests: Also distribute tests for RSA-PSS, Kyber and Dilithium.
	+ commit 2284db4553c3e469a7457811bbe68909f276691f
	* tests/testdrv.c (testpgms): Add t-rsa-pss, t-mlda, and t-mlkem.
	* tests/t-fips-service-ind.c (check_cipher_o_s_e_d_c): Fix printf
	format.

	tests: Fix building of testdrv-build.
	+ commit 12b067260d7866259af18ac302bf66bf6931c26f
	* tests/Makefile.am (testdrv-build): Add -DPACKAGE_VERSION.

2026-01-21  NIIBE Yutaka  <gniibe@fsij.org>

	fips,cipher: Fix the regression with disabled public-key algo.
	+ commit 2c1d41b5f86f93db56432616bc3ee704b9c9cc39
	* cipher/pubkey.c (_gcry_pk_decrypt): Continue the computation when
	marking non-compliant.
	(_gcry_pk_encrypt): When disabled, return an error.
	(_gcry_pk_sign, _gcry_pk_sign_md): Likewise.
	(gcry_pk_verify, _gcry_pk_verify_md, _gcry_pk_testkey): Likewise.

2026-01-15  NIIBE Yutaka  <gniibe@fsij.org>

	build: Apply local change to texinfo.tex.
	+ commit 85bbb33734362cdaaab46abd4b10b3200f026235
	* build-aux/texinfo.tex: Fix typos.

2026-01-14  NIIBE Yutaka  <gniibe@fsij.org>

	build: Update build-aux and m4 from libgpg-error.
	+ commit e53ae4f14f880ac73ade669c0ad6bd1a73883813
	* build-aux/compile, build-aux/depcomp: Update.
	* build-aux/ltmain.sh, build-aux/mdate-sh: Likewise.
	* build-aux/missing, build-aux/texinfo.tex: Likewise.
	* m4/libtool.m4, m4/ltoptions.m4: Likewise.
	* m4/ltsugar.m4, m4/ltversion.m4, m4/lt~obsolete.m4: Likewise.
	* m4/gpg-error.m4: Likewise.

2026-01-13  NIIBE Yutaka  <gniibe@fsij.org>

	mpi: Use secure MPI in _gcry_mpi_assign_limb_space.
	+ commit 6e77b09cff56dd357cd2be332e3a2af200190382
	* mpi/mpiutil.c (_gcry_mpi_assign_limb_space): Use secure memory
	when destination is secure memory.

2026-01-02  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	rijndael: add VAES/AVX512 accelerated implementation.
	+ commit 9e3af928ee1100fc979a75dd4ae6a4ace2c36bef
	* cipher/Makefile.am: Add 'rijndael-vaes-avx512-amd64.S'.
	* cipher/rijndael-internal.h (USE_VAES_AVX512): New.
	(RIJNDAEL_context_s) [USE_VAES_AVX512]: Add 'use_vaes_avx512'.
	* cipher/rijndael-vaes-avx2-amd64.S
	(_gcry_vaes_avx2_ocb_crypt_amd64): Minor optimization for aligned
	blk8 OCB path.
	* cipher/rijndael-vaes-avx512-amd64.S: New.
	* cipher/rijndael-vaes.c [USE_VAES_AVX512]
	(_gcry_vaes_avx512_cbc_dec_amd64, _gcry_vaes_avx512_cfb_dec_amd64)
	(_gcry_vaes_avx512_ctr_enc_amd64)
	(_gcry_vaes_avx512_ctr32le_enc_amd64)
	(_gcry_vaes_avx512_ocb_aligned_crypt_amd64)
	(_gcry_vaes_avx512_xts_crypt_amd64)
	(_gcry_vaes_avx512_ecb_crypt_amd64): New.
	(_gcry_aes_vaes_ecb_crypt, _gcry_aes_vaes_cbc_dec)
	(_gcry_aes_vaes_cfb_dec, _gcry_aes_vaes_ctr_enc)
	(_gcry_aes_vaes_ctr32le_enc, _gcry_aes_vaes_ocb_crypt)
	(_gcry_aes_vaes_ocb_auth, _gcry_aes_vaes_xts_crypt)
	[USE_VAES_AVX512]: Add AVX512 code paths.
	* cipher/rijndael.c (do_setkey) [USE_VAES_AVX512]: Add setup for
	'ctx->use_vaes_avx512'.
	* configure.ac: Add 'rijndael-vaes-avx512-amd64.lo'.

	rijndael-aesni: use assembly for moving first and last round key.
	+ commit d5cf2b90c7d081988c84e23a8f874562fba1d775
	* cipher/rijndael-aesni.c (do_aesni_prepare_decryption): Use
	assembly for moving first and last round keys for decryption.

	rijndael-aesni: prevent inlining AESNI functions by LTO.
	+ commit 7afdbb2812b2fdeea7911f1f67e4079d4f6466e0
	* cipher/rijndael-aesni.c (_gcry_aes_aesni_do_setkey)
	(_gcry_aes_aesni_prepare_decryption, _gcry_aes_aesni_encrypt)
	(_gcry_aes_aesni_ecb_crypt, _gcry_aes_aesni_cfb_enc)
	(_gcry_aes_aesni_cbc_enc, _gcry_aes_aesni_ctr_enc)
	(_gcry_aes_aesni_ctr32le_enc, _gcry_aes_aesni_decrypt)
	(_gcry_aes_aesni_cfb_dec, _gcry_aes_aesni_cbc_dec)
	(_gcry_aes_aesni_ocb_crypt, _gcry_aes_aesni_ocb_auth)
	(_gcry_aes_aesni_xts_crypt): Mark function as noinline.

	rijndael-riscv-zvkned: optimize do_prepare_decryption.
	+ commit 4c9d7a3ba939255d78320d887eb648410949071d
	* cipher/rijndael-riscv-zvkned.c (do_prepare_decryption): Unroll
	loop.

	rijndael-riscv-zvkned: optimize aes192 key setup.
	+ commit ef372b484e0f0876a6657f5ca692c101b8c113bd
	* cipher/rijndael-riscv-zvkned.c (AES192_KF1_GEN): Avoid use of
	stack array for loading scalar value to vector register.

	chacha20: avoid AVX512/AVX2/SSSE3 for single block processing with Zen5.
	+ commit c1d9fff3b2ebde8d54b29e2ad0dce75c74de73ba
	* cipher/chacha20.c (CHACHA20_context_s): Add
	'skip_one_block_hw_impl'.
	(chacha20_blocks, do_chacha20_encrypt_stream_tail): Avoid single
	block / non-parallel processing with AVX512/AVX2/SSSE3.

	blake2: avoid AVX/AVX2/AVX512 when CPU has high vector inst latency.
	+ commit e5bc3b28260ef9967d713a75ad381ee7e97dcb88
	* cipher/blake2.c (blake2b_init_ctx, blake2s_init_ctx): Disable
	AVX/AVX2/AVX512 implementation if x86 CPU prefers GPR implementation
	over scalar integer vector.
	* src/hwf-common.h (hwf_x86_cpu_details)
	(_gcry_hwf_x86_cpu_details): New.
	* src/hwf-x86.c (x86_cpu_details, x86_hw_features)
	(x86_detect_done, _gcry_hwf_x86_cpu_details): New.
	(detect_x86_gnuc): Detect Zen5 and add 'cpu_details'.
	(_gcry_hwf_detect_x86): Add 'x86_cpu_details' setup.

	camellia-gfni-avx512: add 1-block constant-time implementation.
	+ commit 8b538a8c766922337c6c0718271e9399072518f3
	* cipher/camellia-gfni-avx512-amd64.S
	(_gcry_camellia_gfni_avx512_enc_blk1)
	(_gcry_camellia_gfni_avx512_dec_blk1): New.
	* cipher/camellia-glue.c [USE_GFNI_AVX512]
	(_gcry_camellia_gfni_avx512_enc_blk1)
	(_gcry_camellia_gfni_avx512_dec_blk1): New prototypes.
	(camellia_decrypt, camellia_encrypt) [USE_GFNI_AVX512]: Use
	GFNI/AVX512 1-block implementation if supported by CPU.

	aria-x86_64: fixes for CFI markings.
	+ commit 861896b0fad8a7bac5c3ec303391d7b23ff22898
	* cipher/aria-aesni-avx-amd64.S: Add missing CFI stack adjustments
	after pushq/popq.
	* cipher/aria-aesni-avx2-amd64.S: Likewise.
	* cipher/aria-gfni-avx512-amd64.S: Likewise.

	camellia-simd128: optimize round key loading and key setup.
	+ commit b9bafd6c6cc59ac65d0103f2fd3ccc4a4a24a325
	* cipher/camellia-simd128.h (if_vprolb128, vprolb128)
	(vmovd128_amemld, vmovq128_amemld, vmovq128_memld)
	(memory_barrier_with_vec, filter_8bit_3op): New.
	(LE64_LO32, LE64_HI32): Remove.
	(roundsm16, fls16, inpack16_pre, outunpack16): Use 'vmovd128_amemld'
	and 'vmovq128_amemld' for loading round keys.
	(camellia_f): Optimize/Rewrite and split core to ...
	(camellia_f_core): ... this.
	(camellia_f_xor_x): New.
	(sp0044440444044404mask, sp1110111010011110mask)
	(sp0222022222000222mask, sp3033303303303033mask): Adjust constants
	for optimized/rewritten 'camellia_f'.
	(camellia_setup128, camellia_setup256): Adjust for optimized
	'camellia_f'; Use 'vmovq128_amemld' for loading round keys.
	(FUNC_KEY_SETUP): Use 'vmovq128_amemld' instead of 'vmovq128'.

	camellia-aesni-avx: optimize camellia_f used for key setup.
	+ commit f5848080d41a6d706c881fcde0dd47390f609802
	* cipher/camellia-aesni-avx-amd64.S (split_nibbles)
	(filter_8bit_nibbles): New.
	(filter_8bit): Refactor.
	(transpose_8x8b): Remove.
	(camellia_f, camellia_f_core): Refactor.
	(.Lsbox4_input_mask): Remove.
	(__camellia_avx_setup128, __camellia_avx_setup256): Adjust for new
	'camellia_f'.

2025-12-12  NIIBE Yutaka  <gniibe@fsij.org>

	mpi:ec: Fix for use of ec_mulm_lli in _gcry_mpi_ec_get_affine.
	+ commit 92bbe34514ee180c074b882d8459cdf6b873ba0c
	* mpi/ec.c (_gcry_mpi_ec_get_affine): Resize X and Y.  Add
	GCRYECC_FLAG_LEAST_LEAK flag.

	w32: Fix use of GetProcAddress.
	+ commit 028926d3edb52ac2ea6bfabf92748c323265a1d7
	* src/hwfeatures.c (_gcry_get_sysconfdir): Add a type cast.

2025-12-04  NIIBE Yutaka  <gniibe@fsij.org>

	build: Add support for IBM z/OS, fixing -lpthread check with glibc.
	+ commit 5af59d8454cea0231b622ee3ded6f4ead16d05b0
	* configure.ac: Care about PRINTABLE_OS_NAME for IBM z/OS.
	Handle have_pthread for IBM z/OS.
	No check with -lpthread when we know about have_pthread.

2025-12-02  Sachin T  <sachin.t@ibm.com>

	Add support for IBM z/OS.
	+ commit 550b2e2f13df95d8d8371181a6a606a0c062107d
	* m4/libtool.m4: Add openedition* case.
	* mpi/longlong.h: Exclude s390x GCC assembly on z/OS.
	* src/secmem.c (lock_pool_pages): Allow !HAVE_MLOCK on z/OS.

2025-11-27  Werner Koch  <wk@gnupg.org>

	w32: Use CSIDL_COMMON_APPDATA instead of /etc.
	+ commit d5e3cbfd8845a872d39f468da27a443cea4587e2
	* src/hwfeatures.c [W32]: Include shlobj.h
	(_gcry_get_sysconfdir): New.
	(get_hwf_deny_file): New.  Use this instead of the HWF_DENY_FILE
	macro.
	* src/fips.c (get_fips_force_file): New. Use this instead of
	FIPS_FORCE_FILE.
	(_gcry_initialize_fips_mode) [W32]: Do not parse files under "/proc".
	* random/random.c (get_random_conf_file): New.  Use instead of
	RANDOM_CONF_FILE macro.

2025-11-25  NIIBE Yutaka  <gniibe@fsij.org>

	cipher:kyber: Apply a change from upstream.
	+ commit bdc3724d721dfd65fdd8cad311855461f9a101c1
	* cipher/kyber-kdep.c (crypto_kem_dec): Fix the buffer size.

2025-11-20  Gary Lin  <glin@suse.com>

	kdf: Avoid redundant memcpy()
	+ commit 670646bbf185587c7de039430d71a38b7f0f8597
	* cipher/kdf.c (fill_block): Xor 'ref_block' and 'prev_block' directly
	to avoid a redundant memcpy().

2025-11-19  NIIBE Yutaka  <gniibe@fsij.org>

	mpi: Introduce mpi_tfr and use it for point_tfr.
	+ commit 4e65996bb8707c890bff7aeb6e1ec44610b49257
	* mpi/ec.c (point_tfr): New.
	(mpi_ec_mul_point_lli): Use point_tfr.
	* mpi/mpiutil.c (_gcry_mpi_tfr): New.
	* src/mpi.h (mpi_tfr): New.
	(_gcry_mpi_tfr): New.

2025-10-29  NIIBE Yutaka  <gniibe@fsij.org>

	secmem: Handle HAVE_BROKEN_MLOCK for the case with ASAN.
	+ commit fe06287003a153d358f2ddb62ce5d1ec112b2e5c
	* src/secmem.c [HAVE_BROKEN_MLOCK] (lock_pool_pages): Take care when
	build with address sanitizer.

	random:jent: Fix build with address sanitizer.
	+ commit def1d4ea8f66abf23ef0def6d8d34060e1ee923e
	* random/jitterentropy-base.c (jent_entropy_collector_alloc_internal):
	Annotate with gpgrt_annotate_leaked_object.

2025-10-23  NIIBE Yutaka  <gniibe@fsij.org>

	random:jent: Fix for jent_rng_is_initialized.
	+ commit 0ceca9993f5a94389624f6cf12e07165cd2391e4
	* random/rndjent.c (_gcry_rndjent_poll): Set jent_rng_is_initialized
	after successful initialization.
	(_gcry_rndjent_fini): Clear jent_rng_is_initialized.

2025-09-30  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	Add stack burning for PQC algorithms.
	+ commit 1003c9412a4be0c1d248929267a73cf3849fa60b
	* cipher/dilithium.h (DILITHIUM_KEYPAIR_STACK_BURN)
	(DILITHIUM_SIGN_STACK_BURN, DILITHIUM_VERIFY_STACK_BURN): New.
	* cipher/kem.c (_gcry_kem_genkey, _gcry_kem_encap)
	(_gcry_kem_decap): Burn stack after calls to sntrup761, kyber and
	mceliece6688128f algos.
	* cipher/kyber.h (KYBER_KEYPAIR_STACK_BURN, KYBER_ENCAP_STACK_BURN)
	(KYBER_DECAP_STACK_BURN): New.
	* cipher/mceliece6688128f.h (MCELIECE6688128F_KEYPAIR_STACK_BURN)
	(MCELIECE6688128F_ENC_STACK_BURN, MCELIECE6688128F_DEC_STACK_BURN): New.
	* cipher/pubkey-dilithium.c (mldsa_generate, mldsa_sign)
	(mldsa_verify): Burn stack after calls to dilithium algo.
	* cipher/sntrup761.h (SNTRUP761_KEYPAIR_STACK_BURN)
	(SNTRUP761_ENC_STACK_BURN, SNTRUP761_DEC_STACK_BURN): New.

	const-time: add 64-bit fast paths for const-time buffer functions.
	+ commit 11e8f4a8de263d9199479b290b8550e6a6ecc619
	* src/const-time.c (_gcry_ct_not_memequal, _gcry_ct_memequal): Add
	64-bit processing for larger than 7 byte inputs.

2025-09-28  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	mceliece6688128f: use const-time helper for memory comparison.
	+ commit 4c253746e52020254ede4f41d0440b41ca3aa8ec
	* cipher/mceliece6688128f.c (sync_cmp): Use const-time helper for
	comparison.

	mceliece6688128f: harden mask generation against branch optimization.
	+ commit 4012e9a037c5bf9f296ca89a6e94bb3600ec0d35
	* cipher/mceliece6688128f.c (crypto_int64_negative_mask)
	(crypto_int16_negative_mask, crypto_int32_negative_mask)
	(crypto_uint64_signed_negative_mask, crypto_uint16_signed_negative_mask)
	(crypto_uint32_signed_negative_mask, mask_nonzero, mask_leq, vec_cmov)
	(layer, gen_e, gf_mul, same_mask, pk_gen): Generate masks with
	const-time helper function.
	* src/const-time.h (ct_u64_gen_mask, ct_u64_gen_inv_mask): New.

	sntrup761: use const-time helpers for memory comparison and cond move.
	+ commit 4e963e91dbe55b23ed0da2003c2de053c40f4c9a
	* cipher/sntrup761.c (Ciphertexts_diff_mask): Use
	'_gcry_ct_not_memequal' for checking if arrays are different.
	(sntrup761_dec): Use '_gcry_ct_memmov_cond' for conditionally setting
	'r_enc'.

	sntrup761: harden mask generation against branch optimization.
	+ commit bf7546c5028b0c740c4a7a7142de17bcee588e58
	* cipher/sntrup761.c (int32_MINMAX, uint32_divmod_uint14)
	(int32_divmod_uint14, int16_t_nonzero_mask, int16_t_negative_mask)
	(Ciphertexts_diff_mask): Generate mask with const-time helper function.

	kyber: harden mask generation against branch optimization.
	+ commit 052b03fb0c6edea1a208ca0abb31ad09a86aa8e7
	* cipher/kyber-kdep.c (polyvec_compress, polyvec_compress): Generate
	mask with const-time helper function.

	mpih-pow: harden condition calculation against branch optimization.
	+ commit 96534d8c26c6c146482996cf120050e493b267c2
	* mpi/mpih-pow.c (mont_reduc): Pass condition code through mask
	generator to avoid optimization to branch by certain compilers.

	cipher-xts: harden mask generation against branch optimization.
	+ commit ee5cb3833d5b649ca360ab2bbde5ffaa28cbb717
	* cipher/cipher-xts.c (xts_gfmul_byA): Generate mask with const-time
	helper.

	rijndael: harden mask generation against branch optimization.
	+ commit f6b7a40f23c62a45ec1285388a5336c5cf313222
	* cipher/rijndael.c (do_setkey): Generate 'rcon' mask with const-time
	helper.
	(_gcry_aes_xts_crypt): Generate tweak mask with const-time helper.

	mceliece6688128f: fix stack overflow crash on win64/wine.
	+ commit 5bd932017116f0edf49641d56382356b4c5c876e
	* cipher/mceliece6688128f.c (pk_gen): Remove 'mat' array allocation and
	rename function to ...
	(pk_gen_mat): ... this.
	(pk_gen): New wrapper for 'pk_gen_mat' with dynamic allocation of 'mat'
	array.

2025-09-27  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	t-kem: add info print for each algoritm.
	+ commit 593525b4ce43db885068b4b968f70a609fe7edf2
	* tests/t-kem.c (test_kem_sntrup761, test_kem_mceliece6688128f)
	(test_kem_mlkem512, test_kem_mlkem768, test_kem_mlkem1024, test_kem_raw_x25519)
	(test_kem_dhkem_x25519): Add 'Checking <algo>' info print.

2025-09-25  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	hwfeatures: restore "intel-fast-vpgather" as dummy entry.
	+ commit d2ec4e84b40a29564f1b0a7491993e35e92b6466
	* src/hwfeatures.c (hwflist) [HAVE_CPU_ARCH_X86]: Add "intel-fast-vpgather"
	HW feature string without mapping to any HWF flag.

2025-09-24  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	mceliece6688128f: fix UBSAN runtime errors.
	+ commit a786e3b6bf8cdc29aaa209b6528cf9b455677e1a
	* cipher/mceliece6688128f.c (cbrecursion): Fix left shift of signed integer
	by too many places, by casting to unsigned integer before shift.
	(syndrome): Fix misaligned memory loads by using 'bufhelp.h'.

	configure.ac: perform RISC-V vector crypto intrinsics bug checks without LTO
	+ commit 5c9ce0cc51d9fdbd8d859756a26ab42c8a89333a
	* configure.ac (gcry_cv_riscv_vsha2cl_intrinsics_work)
	(gcry_cv_riscv_vaes_vs_intrinsics_work): Run check with '-fno-lto' compiler
	flag.

	hwf-x86: remove unused HWF_INTEL_FAST_VPGATHER.
	+ commit 2bbbaca1824055d20975029a733ce84d8be5b297
	* cipher/twofish-avx2-amd64.S (RNOT): Update comment on usage of this register
	macro.
	* doc/gcrypt.texi: Remove 'intel-fast-vpgather'.
	* src/g10lib.h (HWF_INTEL_FAST_VPGATHER): Remove.
	(HWF_INTEL_RDTSC, HWF_INTEL_SHAEXT, HWF_INTEL_VAES_VPCLMUL, HWF_INTEL_AVX512)
	(HWF_INTEL_GFNI): Shift bit position to close the gap left by FAST_VPGATHER
	removal.
	* src/hwf-x86.c (detect_x86_gnuc): Remove HWF_INTEL_FAST_VPGATHER detection.
	* src/hwfeatures.c (hwflist): Remove 'intel-fast-vpgather'.

2025-09-23  Werner Koch  <wk@gnupg.org>

	tests: Add helper option --exec to testdrv.
	+ commit 276fe34410ccea1a48abc38f773d83b756b1c76c
	* tests/testdrv.c (main): Add options --exec and --version.
	(my_spawn): Remove DETACHED_PROCESS flag.

2025-09-17  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	t-kem: fix test loop iteration.
	+ commit 9f26fa62ee73ea4bac6b3fd28e50be811ff27f24
	* tests/t-kem.c (check_kem): Reset loop iterator for each algo test loop.

	hwfeature: fix "riscv-zvkg" HW feature mapping.
	+ commit 561b2ffbeb632c9bfe135003209a05393018e745
	* src/hwfeatures.c (hwflist) [HAVE_CPU_ARCH_RISCV]: Fix mapping from
	ZVKNED to ZVKG for "riscv-zvkg".

2025-08-20  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	cipher-gcm-riscv-zbb-zbc: add POLYVAL acceleration.
	+ commit 00815c4207a151b5aea6591a4befbcdb832edc34
	* cipher/cipher-gcm-riscv-zbb-zbc.c (_gcry_ghash_riscv_zbb_zbc): Rename to ...
	(ghash_polyval_riscv_zbb_zbc): ... this; Add 'is_polyval' argument.
	(_gcry_ghash_riscv_zbb_zbc): New.
	(ghash_polyval_riscv_zbb_zbc): New.
	* cipher/cipher-gcm.c [GCM_USE_RISCV_ZBB_ZBC]
	(ghash_polyval_riscv_zbb_zbc): New.
	(setupM) [GCM_USE_RISCV_ZBB_ZBC]: Add setup for 'c->u_mode.gcm.polyval_fn'.

	Require RISC-V B extension for vector intrinsics implementations.
	+ commit 729794458fc731fcecd168785c56ada69c800c2a
	* cipher/Makefile.am (riscv_vector_cflags, riscv_vector_crypto_aes_cflags)
	(riscv_vector_crypto_sha_cflags, riscv_vector_crypto_gcm_cflags): Use
	MARCH_RVA22U64_WITH_VEC and MARCH_RVA23U64_BASE.
	* cipher/chacha20.c (chacha20_do_setkey) [USE_RISCV_V]: Require HWF_RISCV_B.
	* cipher/cipher-gcm.c (setupM) [GCM_UNSE_RISCV_ZVKG]: Likewise.
	* cipher/rijndael.c (do_setkey) [USE_RISCV_V_CRYPTO]: Likewise.
	(do_setkey) [USE_VP_RISCV]: Likewise.
	* cipher/sha256.c (sha256_common_init) [USE_RISCV_V_CRYPTO]: Likewise.
	* cipher/sha512.c (sha512_init_common) [USE_RISCV_V_CRYPTO]: Likewise.
	* doc/gcrypt.texi: Document riscv-imafdc, riscv-b, riscv-v, riscv-zbb,
	riscv-zbc, riscv-zvkb, riscv-zvkg, riscv-zvkned, riscv-zvknha and
	riscv-zvknhb as supported hardware features.
	* configure.ac (MARCH_RVA22U64_WITH_VEC, MARCH_RVA23U64_BASE)
	(MARCH_RVA23U64_WITH_VEC_CRYPTO): New.
	* src/g10lib.h (HWF_RISCV_B): Insert before HWF_RISCV_V.
	* src/hwf-riscv.c (hwcap_features, hwprobe_features): Add HWF_RISCV_V.
	(detect_riscv_hwf_by_toolchain) [__riscv_zba&&__riscv_zbb&&__riscv_zbs]: Add
	faulty toolchain check for B extension.
	* src/hwfeatures.c (hwflist) [HAVE_CPU_ARCH_RISCV]: Add "riscv-b".

2025-08-16  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	Add RISC-V Zbb+Zbc implementation of CRC.
	+ commit ab4fa2a19c9fb900e7864eb0a64656aa093f0ecb
	* cipher/Makefile.am: Add 'crc-riscv-zbb-zbc.c'.
	* cipher/crc-riscv-zbb-zbc.c: New.
	* cipher/crc.c (USE_RISCV_ZBB_ZBC): New.
	(CRC_CONTEXT) [USE_RISCV_ZBB_ZBC]: Add 'use_riscv_zbc'.
	[USE_RISCV_ZBB_ZBC] (_gcry_crc32_riscv_zbb_zbc)
	(_gcry_crc24rfc2440_riscv_zbb_zbc): New.
	(crc32_init): Rename to ...
	(generic_crc32_init): ... this; Add 'init_value' parameter.
	(generic_crc32_init) [USE_RISCV_ZBB_ZBC]: Add HW feature check for RISC-V
	Zbb+Zbc implementation.
	(crc24rfc2440_init) [USE_RISCV_ZBB_ZBC]: Likewise.
	(crc32_init, crc32rfc1510_init): Use 'generic_crc32_init'.
	(crc32_write) [USE_RISCV_ZBB_ZBC]: Add RISC-V Zbb+Zbc implementation.
	(crc24rfc2440_write) [USE_RISCV_ZBB_ZBC]: Likewise.
	* configure.ac: Add 'crc-riscv-zbb-zbc.lo'.

	Add RISC-V vector cryptography implementation of GHASH.
	+ commit cc2a4b63889ea1b33bdeafd8bf5f31a424d4dfc0
	* cipher/Makefile.am: Add 'cipher-gcm-riscv-zvkg.c'.
	* cipher/cipher-gcm-riscv-zbb-zbc.c: Fix cipher-internal.h include.
	* cipher/cipher-gcm-riscv-zvkg.c: New.
	* cipher/cipher-gcm.c [GCM_USE_RISCV_ZVKG] (_gcry_ghash_setup_riscv_zvkg)
	(_gcry_ghash_riscv_zvkg, _gcry_polyval_riscv_zvkg): New.
	(setupM) [GCM_USE_RISCV_ZVKG]: Add setup for Zvkg implementation.
	* cipher/cipher-internal.h (GCM_USE_RISCV_ZVKG): New.
	* configure.ac: Add 'cipher-gcm-riscv-zvkg.lo'.
	(GCRY_RISCV_VECTOR_CRYPTO_INTRINSICS_TEST): Add check for Zvkg instrinsic.
	* src/g10lib.h (HWF_RISCV_ZVKG): Insert before HWF_RISCV_ZVKNED.
	* src/hwdf-riscv.h (HWF_RISCV_HWPROBE_EXT_ZVKG): New.
	(hwprobe_features): Add HWF_RISCV_ZVKG.
	* src/hwfeatures.c (hwflist) [HAVE_CPU_ARCH_RISCV]: Add "riscv-zvkg".

2025-08-12  NIIBE Yutaka  <gniibe@fsij.org>

	mpi: Fix redefinition of types.
	+ commit 85927387741fad2aba4f8cc01e3b10ff4ff4c57f
	* mpi/mpi-internal.h (mpi_ptr_t): Remove, as it moved to mpi.h.
	(mpi_size_t): Likewise.

2025-08-09  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	Add RISC-V vector cryptography implementation of AES.
	+ commit b000ab602531b2c29e93736afc1686dea8ed6782
	* cipher/Makefile.am: Add 'rijndael-riscv-zvkned.c'.
	* cipher/rijndael-internal.h (USE_RISCV_V_CRYPTO): New.
	* cipher/rijndael-riscv-zvkned.c: New.
	* cipher/rijndael.c [USE_RISCV_V_CRYPTO]
	(_gcry_aes_riscv_zvkned_setup_acceleration, _gcry_aes_riscv_zvkned_setkey)
	(_gcry_aes_riscv_zvkned_prepare_decryption)
	(_gcry_aes_riscv_zvkned_encrypt, _gcry_aes_riscv_zvkned_decrypt)
	(_gcry_aes_riscv_zvkned_cfb_enc, _gcry_aes_riscv_zvkned_cbc_enc)
	(_gcry_aes_riscv_zvkned_ctr_enc, _gcry_aes_riscv_zvkned_ctr32le_enc)
	(_gcry_aes_riscv_zvkned_cfb_dec, _gcry_aes_riscv_zvkned_cbc_dec)
	(_gcry_aes_riscv_zvkned_ocb_crypt, _gcry_aes_riscv_zvkned_ocb_auth)
	(_gcry_aes_riscv_zvkned_ecb_crypt, _gcry_aes_riscv_zvkned_xts_crypt): New.
	(do_setkey) [USE_RISCV_V_CRYPTO]: Add setup for RISC-V vector cryptography
	extension implementation.
	* configure.ac: Add 'rijndael-riscv-zvkned.lo'.
	(GCRY_RISCV_VECTOR_CRYPTO_INTRINSICS_TEST): Add AES intrinsics.
	(gcry_cv_riscv_vaes_vs_intrinsics_work, HAVE_BROKEN_VAES_VS_INTRINSIC): New.
	* src/g10lib.h (HWF_RISCV_ZVKNED): Insert before HWF_RISCV_ZVKNHA.
	* src/hwf-riscv.c (HWF_RISCV_HWPROBE_EXT_ZVKNED): New.
	(hwprobe_features): Add Zvkned.
	* src/hwfeatures.c (hwflist): Add "riscv-zvkned".

2025-08-07  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	riscv: always use -mstrict-align for vector intrinsic implementations.
	+ commit 79149be2b0bac5b62dd333e0deff86dec170d6af
	* cipher/Makefile.am (riscv_vector_cflags, riscv_vector_crypto_cflags): Use
	"-mstrict-align" if SUPPORT_CC_RISCV_MSTRICT_ALIGN is set.
	* configure.ac (SUPPORT_CC_RISCV_MSTRICT_ALIGN): Add check for "-mstrict-align"
	compiler flag support.

	Add RISC-V vector cryptography implementations of SHA256 and SHA512.
	+ commit cc1d5b0b5ed30d4c36edbea128a6ab825d15415e
	* cipher/Makefile.am: Add 'sha256-riscv-zvknha-zvkb.c' and
	'sha512-riscv-zvknhb-zvkb.c'.
	* cipher/sha256-riscv-zvknha-zvkb.c: New.
	* cipher/sha256.c (USE_RISCV_V_CRYPTO): New.
	[USE_RISCV_V_CRYPTO] (_gcry_sha256_riscv_v_check_hw)
	(_gcry_sha256_transform_riscv_zvknha_zvkb)
	(do_sha256_transform_riscv_zvknha): New.
	(sha256_common_init) [sha256_common_init]: Enable new implementation
	if supported by HW.
	* cipher/sha512-riscv-zvknhb-zvkb.c: New.
	* cipher/sha512.c (USE_RISCV_V_CRYPTO): New.
	[USE_RISCV_V_CRYPTO] (_gcry_sha512_riscv_v_check_hw)
	(_gcry_sha512_transform_riscv_zvknhb_zvkb)
	(do_sha512_transform_riscv_zvknhb): New.
	(sha512_common_init) [sha512_common_init]: Enable new implementation
	if supported by HW.
	* configure.ac: Add 'sha256-riscv-zvknha-zvkb.lo' and
	'sha512-riscv-zvknhb-zvkb.lo'.
	(GCRY_RISCV_VECTOR_INTRINSICS_TEST): New.
	(gcry_cv_cc_riscv_vector_intrinsics)
	(gcry_cv_cc_riscv_vector_intrinsics_cflags): Move test code to new
	macro GCRY_RISCV_VECTOR_INTRINSICS_TEST.
	(GCRY_RISCV_VECTOR_CRYPTO_INTRINSICS_TEST)
	(gcry_cv_cc_riscv_vector_crypto_intrinsics)
	(gcry_cv_cc_riscv_vector_crypto_intrinsics_cflags)
	(gcry_cv_riscv_vsha2cl_intrinsics_work): New.
	* src/g10lib.h [HAVE_CPU_ARCH_RISCV] (HWF_RISCV_ZVKB, HWF_RISCV_ZVKNHA)
	(HWF_RISCV_ZVKNHB): New.
	* src/hwf-riscv.c (HWF_RISCV_HWPROBE_EXT_ZVKB)
	(HWF_RISCV_HWPROBE_EXT_ZVKNHA, HWF_RISCV_HWPROBE_EXT_ZVKNHB): New.
	* src/hwfeatures.c (hwflist) [HAVE_CPU_ARCH_RISCV]: Add "riscv-zvkb",
	"riscv-zvknha" and "riscv-zvknhb".

	bithelp: fix __riscv_zbb check for _gcry_ctz_no_zero.
	+ commit ca951abe818e26b8cefb11329f249213bc35b8d8
	* cipher/bithelp.h (_gcry_ctz_no_zero): Fix __riscv_zbb version check.

	rijndael-vp: clean-ups.
	+ commit 788e40f888032407c9001e1e54e7acc19db3f23d
	* cipher/rijndael-vp-riscv.c: Remove "./" from "cipher-internal.h" include.
	* cipher/rijndael-vp-simd128.h (aes_simd128_xts_enc, aes_simd128_xts_dec): Make
	these functions static.

	configure.ac: deduplicate intrinsics test code.
	+ commit 9001f098680ab1a365380974b7f183ecb756a026
	* configure.ac (gcry_cv_cc_aarch64_neon_intrinsics)
	(gcry_cv_cc_aarch64_neon_intrinsics_cflags): Move test source code
	to new macro GCRY_AARCH64_NEON_INTRINSICS_TEST.
	(gcry_cv_cc_ppc_altivec, gcry_cv_cc_ppc_altivec_cflags):
	Move test source code to new macro GCRY_POWERPC_VECTOR_INTRINSICS_TEST.

	crc-intel-pclmul: add AVX2 and AVX512 code paths.
	+ commit c30788969d3f2760933eb8e7bf1271c8e010b6d1
	* cipher/crc-intel-pclmul.c (crc32_consts_s, crc32_consts)
	(crc24rfc2440_consts): Add k_ymm and k_zmm.
	(crc32_reflected_bulk, crc32_bulk): Add VPCLMUL+AVX2 and VAES_VPCLMUL+AVX512
	code paths; Add 'hwfeatures' parameter.
	(_gcry_crc32_intel_pclmul, _gcry_crc24rfc2440_intel_pclmul): Add 'hwfeatures'
	parameter.
	* cipher/crc.c (CRC_CONTEXT) [USE_INTEL_PCLMUL]: Add 'hwfeatures'.
	(_gcry_crc32_intel_pclmul, _gcry_crc24rfc2440_intel_pclmul): Add 'hwfeatures'
	parameter.
	(crc32_init, crc32rfc1510_init, crc24rfc2440_init) [USE_INTEL_PCLMUL]: Store
	HW features to context.

2025-07-30  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	poly1305-p10le: use '.rodata' section for read-only data.
	+ commit 0c2d120e1124ee491712bbf93329c50a5b4d287f
	* cipher/poly1305-p10le.s: Change '.data' section to '.rodata'.

	Add missing abiversion tag for PowerPC assembly.
	+ commit 5cdb3b08fdd44c70ba9d771d2135e296c7d95e2d
	* cipher/chacha20-p10le-8x.s: Add abiversion tag.
	* cipher/poly1305-p10le.s: Likewise.
	* configure.ac (gcry_cv_gcc_inline_asm_ppc_altivec)
	(gcry_cv_gcc_inline_asm_ppc_arch_3_00): Likewise.

	Add missing machine tags for PowerPC assembly.
	+ commit 660ed722aed20f274daf6972930b9714cacef2fb
	* cipher/chacha20-p10le-8x.s: Add "any" machine tag.
	* cipher/poly1305-p10le.s: Likewise.
	* configure.ac (gcry_cv_gcc_inline_asm_ppc_altivec)
	(gcry_cv_gcc_inline_asm_ppc_arch_3_00): Likewise.

2025-07-30  NIIBE Yutaka  <gniibe@fsij.org>

	mpi: Provide the function prototype of __udiv_qrnnd.
	+ commit b61a7661d017c37bbc867a61a75213986954796b
	* mpi/longlong.h [__alpha] (__udiv_qrnnd): Add the prototype.
	[__hppa] (__udiv_qrnnd): Likewise.
	[__sparc__] (__udiv_qrnnd): Likewise.

2025-07-21  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	blake2s-avx512: mark merged load as such.
	+ commit 41c3747ebec07d8572668d231524666698c3b563
	* cipher/blake2s-amd64-avx512.S (GATHER_MSG_8): Add comment
	on 'vmovq' that it is merged load.

	blake2s-avx512: remove duplicate load.
	+ commit 0c48dcaad7554e16b1c233fc7c0176612f1c768c
	* cipher/blake2s-amd64-avx512.S (GATHER_MSG_3): Remove
	duplicate load which is already handled with 'vmovdqu32'
	earlier.

2025-07-04  NIIBE Yutaka  <gniibe@fsij.org>

	cipher:ecc: Silence GCC 15 warning.
	+ commit f06e90f4137a3dfaead69c21a8993c3530e0d913
	* cipher/ecc-eddsa.c (_gcry_ecc_eddsa_ensure_compact): Initialize
	ENC and ENCLEN before use.

	cipher:gcm: Minor fix for buffer size.
	+ commit e414699f5da7b54665c5496487beb68b753514f2
	* cipher/cipher-internal.h (struct gcry_cipher_handle): Use
	GCRY_GCM_BLOCK_LEN.

2025-07-03  NIIBE Yutaka  <gniibe@fsij.org>

	cipher:kem: Provide each enum constant as macro.
	+ commit e9b1c3ec91a17c62f46e6ffd5909d0ed95a89121
	src/gcrypt.h.in (GCRY_KEM_CM6688128F, GCRY_KEM_DHKEM25519)
	(GCRY_KEM_DHKEM448, GCRY_KEM_DHKEMP256R1, GCRY_KEM_DHKEMP384R1)
	(GCRY_KEM_DHKEMP521R1, GCRY_KEM_RAW_BP256, GCRY_KEM_RAW_BP384)
	(GCRY_KEM_RAW_BP512, GCRY_KEM_RAW_MLKEM512, GCRY_KEM_RAW_MLKEM768)
	(GCRY_KEM_RAW_MLKEM1024, GCRY_KEM_RAW_P256K1, GCRY_KEM_RAW_P256R1)
	(GCRY_KEM_RAW_P384R1, GCRY_KEM_RAW_P521R1, GCRY_KEM_RAW_X25519)
	(GCRY_KEM_RAW_X448, GCRY_KEM_SNTRUP761): New defines.

	cipher:rsa: Fix missing initialization in generate_fips.
	+ commit 292cb75a723c74b79ccd482c48620bd5f75c9e2e
	* cipher/rsa.c (generate_fips): Initialize E, P and Q.

	build: More changes to allow build with no Kyber.
	+ commit d9acecb02a90f8a746d7a9349782a08b014c82ba
	* cipher/Makefile.am (libcipher_la_SOURCES): Move kyber.c and kyber.h
	to ...
	(EXTRA_libcipher_la_SOURCES): ... here.
	* cipher/kem.c: [USE_KYBER]: Only include kyber.h when USE_KYBER.
	(_gcry_kem_genkey, _gcry_kem_encap, _gcry_kem_decap): [USE_KYBER]:
	Enable Kyber when USE_KYBER.
	* tests/keygen.c (check_kem_keys): [USE_KYBER]: Enable Kyber when
	USE_KYBER.

2025-07-02  NIIBE Yutaka  <gniibe@fsij.org>

	build: Allow build with no Kyber.
	+ commit f2b7d7862ff91457966b7f14ce92bf15655766cd
	* configure.ac (GCRYPT_PUBKEY_CIPHERS): It's kyber.lo.
	* tests/Makefile.am (tests_bin): [USE_KYBER]: Add t-mlkem only when
	USE_KYBER.
	* tests/t-kem.c: Allow building with no Kyber.

	tests: Add a test for Dilithium.
	+ commit 95beae48241222336c5060a5969adb9b14afe25e
	* tests/Makefile.am (tests_bin) [USE_DILITHIUM]: Add t-mldsa.
	(EXTRA_DIST): Add t-mldsa.inp.
	* tests/t-mldsa.c: New.
	* tests/t-mldsa.inp: New.

	cipher:dilithium: Support "no-prefix" flag for Dilithium testing.
	+ commit 0a1fda8ce4d0111bd33049d87653985b5ef99b6f
	* src/cipher.h (PUBKEY_FLAG_NO_PREFIX): New.
	* cipher/pubkey-dilithium.c (mldsa_sign, mldsa_verify): Support
	PUBKEY_FLAG_NO_PREFIX.
	* cipher/pubkey-util.c (_gcry_pk_util_parse_flaglist): Support
	PUBKEY_FLAG_NO_PREFIX.

	cipher:dilithium: Add ML-DSA into libgcrypt pubkey interface.
	+ commit 40c84d8a4c764631e50384d7d2a1898a88fe3c4f
	* configure.ac (available_pubkey_ciphers): Add dilithium.
	(USE_DILITHIUM): New.
	* cipher/Makefile.am (EXTRA_libcipher_la_SOURCES): Add
	pubkey-dilithium.c.
	* cipher/pubkey-dilithium.c: New.
	* cipher/pubkey.c (pubkey_list): Add _gcry_pubkey_spec_mldsa.
	* src/cipher.h (_gcry_pubkey_spec_mldsa): New.
	* src/gcrypt-int.h (enum gcry_mldsa_algos): New.
	* src/gcrypt.h.in (GCRY_PK_MLDSA): New.

	cipher:dilithium: Add dilithium functions for libgcrypt internal use.
	+ commit 81a8332963e2a5581ee0e7d0393363e8b9015bbf
	* cipher/dilithium.c (dilithium_keypair, dilithium_sign)
	(dilithium_verify): New.
	* cipher/dilithium.h: Likewise.

2025-07-01  NIIBE Yutaka  <gniibe@fsij.org>

	cipher:dilithium: List the dilithium implementation to Makefile.am.
	+ commit bef89f9316c8f37c4806f757e9f38fc478fcc8db
	* cipher/Makefile.am (EXTRA_DIST): Add dilithium-common.c and
	dilithium-dep.c.
	(EXTRA_libcipher_la_SOURCES): Add dilithium.c and dilithium.h.

	cipher:dilithium: Don't include unused freeze function.
	+ commit aeb775adfafd4520b1d67c5fc58f1e4c50ee174d
	* cipher/dilithium-common.c (freeze): Remove.
	* cipher/dilithium.c (freeze): Remove.

	cipher:dilithium: Have cipher/dilithium.h.
	+ commit cce9c02988c25f98b3097310963586bd3033f224
	* cipher/dilithium.h: New.
	* cipher/dilithium-common.c: Add static qualifier to functions.
	* cipher/dilithium-dep.c: Move function delclarations from
	dilithium.c and add undef-s.
	* cipher/dilithium.c: Support use of DILITHIUM_MODE.

	cipher:dilithium: Add DILITHIUM_INTERNAL_API_ONLY.
	+ commit f78099b5a022b417aeea324ff94fdd2a1e5bf5b9
	* cipher/dilithium-dep.c (crypto_sign_keypair_internal): New.
	(crypto_sign_signature) [DILITHIUM_INTERNAL_API_ONLY]: Don't define.
	(crypto_sign) [DILITHIUM_INTERNAL_API_ONLY]: Don't define.
	(crypto_sign_verify) [DILITHIUM_INTERNAL_API_ONLY]: Don't define.
	(crypto_sign_open) [DILITHIUM_INTERNAL_API_ONLY]: Don't define.
	* cipher/dilithium.c: Define DILITHIUM_INTERNAL_API_ONLY for use
	within libgcrypt.

	cipher:dilithium: For _GCRYPT_IN_LIBGCRYPT, add *_close function.
	+ commit 92f129fb9ddc7b076a1942983f593869264ea8d5
	* cipher/dilithium-common.c (poly_uniform): Add stream128_close.
	(poly_uniform_eta_2, poly_uniform_eta_4): Add stream256_close.
	(poly_uniform_gamma1_17, poly_uniform_gamma1_19): Likewise.
	* cipher/dilithium-dep.c (poly_challenge): Add shake256_close.
	(crypto_sign_signature_internal): Likewise.
	(crypto_sign_verify_internal): Likewise.
	* cipher/dilithium.c [_GCRYPT_IN_LIBGCRYPT]: Add glue code
	for shake128_* and shake256_*.

	cipher:dilithium: Functions of poly for different DILITHIUM_MODE.
	+ commit 28fb2e30790b07882b7ac2f5ccacd09e4e70de9c
	* cipher/dilithium-common.c (decompose): Make it into...
	(decompose_88, decompose_32): ... these two functions.
	(make_hint): Make it into...
	(make_hint_88, make_hint_32): ... these two functions.
	(use_hint): Make it into...
	(use_hint_88, use_hint_32): ... these two functions.
	(poly_decompose): Make it into...
	(poly_decompose_88, poly_decompose_32): ... these two functions.
	(poly_make_hint): Make it into...
	(poly_make_hint_88, poly_make_hint_32): ... these two functions.
	(poly_use_hint): Make it into...
	(poly_use_hint_88, poly_use_hint_32): ... these two functions.
	(rej_eta): Make it into...
	(rej_eta_2, rej_eta_4): ... these two functions.
	(poly_uniform_eta): Make it into...
	(poly_uniform_eta_2, poly_uniform_eta_4): ... these two functions.
	(POLY_UNIFORM_ETA_NBLOCKS): Make it into...
	(POLY_UNIFORM_ETA_NBLOCKS_2, POLY_UNIFORM_ETA_NBLOCKS_4): ... these
	two macros.
	(poly_uniform_gamma1): Make it into...
	(poly_uniform_gamma1_17, poly_uniform_gamma1_19): ... these two
	functions.
	(POLY_UNIFORM_GAMMA1_NBLOCKS): Make it into...
	(POLY_UNIFORM_GAMMA1_NBLOCKS_17, POLY_UNIFORM_GAMMA1_NBLOCKS_19):
	... these two macros.
	(polyeta_pack): Make it into...
	(polyeta_pack_2, polyeta_pack_4): ... these two functions.
	(polyeta_unpack): Make it into...
	(polyeta_unpack_2, polyeta_unpack_4): ... these two functions.
	(polyz_pack): Make it into...
	(polyz_pack_17, polyz_pack_19): ... these two functions.
	(polyz_unpack): Make it into...
	(polyz_unpack_17, polyz_unpack_19): ... these two functions.
	(polyw1_pack): Make it into...
	(polyw1_pack_88, polyw1_pack_32): ... these two functions.

	cipher:dilithium: Fix comment style.
	+ commit a0bd76300f606c9b2d9a5720ed4643f89e90db8b
	* cipher/dilithium.c: Fix comments.

	cipher:dilithium: Make the implementation into three files.
	+ commit 5cbf3180533dd84fb74c32e22e2f8fcecab90532
	* cipher/dilithium-common.c: New.  Common part.
	* cipher/dilithium-dep.c: New.  DILITHIUM_MODE dependent part.
	* cipher/dilithium.c: Move functions and variables to two files.

	cipher:dilithium: Export the external API only.
	+ commit cc7d750be1c71c05f5e9fa0439edbc6dabff4410
	* cipher/dilithium.c: Don't export other functions.

2025-06-28  NIIBE Yutaka  <gniibe@fsij.org>

	cipher: Editorial clean up cipher/dilithium.c for headers.
	+ commit cb15a5563ade6828312311682ddbdc0e5ae1eb6e
	* cipher/dilithium.c: Clean up.

	cipher: Add headers to the Dilithium implementation.
	+ commit a7fdda036591dd9022e58b6613e25b23c8d9a50f
	* cipher/dilithium.c: Add headers from the reference implementation.

	cipher: Put the original Dilithium implementation.
	+ commit 1b422366e2b3b5438713418b50f8a0a1abf8d365
	* cipher/dilithium.c: Add the Dilithium reference implementation into
	one file.

2025-06-26  NIIBE Yutaka  <gniibe@fsij.org>

	tests:common: Increse buffer size to allow input for PQC testing.
	+ commit b945002e44ce79227599e723fc1faa961494062b
	* tests/t-common.h (read_textline): Increase the buffer size.

2025-06-25  NIIBE Yutaka  <gniibe@fsij.org>

	cipher:kem:ecc: Support secp256k1 by KEM API.
	+ commit 10c0ce88ba3fbba6b04ee6ded9d0f6ae15171d6b
	* src/gcrypt.h.in (GCRY_KEM_RAW_P256K1): New.
	* cipher/kem-ecc.c (algo_to_curve, algo_to_seckey_len): Support
	GCRY_KEM_RAW_P256K1.

2025-06-24  NIIBE Yutaka  <gniibe@fsij.org>

	cipher: Support random-override with PUBKEY_FLAG_BYTE_STRING.
	+ commit cbefff5fcaa66dbd6ee652a9a5bc376b86d44d30
	* cipher/pubkey-util.c (_gcry_pk_util_init_encoding_ctx): Initialize
	RND and RNDLEN field.
	(_gcry_pk_util_free_encoding_ctx): Release memory by RND field.
	(_gcry_pk_util_data_to_mpi): Support optional "random-override".
	* src/cipher.h (struct pk_encoding_ctx): Add RND and RNDLEN.

	cipher: Add PUBKEY_FLAG_BYTE_STRING to support byte string data.
	+ commit 3bb4a54f43876a169ce16b62bd73742374370db4
	* cipher/pubkey-util.c (_gcry_pk_util_data_to_mpi): Add support for
	PUBKEY_FLAG_BYTE_STRING.
	* src/cipher.h (PUBKEY_FLAG_BYTE_STRING): New.

2025-05-19  Collin Funk  <collin.funk1@gmail.com>

	Fix missing simd-common-riscv.h in libgcrypt tarball.
	+ commit b100dd25eb6821d58851c2b802bfe9ef2f441228
	* cipher/Makefile.am (EXTRA_libcipher_la_SOURCES): Add
	simd-common-riscv.h.

2025-05-13  NIIBE Yutaka  <gniibe@fsij.org>

	mpi:ec: Least leak with k^(-1) for ECDSA.
	+ commit 0bd4c77be6e04f5c8734926234742c3a2bb8fb18
	* src/mpi.h (_gcry_mpi_assign_limb_space): Add.
	(_gcry_mpih_mod_lli, _gcry_mpih_mul_lli): Add.
	* cipher/ecc-ecdsa.c (_gcry_ecc_ecdsa_sign): Take care
	about least leak with k^(-1).

	mpi:ec: Use ec_mulm_lli in _gcry_mpi_ec_get_affine.
	+ commit aa089ec89badcd74817e5008c66036b1e28674f5
	* mpi/ec.c (_gcry_mpi_ec_get_affine): Fix for possible leak.

2025-05-12  Paul Eggert  <eggert@cs.ucla.edu>

	Fix ungrammatical use of "allow to"
	+ commit 93034d649124841a962e6e832afe4675d99abb7a


2025-05-12  Collin Funk via Gcrypt-devel  <gcrypt-devel@gnupg.org>

	Remove occurrences of old FSF postal address.
	+ commit 67b8da4ef62734927e061327efa9a6f48616d114
	* COPYING: Update to latest from Gnulib.
	* COPYING.LIB: Likewise.
	* doc/gpl.texi: Likewise.
	* doc/lgpl.texi: Likewise.
	* cipher/scrypt.c: Link to gnu.org instead of mentioning the old FSF
	address.

2025-05-03  Collin Funk  <collin.funk1@gmail.com>

	tests: Fix link errors for t-thread-local.
	+ commit 793eda7b258a562757b51c96044b103b638f1a63
	On platforms where pthread_create is not in libc t-thread-local fails to
	link.  Issue found on NetBSD 10.0.
	* tests/Makefile.am (t_thread_local_LDADD): Add $(standard_ldadd),
	$(GPG_ERROR_MT_LIBS), and @LDADD_FOR_TESTS_KLUDGE@.
	(t_thread_local_CFLAGS): Add $(GPG_ERROR_MT_CFLAGS).

	cipher:aria: Fix compiler error on NetBSD.
	+ commit df684aca7407a4179771d79b5ef04ef8e4bedcc6
	* cipher/aria.c (bswap32): Remove function that conflicts with system
	definitions on NetBSD.
	(aria_diff_byte): Use _gcry_bswap32.

2025-04-21  NIIBE Yutaka  <gniibe@fsij.org>

	Mark nonstring use cases with __nonstring__ attribute.
	+ commit d5fb7cd9b3512ef5326638bb8930583fad127882
	* src/gcrypt.h.in (_GCRY_GCC_ATTR_NONSTRING): New.
	* cipher/chacha20.c (chacha20_keysetup): Use _GCRY_GCC_ATTR_NONSTRING.
	* cipher/cipher-gcm-siv.c (gcm_siv_selftest): Likewise.
	* cipher/ecc.c (compute_keygrip): Likewise.
	* cipher/serpent.c (serpent_test): Likewise.
	* tests/basic.c (check_aes128_cbc_cts_cipher): Likewise.
	(_check_gcm_cipher, check_gcm_siv_cipher): Likewise.
	(check_ocb_cipher_largebuf_split, check_ocb_cipher_checksum): Likewise.
	* tests/keygrip.c (key_grips): Likewise.

2025-04-08  NIIBE Yutaka  <gniibe@fsij.org>

	mpi:ec: Set GCRYECC_FLAG_LEAST_LEAK, calling mpi_ec_mul_point_lli.
	+ commit 32f848ef9dca726a0bfe1b895b93880522938aab
	* mpi/ec.c (_gcry_mpi_ec_mul_point): Enable GCRYECC_FLAG_LEAST_LEAK
	when calling mpi_ec_mul_point_lli.

2025-04-07  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	mpi/ec-nist: fix NIST-P224 failing on 32-bit architectures.
	+ commit e34aa59b014eba6fd56d789e1b066c050f1e149a
	* mpi/ec-nist.c (_gcry_mpi_ec_nist224_mod): Set output size
	based on bit per limb.

2025-03-28  NIIBE Yutaka  <gniibe@fsij.org>

	mpi:ec: Introduce ec_*_lli for Weierstrass curves to be less leaky.
	+ commit d1c471c78d6f045a2ec53fd7bdc10308b6305096
	* mpi/ec.c (ec_addm_lli, ec_subm_lli, ec_mulm_lli): New.
	(dup_point_weierstrass_lli): New, using ec_*_lli.
	(add_points_weierstrass_a): Use ec_*_lli.
	(mpi_ec_mul_point_lli): Use dup_point_weierstrass_lli.
	Remove mpi_point_resize.

	mpi:ec: Don't normalize the MPIs when GCRYECC_FLAG_LEAST_LEAK.
	+ commit 4f56fd8c5e03f389a9f27a5e9206b9dfb49c92e3
	* mpi/ec-nist.c (_gcry_mpi_ec_nist192_mod): Don't do MPN_NORMALIZE
	when GCRYECC_FLAG_LEAST_LEAK.
	(_gcry_mpi_ec_nist224_mod): Likewise.
	(_gcry_mpi_ec_nist256_mod): Likewise.
	(_gcry_mpi_ec_nist384_mod): Likewise.
	(_gcry_mpi_ec_nist521_mod): Likewise.
	* mpi/ec.c (ec_mod): Keep ->NLIMBS when GCRYECC_FLAG_LEAST_LEAK.

	mpi:ec: Use affine coordinate for mpi_ec_mul_point_lli.
	+ commit 0680408b37515db8437e18d6d2a1e973155b6565
	* mpi/ec.c (add_points_weierstrass_a, add_points_edwards_a): New.
	(mpi_ec_mul_point_lli): Use those routines directly.

2025-03-27  NIIBE Yutaka  <gniibe@fsij.org>

	mpi:ec: Resize when GCRYECC_FLAG_LEAST_LEAK.
	+ commit 794b8e7378e84c344a0629af61b1154f8830aca4
	* mpi/ec.c (ec_p_init): Also resize when GCRYECC_FLAG_LEAST_LEAK.

	cipher:ecc: Introduce GCRYECC_FLAG_LEAST_LEAK.
	+ commit 6419bd17f034bb7dad17bbd6c1f90c4c28cc4348
	* src/cipher.h (GCRYECC_FLAG_LEAST_LEAK): New.
	* cipher/ecc.c (ecc_generate): Use GCRYECC_FLAG_LEAST_LEAK.
	(ecc_check_secret_key, ecc_sign, ecc_decrypt_raw): Likewise.

	mpi:ec: Refactor _gcry_mpi_ec_mul_point.
	+ commit 5e3dbfb8233d5849e5031c527aefed1ff460089c
	* mpi/ec.c (montgomery_mul_point, mpi_ec_mul_point_lli): Factor out
	from _gcry_mpi_ec_mul_point.
	(_gcry_mpi_ec_mul_point): Use montgomery_mul_point and
	mpi_ec_mul_point_lli.

	mpi:ec: Keep A untouched in ec_get_a_is_pminus3.
	+ commit d698ed5386e8e3be43296e77938f513261523503
	* mpi/ec.c (ec_get_a_is_pminus3): Change the calculation
	so that it keeps the MPI of A untouched.

	mpi:ec: Use ec_addm for ec_mul2.
	+ commit 38cdb7fecc80c7f834bdd4fdc77e37f73ca8149f
	* mpi/ec.c (ec_mul2): Use ec_addm.

	mpi:ec: Remove runtime check in ec_mod.
	+ commit 16c6936c811a3af4c53ddd9526eac61569c436d0
	* mpi/ec-inline.h (mpi_nbits_more_than): Remove.
	* mpi/ec-nist.c (_gcry_mpi_ec_nist192_mod): Remove
	runtime check for the size of W.
	(_gcry_mpi_ec_nist224_mod): Likewise.
	(_gcry_mpi_ec_nist256_mod): Likewise.
	(_gcry_mpi_ec_nist384_mod): Likewise.
	(_gcry_mpi_ec_nist521_mod): Likewise.
	(ec_secp256k1_mod): Likewise.

2025-03-23  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	t-mpi-point: fix test failing in FIPS mode.
	+ commit 058c2fab9aa8e0fda62f29ad0bbe253313d5c810
	* tests/t-mpi-point.c (point_on_curve): Skip non-NIST test-vectors
	in FIPS mode.

2025-03-21  NIIBE Yutaka  <gniibe@fsij.org>

	mpi:ec: Use ec_addm to multiply with small integer.
	+ commit 17d5d3262c148cf6b1e1040052984bca7169b064
	* mpi/ec.c (dup_point_weierstrass): Use ec_addm instead of ec_mulm for
	small integer.

	mpi:ec: Use mpi_set_ui in _gcry_mpi_ec_mul_point.
	+ commit 191c2340c4a6cdb35208d4cf78f4a399bcf2af8f
	* mpi/ec.c (_gcry_mpi_ec_mul_point): mpi_set_ui to initialize 1.

	mpi:ec: Avoid use mpi_const.
	+ commit 522566b15a31a5352bb1605d3e4622e770cb7e59
	* mpi/ec.c (_gcry_mpi_ec_mul_point): Use mpi_mul_ui.
	(_gcry_mpi_ec_curve_point): Use mpi_mul_ui and mpi_add_ui.
	Don't use mpi_const.
	* tests/t-mpi-point.c (point_on_curve): Add Curve25519.

	mpi:ec: Don't use mpi_powm for small exponent.
	+ commit 5052efed9f540add726bf604fbf70ee6a608b101
	* mpi/ec.c (ec_pow3): Remove.
	(_gcry_mpi_ec_curve_point): Don't use ec_pow3.
	(dup_point_weierstrass): Use ec_pow2 twice for Z^4.
	(add_points_weierstrass): Don't use ec_powm.

	mpi:ec: Remove the minor optimization for the case of Z==1.
	+ commit 53993003db9b9e90b518318ddb3bc67e61aa2735
	* mpi/ec.c (add_points_weierstrass): Always multiply with Z^2.

2025-03-13  NIIBE Yutaka  <gniibe@fsij.org>

	doc: Add about GCRYCTL_FIPS_SERVICE_INDICATOR.
	+ commit 636f40cb78587635ef663bfc3430937cf140f245
	* doc/gcrypt.texi (GCRYCTL_FIPS_SERVICE_INDICATOR): Add a description.
	(GCRYCTL_FIPS_REJECT_NON_FIPS): Likewise.

	fips: Fix GCRY_FIPS_FLAG_REJECT_MD.
	+ commit b9eb8f4cb81801d68580627ad2188607a8c5f2ec
	* src/gcrypt.h.in (GCRY_FIPS_FLAG_REJECT_MD): Include SHA1.

2025-03-11  NIIBE Yutaka  <gniibe@fsij.org>
	    Lucas Mulling  <lucas.mulling@suse.com>

	md: Make SHA-1 non-FIPS internally for 1.12 API.
	+ commit 4ee91a94bcdad32aed4364d09e3daf8841fa579f
	* src/gcrypt.h.in (GCRY_FIPS_FLAG_REJECT_MD_SHA1): New.
	* cipher/md.c (check_digest_algo_spec, _gcry_md_open, md_enable)
	(_gcry_md_enable, md_copy): Care about SHA1.
	* cipher/sha1.c (_gcry_digest_spec_sha1): Make SHA1 non-FIPS.
	* tests/t-fips-service-ind.c (check_mac_o_w_r_c): SHA1 is non-FIPS.
	(check_md_o_w_r_c, check_hash_buffer, check_hash_buffers): Likewise.
	(main): Add GCRY_FIPS_FLAG_REJECT_MD_SHA1 for gcry_control.

2025-03-06  NIIBE Yutaka  <gniibe@fsij.org>

	mpi: Use const-time modular exponentiation on 64-bit arch.
	+ commit 71d17c0b4c01728aec2b587a85a60354ba67f354
	* mpi/mpi-pow.c (USE_ALGORITHM_LLI_EXPONENTIATION): Enable on 64-bit.
	* src/global.c (print_config): Fix to "mpi-powm".

	cipher,fips: Fix for random-override.
	+ commit ca8bf05e111b41e482a2a4b34cda6bcf5aa1f27e
	* cipher/pubkey-util.c (gcry_pk_util_data_to_mpi): Keep
	the behavior of 1.10.
	* src/visibility.c (gcry_pk_random_override_new): Likewise.
	* tests/t-fips-service-ind.c (main): Use GCRY_FIPS_FLAG_REJECT_PK_FLAGS.

2025-03-06  Lucas Mulling via Gcrypt-devel  <gcrypt-devel@gnupg.org>

	cipher,visibility: Differentiate use of random-override in the SLI.
	+ commit 234eb316b0a04c50e8511a570775ded45060f18b
	* cipher/pubkey-util.c (_gcry_pk_util_data_to_mpi,
	_gcry_pk_single_data_push, _gcry_pk_util_free_encoding_ctx):
	Differentiate use of random-override in the SLI.
	* src/visibility.c (gcry_pk_random_override_new):
	Differentiate use explicit random override in the SLI.

2025-03-06  NIIBE Yutaka  <gniibe@fsij.org>

	cipher,ecc: Fix for supplied K.
	+ commit 755e6dce727915249cbb1a98f22832d940b99c24
	* cipher/ecc.c (ecc_sign): Check if it's under FIPS mode.
	(ecc_verify): Supplied K does no sense for verification, but add
	comment of clarification mark/reject-ing under FIPS mode.

	fips,cipher: Add GCRY_FIPS_FLAG_REJECT_PK_FLAGS.
	+ commit 0414e126b939f0b11ecf441908d923e87c1caf02
	* src/gcrypt.h.in (GCRY_FIPS_FLAG_REJECT_PK_FLAGS): New.
	* cipher/pubkey-util.c (_gcry_pk_util_parse_flaglist): Keep the
	behavior of 1.10.
	* cipher/rsa.c (rsa_decrypt, rsa_sign): Likewise.

2025-03-05  Lucas Mulling via Gcrypt-devel  <gcrypt-devel@gnupg.org>

	cipher: Differentiate no-blinding flag in the SLI.
	+ commit cc0a40bd74120dc06fd80f163b30abb91f60b63b
	* cipher/rsa.c (rsa_decrypt, rsa_encrypt): Differentiate use of flag
	no-blinding in the service level indicator.

	cipher: Differentiate igninvflag in the SLI.
	+ commit 3bdb59c21b77711cf7d44d692a7a02f5f469033e
	* cipher/pubkey-util.c (_gcry_pk_util_parse_flaglist): Differentiate use
	of igninvflag.

2025-03-04  Lucas Mulling via Gcrypt-devel  <gcrypt-devel@gnupg.org>

	cipher: Differentiate use of label K in the SLI.
	+ commit 2f6d2db1a4c28775a568c1f81ca127d2daebaf1c
	* cipher/ecc.c (ecc_sign, ecc_verify): Use of label K is not allowed in
	fips mode, differentiate with the GCRY_FIPS_FLAG_REJECT_PK_ECC_K flag.
	* src/gcrypt.h.in: New GCRY_FIPS_FLAG_REJECT_PK_ECC_K.
	* tests/t-fips-service-ind.c (check_pk_hash_sign_verify): Mark non
	compliant use of label.

	cipher: Add KAT for non-rfc6979 ECDSA with fixed k.
	+ commit be57179f42f8a7cb64f72f73ccea753400573b4f
	* cipher/ecc.c (run_selftests): Implement KAT for non-deterministic
	ECDSA.
	* cipher/ecc. (rfc6979_ecdsa_sample_data, rfc6979_ecdsa_sample_data_bad,
	rfc6979_ecdsa_data_tmpl): New.

2025-03-04  NIIBE Yutaka  <gniibe@fsij.org>

	tests: Allow tests with !USE_RSA.
	+ commit 8404a048b7c58eb903717e09cffaa7735f7d8520
	* tests/t-fips-service-ind.c [USE_RSA] (check_pk_s_v): Ifdef-out.

	fips,cipher: Do the computation when marking non-compliant.
	+ commit 54a6617b3679cfeb6d986ddf3c9c73641929f02c
	* cipher/ecc-ecdsa.c (_gcry_ecc_ecdsa_sign): Continue the computation
	when marking non-compliant.
	* cipher/pubkey.c (_gcry_pk_encrypt, _gcry_pk_sign): Likewise.
	(_gcry_pk_sign_md, _gcry_pk_verify, _gcry_pk_verify_md): Likewise.
	(_gcry_pk_testkey): Likewise.

2025-02-26  NIIBE Yutaka  <gniibe@fsij.org>

	tests: Update t-fips-service-ind using GCRY_MD_SHA256 for KDF tests.
	+ commit e5989e08a556117ec3f19f098765963358b71051
	* tests/t-fips-service-ind.c (check_kdf_derive): Use GCRY_MD_SHA256.

	md: Use check_digest_algo_spec in _gcry_md_selftest.
	+ commit ce4755d5c5500cede6d7d380fdab2d15f5d77796
	* cipher/md.c (check_digest_algo_spec): New.
	(check_digest_algo): Use check_digest_algo_spec.
	(_gcry_md_selftest): Likewise.

	md: Fix gcry_md_algo_info to mark/reject under FIPS mode.
	+ commit 2f17a98a80b155e750ab77d4703e33612e545d58
	* cipher/md.c (check_digest_algo): Fix for marking non-compliance.
	* src/visibility.c (gcry_md_algo_info): Add check with
	fips_is_operational.

2025-02-25  NIIBE Yutaka  <gniibe@fsij.org>

	cipher:rsa: Mark/reject SHA1/unknown with RSA signature generation.
	+ commit 60e5039793c2474d29ded039cf1a6b8107733a20
	* cipher/rsa-common.c (_gcry_rsa_pkcs1_encode_raw_for_sig): We can't
	determine if it's compliant when raw PKCS1 encoding is used.
	(_gcry_rsa_pss_encode): Add the behavior of marking non-compliant use.
	(_gcry_rsa_pss_verify): Likewise.
	* cipher/rsa.c (rsa_sign): Handle the check for SHA1.
	(rsa_verify): Likewise.
	* tests/t-fips-service-ind.c (check_pk_s_v): Add use cases for RSA
	and Ed25519.

	Revert "md: Make SHA1 non-FIPS and differentiate in the SLI"
	+ commit 1e815a00c302921adb9b41b372a8f6f908e23620
	This reverts commit 13a71215c255377863b0154ac602c86fe5450c49.

	cipher:(EC)DSA: Simply use mpi_clear_highbit in _gcry_dsa_gen_k.
	+ commit 54caef02afa90ad43d70f5772cd5550bb2055555
	* cipher/dsa-common.c (_gcry_dsa_gen_k): Use mpi_clear_highbit.

	mpi: Avoid normalizing MPI in _gcry_mpi_invm.
	+ commit c1da86e45a6e9c462cdb511c4c9c7fd375da1303
	* mpi/mpi-inv.c (_gcry_mpi_invm): Use _gcry_mpih_cmp_ui.

2025-02-20  NIIBE Yutaka  <gniibe@fsij.org>

	cipher,mpi: Expose some MPI helper functions by mpi.h.
	+ commit 88ae76d069c331ad947ecab8419df9a00f979b0e
	* cipher/dsa-common.c: Don't include mpi-internal.h.
	* mpi/mpi-inline.h (_gcry_mpih_add_lli): Move this to ...
	* src/mpi.h (_gcry_mpih_add_lli): ... here.
	(_gcry_mpih_rshift, _gcry_mpih_add_n_cond): Add.
	(_gcry_mpih_cmp_ui, _gcry_mpih_cmp_lli): Add.
	(_gcry_mpih_add_n): Add.
	* mpi/mpi-internal.h (_gcry_mpih_cmp_ui, _gcry_mpih_cmp_lli): Remove.

2025-02-19  NIIBE Yutaka  <gniibe@fsij.org>

	mpi: Fix _gcry_mpih_add_lli, as macro.
	+ commit bd53c51b03383ade2b63132d0034a75ab526c546
	* mpi/mpi-inline.h (_gcry_mpih_add_lli): Use _gcry_mpih_add_n.
	* mpi/mpi-internal.h (_gcry_mpih_add_lli): Remove.
	* mpi/mpih-const-time.c (_gcry_mpih_add_lli): Remove.

2025-02-18  NIIBE Yutaka  <gniibe@fsij.org>

	mpi: Add MPI helper modular exponentiation, Least Leak Intended.
	+ commit 2039d93289dbc1a90089466390777c756660ba5a
	* mpi/Makefile.am (libmpi_la_SOURCES): Add mpih-pow.c.
	* mpi/mpi-internal.h (_gcry_mpih_powm_lli): New.
	* mpi/mpi-pow.c (_gcry_mpi_get_powm_config): New.
	(USE_ALGORITHM_LLI_EXPONENTIATION): New, enabled as default.
	[USE_ALGORITHM_LLI_EXPONENTIATION] (_gcry_mpi_powm): Call
	_gcry_mpih_powm_lli when it's on secure memory.
	* mpi/mpih-pow.c (_gcry_mpih_powm_lli): New.
	* src/gcrypt-int.h (_gcry_mpi_get_powm_config): New.
	* src/global.c (print_config): Call _gcry_mpi_get_powm_config.

	mpi: Add MPH helper of table lookup, Least Leak Intended.
	+ commit 8fd2aab881c733a29c26459ed1d1d7f234728314
	* mpi/mpi-internal.h (ct_limb_select): New.
	(_gcry_mpih_lookup_lli): New.
	* mpi/mpih-const-time.c (_gcry_mpih_lookup_lli): New.

	cipher:(EC)DSA: Fix _gcry_dsa_gen_*k not to normalize MPI.
	+ commit bb5e893456b10c8a4fa336a281bf3008c0f9eb5e
	* cipher/dsa-common.c (_gcry_dsa_gen_k): Use _gcry_mpih_cmp_lli
	and _gcry_mpih_cmp_ui.
	(_gcry_dsa_gen_rfc6979_k): Likewise.

	cipher:(EC)DSA: Avoid MPI normalize by mpi_rshift.
	+ commit 0b794c208db39d959f8f532bc9920daefa853d2a
	* cipher/dsa-common.c (_gcry_dsa_gen_rfc6979_k): Use
	_gcry_mpi_set_buffer and _gcry_mpih_rshift, instead of _gcry_mpi_scan
	and mpi_rshift.

	cipher:(EC)DSA: Fix _gcry_dsa_modify_k to least leak.
	+ commit d05cdb31689a45733751393a819a71c7c3386675
	* cipher/dsa-common.c (_gcry_dsa_modify_k): Use _gcry_mpih_add_lli.

2025-02-17  NIIBE Yutaka  <gniibe@fsij.org>

	mpi: Add _gcry_mpih_add_lli.
	+ commit 58e72af4eac4711993191919b6890b5ebb554acc
	* mpi/mpi-internal.h (_gcry_mpih_add_lli): New.
	* mpi/mpih-const-time.c (_gcry_mpih_add_lli): New.

2025-02-17  NIIBE Yutaka  <gniibe@fsij.org>
	    Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	mpi: Add _gcry_mpih_cmp_lli, Least Leak Intended.
	+ commit 459a6c9c81ee28ddf5baa9fe47f3138fd34334d5
	* mpi/mpi-internal.h (_gcry_mpih_cmp_lli): New.
	* mpi/mpih-const-time.c (_gcry_mpih_cmp_lli): New.

	mpi: Add _gcry_mpih_add_1_lli as Least Leak Intended.
	+ commit 06de5bc277532d1ef42b81464af81d2a22b90ad4
	* mpi/mpi-inline.h (_gcry_mpih_add_1_lli): New.

2025-02-14  Lucas Mulling  <lucas.mulling@suse.com>

	md: Make SHA1 non-FIPS and differentiate in the SLI.
	+ commit 13a71215c255377863b0154ac602c86fe5450c49
	* cipher/md.c (_gcry_md_open, md_enable, _gcry_md_enable, md_copy):
	Differentiate SHA1.
	* cipher/sha1.c (_gcry_digest_spec_sha1): Make SHA1 not FIPS.
	* src/fips.c (_gcry_fips_indicator_mac, _gcry_fips_indicator_md,
	run_digest_selftests, run_mac_selftests): Differentiate SHA1.
	* src/gcrypt.h.in (GCRY_FIPS_FLAG_REJECT_MD_SHA1): New.
	* tests/basic.c: (check_pubkey_sign): Use sha256 for baddata, add
	FLAG_NOFIPS to non FIPS compliant tests that use SHA1, and improve error
	messages.
	* tests/pkcs1v2.c (main): Skip tests in FIPS mode.
	* tests/t-fips-service-ind.c (check_kdf_derive): Use sha256 as pbkdf2
	subalgo.
	* tests/t-fips-service-ind.c (check_mac_o_w_r_c): Check for rejection of
	SHA1 test cases if in FIPS mode.

2025-02-13  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	mpih-const-time: fix return value for _gcry_mpih_cmp_ui.
	+ commit 957ac97097d0960a621ea1ea9f751b422afa8949
	* mpi/mpih-const-time.c (_gcry_mpih_cmp_ui): Return '1' when
	upper part of MPI is not all zeros.
	* tests/mpitests.c (test_invm_cmpui, test_invm): Add tests
	for gcry_mpi_invm().

2025-02-12  Lucas Mulling  <lucas.mulling@suse.com>

	cipher: Don't differentiate GCRY_CIPHER_MODE_CMAC in FIPS mode.
	+ commit 608ff4b2261e2d8961f0ef4189e74b1173b2802c
	* cipher/cipher.c (_gcry_cipher_mode_fips_compliance): Allow
	GCRY_CIPHER_MODE_CMAC in fips mode.
	* cipher/cipher.c (cipher_modes_fips_compliance)
	(cipher_int_modes_fips_compliance): New.

	cipher: Rename _gcry_cipher_is_mode_fips_compliant.
	+ commit 6b0fbb7e5e0da77787e3a87d74359ee21c44904e
	* cipher/cipher.c (_gcry_cipher_is_mode_fips_compliant): Rename to
	_gcry_cipher_mode_fips_compliance for better clarity and change the
	return type to gcry_err_code_t.
	* cipher/cipher.c (_gcry_cipher_mode_fips_compliance): Use
	gcry_cipher_modes instead of int for mode.
	* tests/t-fips-service-ind.c (check_cipher_o_s_e_d_c): Fix typo in fail.

2025-02-11  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	mpi/longlong: prevent optimization of carry instructions to branches.
	+ commit dd480b1e797463f71a7e69e9509833ff7a923bd6
	* mpi/longlong.h: Include "const-time.h"
	(add_ssaaaa, sub_ddmmss): Prevent optimization of carry handling to
	conditional branches in generic variant of double width addition and
	subtraction as was seen with GCC on riscv64.
	(umul_ppmm): Avoid conditional branch in generic 16x16=>32bit
	multiplication version of umul_ppmm.
	* src/const-time.h (CT_DEOPTIMIZE_VAR): New.

	mpih-const-time: avoid branches in _gcry_mpih_cmp_ui.
	+ commit 9c658cc8214f277d43b18d722bbc316972802d47
	* mpi/mpih-const-time.c (_gcry_mpih_cmp_ui): Avoid conditional
	branches for return value selection.

2025-02-06  NIIBE Yutaka  <gniibe@fsij.org>

	Fix _gcry_dsa_modify_k.
	+ commit 35a6a6feb9dcd0f4650a0fe73eb2581f481602c6
	* cipher/dsa-common.c (_gcry_dsa_modify_k): Don't use ! to negate the
	logical value.

2025-02-03  NIIBE Yutaka  <gniibe@fsij.org>

	mpi: Rename _gcry_mpih_mod as the one of Least Leak Intended.
	+ commit ff6c905bea7b2fb5526423ec9fba53f8d08f014b
	* mpi/mpi-internal.h (mpih_mod_lli): Add _lli suffix.
	(_gcry_mpih_mod_lli): Likewise.
	* mpi/mpih-const-time.c (_gcry_mpih_mod_lli): Rename.
	* mpi/mpi-inv.c (_gcry_mpi_invm): Follow the change.

	mpi: Add _gcry_mpih_mul_lli as Least Leak Intended.
	+ commit 5c5089ba36205ee5af0c83eec782eac68bf55d2e
	* mpi/mpi-internal.h (_gcry_mpih_mul_lli): New.
	* mpi/mpih-mul.c (_gcry_mpih_mul_lli): New.

2025-01-31  NIIBE Yutaka  <gniibe@fsij.org>

	cipher:prime: Fix long standing bug for PRIME % 2 == 0.
	+ commit 639b0fca15054f18c83fe3a6132a7765e558b984
	* cipher/primegen.c (check_prime): Check if it's even.

2025-01-27  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	Add SHA3 acceleration for RISC-V Zbb extension.
	+ commit 1a660068ba5b58861de2c71b119ae2b6b6db0263
	* cipher/keccak.c (USE_RISCV_ZBB): New.
	[NEED_COMMON64, HAVE_GCC_INLINE_ASM_RISCV] (load_aligned_u64)
	(HAVE_ALIGNED_ABSORB_LANES64, aligned_absorb_lanes64_8)
	(aligned_absorb_lanes64_4, aligned_absorb_lanes64_2)
	(aligned_absorb_lanes64_1, HAVE_ALIGNED_EXTRACT64)
	(aligned_extract64): New.
	[NEED_COMMON64] (keccak_extract64): Add 'aligned_extract64' path.
	[USE_64BIT] (absorb_lanes64_8, absorb_lanes64_4, absorb_lanes64_2)
	(absorb_lanes64_1): Rename these functions to …
	[USE_64BIT] (unaligned_absorb_lanes64_8, unaligned_absorb_lanes64_4)
	(unaligned_absorb_lanes64_2, unaligned_absorb_lanes64_1): … these.
	[USE_64BIT] (absorb_lanes64_21, absorb_lanes64_18, absorb_lanes64_17)
	(absorb_lanes64_13, absorb_lanes64_9): New.
	[USE_RISCV_ZBB]: (ANDN64, ROL64, keccak_riscv_zbb_64_ops): New.
	(keccak_init) [USE_RISCV_ZBB]: Use 'keccak_riscv_zbb_64_ops' if
	HWF_RISCV_IMAFDC and HWF_RISCV_ZBB available.
	* cipher/keccak_permute_64.h (KECCAK_F1600_ABSORB_FUNC_NAME): Use
	absorb_lanes64_21, absorb_lanes64_18, absorb_lanes64_17,
	absorb_lanes64_13 and absorb_lanes64_9.

	chacha20: add RISC-V vector intrinsics implementation.
	+ commit 8dbee93ac2f1bba095a0519a6e0656319cfddfa4
	* cipher/Makefile.am: Add 'chacha20-riscv-v.c' and
	add ENABLE_RISCV_VECTOR_INTRINSICS_EXTRA_CFLAGS handling for
	'chacha20-riscv-v.o' and 'chacha20-riscv-v.lo'.
	* cipher/chacha20-riscv-v.c: New.
	* cipher/chacha20.c (USE_RISCV_V): New.
	(CHACHA20_context_s): Add 'use_riscv_v'.
	[USE_RISCV_V] (_gcry_chacha20_riscv_v_blocks)
	(_gcry_chacha20_riscv_v_check_hw): New.
	(chacha20_blocks) [USE_RISCV_V]: Add RISC-V vector code path.
	(chacha20_do_setkey) [USE_RISCV_V]: Add HW feature detection for
	RISC-V vector implementation.
	* configure.ac: Add 'chacha20-riscv-v.lo'.

	Add GHASH RISC-V Zbb+Zbc implementation.
	+ commit 0f1fec12b0e9c952afaf78d3c973df41627cb3ff
	* cipher/Makefile.am: Add 'cipher-gcm-riscv-zbb-zbc.c'.
	* cipher/cipher-gcm-riscv-zbb-zbc.c: New.
	* cipher/cipher-gcm.c [GCM_USE_RISCV_ZBB_ZBC]
	(_gcry_ghash_setup_riscv_zbb_zbc, _gcry_ghash_riscv_zbb_zbc): New.
	(setupM) [GCM_USE_RISCV_ZBB_ZBC]: Check for HWF_RISCV_IMAFDC,
	HWF_RISCV_ZBB and HWF_RISCV_ZBC to enable RISC-V Zbb+Zbc implementation.
	* cipher/cipher-internal.h (GCM_USE_RISCV_ZBB_ZBC): New.
	* configure.ac: Add 'cipher-gcm-riscv-zbb-zbc.lo'.

	Add RISC-V vector permute AES.
	+ commit b24ebd61630486600530ebfc2cc81634a0fb373e
	* cipher/Makefile.am: Add 'rinjdael-vp-riscv.c' and
	CFLAG handling for 'rijndael-vp-riscv.o' and 'rijndael-vp-riscv.lo'.
	(ENABLE_RISCV_VECTOR_INTRINSICS_EXTRA_CFLAGS): New.
	* cipher/rijndael-internal.h (USE_VP_RISCV): New.
	* cipher/rijndael-vp-simd128.h [__ARM_NEON]: Move ARM NEON macros to ...
	* cipher/rijndael-vp-aarch64.c: ... here.
	* cipher/rijndael-vp-riscv.c: New.
	* cipher/rijndael-vp-simd128.h: Use '__m128i_const' type for constant
	vector values and use *_amemld() macros to load these values to vector
	registers.
	[__x86_64__] (vpaddd128, vpaddb128): Remove.
	[__x86_64__] (psrl_byte_128, movdqa128_memld, pand128_amemld)
	(paddq128_amemld, paddd128_amemld, pshufb128_amemld): New.
	[HAVE_SIMD256] (aes_encrypt_core_4blks_simd256)
	(aes_decrypt_core_4blks_simd256): New.
	(FUNC_CTR_ENC, FUNC_CTR32LE_ENC, FUNC_CFB_DEC, FUNC_CBC_DEC)
	(aes_simd128_ocb_enc, aes_simd128_ocb_dec, FUNC_OCB_AUTH)
	(aes_simd128_ecb_enc, aes_simd128_ecb_dec, aes_simd128_xts_enc)
	(aes_simd128_xts_dec) [HAVE_SIMD256]: Add 4 block parallel code paths
	for HW with 256-bit wide vectors.
	* cipher/rijndael.c [USE_VP_RISCV]
	(_gcry_aes_vp_riscv_setup_acceleration, _gcry_aes_vp_riscv_do_setkey)
	(_gcry_aes_vp_riscv_prepare_decryption, _gcry_aes_vp_riscv_encrypt)
	(_gcry_aes_vp_riscv_decrypt, _gcry_aes_vp_riscv_cfb_enc)
	(_gcry_aes_vp_riscv_cbc_enc, _gcry_aes_vp_riscv_ctr_enc)
	(_gcry_aes_vp_riscv_ctr32le_enc, _gcry_aes_vp_riscv_cfb_dec)
	(_gcry_aes_vp_riscv_cbc_dec, _gcry_aes_vp_riscv_ocb_crypt)
	(_gcry_aes_vp_riscv_ocb_auth, _gcry_aes_vp_riscv_ecb_crypt)
	(_gcry_aes_vp_riscv_xts_crypt): New.
	(do_setkey) [USE_VP_RISCV]: Setup vector permute AES for RISC-V with
	HWF_RISCV_IMAFDC and HWF_RISCV_V.
	* cipher/simd-common-riscv.h: New.
	* configure.ac: Add 'rijndael-vp-riscv.lo'.
	(gcry_cv_cc_riscv_vector_intrinsics)
	(gcry_cv_cc_riscv_vector_intrinsics_cflags): New.

	bithelp: add count trailing zero bits variant for RISC-V.
	+ commit 60104c2f92dc0d89bc67aa12a403533a65c34a2f
	* cipher/bithelp.h (_gcry_ctz_no_zero): New.
	(_gcry_ctz): Use '_gcry_ctz_no_zero'.
	* cipher/cipher-internal.h (ocb_get_l): Use '_gcry_ctz_no_zero'.

	hwf: add detection of RISC-V (64-bit) hardware features.
	+ commit df9de2a5e5a847fa4f11a923cf3397bf1cf7a562
	* configure.ac
	(gcry_cv_gcc_inline_asm_riscv, gcry_cv_gcc_inline_asm_riscv_v)
	(HAVE_GCC_INLINE_ASM_RISCV_V, HAVE_CPU_ARCH_RISCV): Add RISC-V
	detection support.
	* mpi/config.links: Add setup for RISC-V links.
	* src/Makefile.am: Add 'hwf-riscv.c'.
	* src/g10lib.h (HWF_RISCV_IMAFDC, HWF_RISCV_V, HWF_RISCV_ZBB)
	(HWF_RISCV_ZBC): New.
	* src/hwf_common.h (_gcry_hwf_detect_riscv): New.
	* src/hwf-riscv.c: New.
	* src/hwfeatures.c: Add "riscv-imafdc", "riscv-v", "riscv-zbb",
	and "riscv-zbc".

2025-01-27  Lucas Mulling  <lucas.mulling@suse.com>

	cipher: Check and mark non-compliant cipher modes in the SLI.
	+ commit 9f0fd2656d7d7ba26fcf95cc64d2514ae9ac8ec1
	* cipher/cipher.c (_gcry_cipher_open_internal): Check and mark if the
	cipher mode is compliant and reject accordingly.
	(_gcry_cipher_is_mode_fips_compliant): New.
	* src/gcrypt.h.in (GCRY_FIPS_FLAG_REJECT_CIPHER_MODE): New.
	* tests/t-fips-service-ind.c (check_cipher_o_s_e_d_c): Add test to
	verify that the service level indication is correctly set for non-
	compliant cipher modes, and correctly rejected if
	GCRY_FIPS_FLAG_REJECT_CIPHER_MODE is set.

2025-01-16  NIIBE Yutaka  <gniibe@fsij.org>

	Remove WindowsCE support.
	+ commit 24a2ca672b2198d3f420399bd01cc626d9de99f8
	* compat/clock.c, compat/getpid.c, random/rndw32ce.c: Remove.
	* compat/Makefile.am: Remove comment for clock.c and getpid.c.
	* compat/libcompat.h: Remove replacement functions.
	* configure.ac (GPG_ERR_ENABLE_ERRNO_MACROS): Remove.
	(have_w32ce_system, HAVE_W32CE_SYSTEM): Remove.
	(AC_REPLACE_FUNCS): Remove.
	(USE_RNDW32CE): Remove.
	* random/Makefile.am (EXTRA_librandom_la_SOURCES): Remove rndw32ce.c.
	* random/random-csprng.c [USE_RNDW32CE] (getfnc_gather_random):
	Remove WindowsCE support.
	(getfnc_fast_random_poll): Likewise.
	* src/Makefile.am [HAVE_W32CE_SYSTEM]: Remove WindowsCE support.
	* src/dumpsexp.c [__MINGW32CE__]: Remove WindowsCE support.
	* tests/stopwatch.h [__MINGW32CE__] (start_timer, stop_timer): Remove
	WindowsCE support.

2025-01-09  NIIBE Yutaka  <gniibe@fsij.org>

	build: Improve __thread specifier check.
	+ commit 42e8858566e32080aaf818b168f34c698a9ef084
	* configure.ac (AC_COMPILE_IFELSE __thread): Move the declaration to
	global, referring the variable with (void) in main to avoid an error
	buidling with -Werror=unused-variable.  Don't need to include
	stdlib.h.

2025-01-06  NIIBE Yutaka  <gniibe@fsij.org>

	fips,cipher: Fix memory leak for gcry_pk_hash_sign.
	+ commit 5e925e6c348450bf80b4560abac9a035903bff59
	* cipher/pubkey.c (prepare_datasexp_to_be_signed): Release
	copied HD when error.

2024-12-26  NIIBE Yutaka  <gniibe@fsij.org>

	fips,ecc: Check DATA in gcry_pk_sign/verify in FIPS mode.
	+ commit 53c97483b17fee280e24f595bc0d82d9b362ffde
	* src/gcrypt.h.in (GCRY_FIPS_FLAG_REJECT_PK_MD): New.
	(GCRY_FIPS_FLAG_REJECT_PK_GOST_SM2): New.

	* cipher/ecc.c (ecc_sign): Check if GOST or SM2.  Check if hash is
	compliant.
	(ecc_verify): Likewise.
	* tests/t-fips-service-ind.c (check_pk_s_v): Modify tests including
	hash compliance.

2024-12-24  NIIBE Yutaka  <gniibe@fsij.org>

	tests: Add more tests to tests/t-fips-service-ind.
	+ commit d71c88f78a4f1b72f92de90791fc6fe81a3cb861
	* tests/t-fips-service-ind.c (check_pk_g_t_n_c, check_pk_s_v): New.
	(main): Call check_pk_g_t_n_c and check_pk_s_v.

	fips,ecc: Add rejecting or marking for gcry_pk_get_curve.
	+ commit c6a092abbe7bea315394b15f28fd231dae0e4d7c
	* cipher/ecc-curves.c (_gcry_ecc_get_curve): Check under FIPS mode.

2024-12-20  NIIBE Yutaka  <gniibe@fsij.org>

	fips,cipher: Add behavior not to reject but mark non-compliant.
	+ commit a776b692669af7a6c089779989b626c4795e30b0
	* cipher/dsa.c (dsa_check_keysize): Check reject flag for rejection,
	or mark non-comliant in FIPS mode.
	* cipher/ecc-ecdsa.c (_gcry_ecc_ecdsa_sign): Likewise.
	* cipher/ecc.c (ecc_sign, ecc_verify): Likewise.
	* cipher/pubkey.c (_gcry_pk_encrypt, _gcry_pk_sign): Likewise.
	(_gcry_pk_verify, _gcry_pk_testkey, _gcry_pk_genkey): Likewise.
	(_gcry_pk_get_nbits, _gcry_pk_get_curve): Likewise.
	* src/visibility.c (gcry_pk_encrypt): Initialize the indicator.
	(gcry_pk_decrypt, gcry_pk_sign, gcry_pk_verify): Likewise.
	(gcry_pk_testkey, gcry_pk_genkey), gcry_pk_get_nbits)
	(gcry_pk_get_curve): Likewise.

	fips: Rejection by GCRYCTL_FIPS_REJECT_NON_FIPS, not by open flags.
	+ commit d060dd58b82882dec0d8bfcc593536bc0083b4b1
	* src/gcrypt.h.in (GCRY_CIPHER_FLAG_REJECT_NON_FIPS): Remove.
	(GCRY_MD_FLAG_REJECT_NON_FIPS): Remove.
	(GCRY_MAC_FLAG_REJECT_NON_FIPS): Remove.
	* tests/t-fips-service-ind.c: Update tests with
	GCRYCTL_FIPS_REJECT_NON_FIPS.
	* cipher/cipher.c (_gcry_cipher_open_internal, cipher_setkey): Use
	fips_check_rejection.
	* cipher/mac.c (mac_open): Likewise.
	* cipher/md.c (struct gcry_md_context): Remove reject_non_fips.
	(md_open, md_enable): Use fips_check_rejection.
	(_gcry_md_enable, md_copy): Likewise.

2024-12-19  NIIBE Yutaka  <gniibe@fsij.org>

	Fix the previous change.
	+ commit b4eb23dc01a40e13d542fbfc5169dffa7fae5677
	* cipher/pubkey.c (_gcry_pk_sign_md): Fix memory leak.
	(_gcry_pk_verify_md): Likewise.

	fips: Introduce GCRYCTL_FIPS_REJECT_NON_FIPS.
	+ commit e52adf0948c60b2e9accd7996fcece0f9b443763
	* src/gcrypt.h.in (GCRYCTL_FIPS_REJECT_NON_FIPS): New.
	(GCRY_FIPS_FLAG_REJECT_*): New.
	* src/fips.c (struct gcry_thread_context): Add flags_reject_non_fips.
	(the_tc): Add initial value.
	(_gcry_thread_context_set_reject): New.
	(_gcry_thread_context_check_rejection): New.
	* src/gcrypt-int.h (fips_check_rejection): New.
	* src/global.c (_gcry_vcontrol): Handle GCRYCTL_FIPS_REJECT_NON_FIPS.
	* tests/t-fips-service-ind.c (main): Use GCRYCTL_FIPS_REJECT_NON_FIPS.

2024-12-18  NIIBE Yutaka  <gniibe@fsij.org>

	fips,cipher: Implement FIPS service indicator for gcry_pk_hash_ API.
	+ commit edb43bc290046bd22548bf69ae2fbeb453112e44
	* src/visibility.c (gcry_pk_hash_sign): Initialize the indicator.
	(gcry_pk_hash_verify): Likewise.
	* tests/t-fips-service-ind.c (check_pk_hash_sign_verify): New.
	(main): Call check_pk_hash_sign_verify.
	* cipher/ecc-curves.c (_gcry_ecc_fill_in_curve): Don't reject, but
	mark non-compliance.
	* cipher/pubkey.c (prepare_datasexp_to_be_signed): Likewise.
	(_gcry_pk_sign_md, _gcry_pk_verify_md): Likewise.

	fips,md: gcry_md_copy should care about FIPS service indicator.
	+ commit 60db2a175d120aba6818de49638b36006878abf7
	* cipher/md.c (md_copy): In a case of non-compliant, mark with
	fips_service_indicator_mark_non_compliant.
	* src/visibility.c (gcry_md_copy): Initialize the indicator.

2024-12-17  NIIBE Yutaka  <gniibe@fsij.org>

	tests,fips: Add gcry_cipher_open tests.
	+ commit cfd2d2f41ad4aef40d83f8f7237d1da13c7e240c
	* tests/t-fips-service-ind.c (check_cipher_o_s_e_d_c): New.
	(main): Call check_cipher_o_s_e_d_c.

2024-12-16  NIIBE Yutaka  <gniibe@fsij.org>

	tests,fips: Move KDF tests to t-fips-service-ind.
	+ commit b59bde31ded9e829e2a53ddb8c533bf35a144972
	* tests/t-fips-service-ind.c (check_kdf_derive): Move from...
	* tests/t-kdf.c (check_fips_gcry_kdf_derive): ... here.

	tests,fips: Rename t-fips-service-ind.
	+ commit 132f346232b33fe41ffee3b3870ec189626676e7
	* tests/t-fips-service-ind.c: Rename from t-digest.c.
	* tests/Makefile.am (tests_bin): Follow the change.

	tests,fips: Add gcry_mac_open tests.
	+ commit c4f75014cb8af732f87c02fe7c2e7a488fe71c6d
	* tests/t-digest.c (check_mac_o_w_r_c): New.
	(main): Call check_mac_o_w_r_c.

	fips,cipher: Implement new FIPS service indicator for cipher_open.
	+ commit 69a5d0ed18a3ddc6f297de783c7cef5ad2257df0
	* src/gcrypt.h.in (GCRY_CIPHER_FLAG_REJECT_NON_FIPS): New.
	* cipher/cipher.c (_gcry_cipher_open_internal): Don't reject
	but mark the service indicator in FIPS mode.
	(cipher_setkey): Likewise.
	* src/visibility.c (gcry_cipher_open): Initialize the service
	indicator.
	(gcry_cipher_setkey): Likewise.

	fips,mac: Implement new FIPS service indicator for gcry_mac_open.
	+ commit fcb0c7004b0b6b318fdcced2bf61d9acb1e28cfc
	* src/gcrypt.h.in (GCRY_MAC_FLAG_REJECT_NON_FIPS): New.
	* cipher/mac.c (mac_open): Have FLAGS, instead of SECURE.  Reject when
	GCRY_MAC_FLAG_REJECT_NON_FIPS, otherwise, mark non compliant.
	(_gcry_mac_open): Follow the change.
	* src/visibility.c (gcry_mac_open): Add initialization for FIPS
	service indicator.
	(gcry_mac_setkey): Likewise.  Don't reject but mark.

2024-12-13  NIIBE Yutaka  <gniibe@fsij.org>

	fips,tests: Add tests for md_open/write/read/close for t-digest.
	+ commit 917fc6000dfebd8854f0d1c220b85dec0dbf4676
	* tests/t-digest.c (check_md_o_w_r_c): New.
	(main): Call check_md_o_w_r_c.

	fips,md: Implement new FIPS service indicator for gcry_md_open API.
	+ commit 9757e280794f537efc82c4eaa9a2944ece6a068a
	* src/gcrypt.h.in (GCRY_MD_FLAG_FIPS_NO_REJECTION): Remove.
	(GCRY_MD_FLAG_REJECT_NON_FIPS): New.
	* cipher/md.c (struct gcry_md_context): Add reject_non_fips.
	(md_enable): Remove NO_REJECT argument.
	(md_open): Change the FLAGS handling.
	(_gcry_md_open): Add checking of FIPS compliance against ALGO.
	(_gcry_md_enable): Likewise.
	(_gcry_md_hash_buffer): Follow the change of md_open change
	which now defaults to no rejection.
	(_gcry_md_hash_buffers_extract): Likewise.
	* src/visibility.c (gcry_md_open): Add fips_service_indicator_init.
	(gcry_md_enable): Likewise.
	(gcry_md_setkey): Don't reject but mark non-compliance.
	* tests/t-kdf.c (check_fips_gcry_kdf_derive): Add a test with
	non-compliant hash function.
	* cipher/mac-hmac.c (_gcry_mac_type_spec_hmac_md5): It's not
	compliant.
	* cipher/md5.c (gcry_md_oid_spec_t oid_spec_md5): It's not compliant.
	* tests/t-digest.c (check_hash_buffer, check_hash_buffers): MD5
	tests enabled.

	fips: Change the internal API for new FIPS service indicator.
	+ commit 4799914966a7f94f41e1ed5b7b62fded7ba09704
	* src/gcrypt-int.h (fips_service_indicator_init): Initialize by 0.
	(fips_service_indicator_mark_success): Remove.
	(fips_service_indicator_mark_non_compliant): New.
	* cipher/kdf.c (_gcry_kdf_derive): Follow the change of the API.
	* cipher/md.c (_gcry_md_hash_buffer): Likewise.
	(_gcry_md_hash_buffers_extract): Likewise.

2024-12-12  Simon Josefsson  <simon@josefsson.org>

	cipher: Add script to re-generate mceliece6688128f.c.
	+ commit 47ed744465ae7461771a3ca08799264a3d32a7fd
	* cipher/mceliece6688128f.sh: Add.
	* cipher/mceliece6688128f.c: Regenerate from script.

2024-12-11  Milan Broz  <gmazyland@gmail.com>

	kdf: Fix memory cost overflow in Argon2 KDF.
	+ commit 28327dba6b5ffae4a5e33da827fe0e2b48e99adb
	* cipher/kdf.c (argon2_init) Fix memory cost overflow in Argon2 KDF.

2024-12-11  NIIBE Yutaka  <gniibe@fsij.org>

	tests: Fix comment in t-thread-local.
	+ commit 75744f721d8d9c3bfc0ee1f8fec760718eb924a2
	* tests/t-thread-local.c: Fix the name.

2024-12-10  NIIBE Yutaka  <gniibe@fsij.org>

	tests: Extend tests/t-digest to test hmac too.
	+ commit 41cbcc0f0e786364972a4df213eff1b0ae362a40
	* tests/t-digest.c (check_hash_buffer): Rename.
	(check_hash_buffers): New.
	(main): Call check_hash_buffer and check_hash_buffers.

	tests: Fix t-digest for a minimal configuration.
	+ commit 06f6aafedc9f53d54468611744c67e0b7aa13c0c
	* tests/t-digest.c (check_digests): Care about minimal configuration.

2024-12-09  NIIBE Yutaka  <gniibe@fsij.org>

	fips,tests: Add t-digest.
	+ commit 7faf542f157330f3b247fa2542182ac805f06737
	* tests/Makefile.am (tests_bin): Add t-digest.
	* tests/t-digest.c: New.

2024-12-06  NIIBE Yutaka  <gniibe@fsij.org>

	fips,md: Implement new FIPS service indicator for gcry_md_hash_*.
	+ commit 3478caac62c712547f7c0e07f4cf9602bc317997
	* cipher/md.c (md_enable): Add an NO_REJECT argument.
	(md_open): Check flags against GCRY_MD_FLAG_FIPS_NO_REJECTION to
	call md_enable.
	(_gcry_md_enable): Follow the change.
	(_gcry_md_hash_buffer): Don't reject but keep the computation.
	Call fips_service_indicator_mark_success.
	(_gcry_md_hash_buffers_extract): Likewise.
	* src/gcrypt.h.in (GCRY_MD_FLAG_FIPS_NO_REJECTION): New.
	* src/visibility.c (gcry_md_hash_buffer, gcry_md_hash_buffers): Call
	fips_service_indicator_init.
	(gcry_md_hash_buffers_ext): Likewise.

2024-12-05  NIIBE Yutaka  <gniibe@fsij.org>
	    David Sugar  <david@atsec.com>

	fips,kdf: Implement new FIPS service indicator for gcry_kdf_derive.
	+ commit 5cfa1aee5b98baf0d66333344e0fa45b79cca28b
	* cipher/kdf.c (_gcry_kdf_derive): Don't reject by GPG_ERR_INV_VALUE
	but continue the computation, clearing IS_COMPLIANT.  After successful
	computation, call fips_service_indicator_mark_success with
	IS_COMPLIANT.
	* src/visibility.c (gcry_kdf_derive): Call fips_service_indicator_init.
	* tests/t-kdf.c (check_fips_gcry_kdf_derive): New.
	(main): Call check_fips_gcry_kdf_derive.

2024-12-05  NIIBE Yutaka  <gniibe@fsij.org>

	fips: Introduce GCRYCTL_FIPS_SERVICE_INDICATOR and the macro.
	+ commit f51f4e98930e6b2175e85fe8a95b8b6a15ad5efa
	* src/fips.c (_gcry_fips_indicator): New.
	* src/g10lib.h (_gcry_fips_indicator): New.
	* src/gcrypt.h.in (GCRYCTL_FIPS_SERVICE_INDICATOR): New.
	(gcry_get_fips_service_indicator): New.
	* src/global.c (_gcry_vcontrol): Handle GCRYCTL_FIPS_SERVICE_INDICATOR.

	fips: Introduce an internal API for FIPS service indicator.
	+ commit e1cf3123282525693b646499eb7efe4f2be4010a
	* configure.ac (HAVE_GCC_STORAGE_CLASS__THREAD): New.
	* src/fips.c (struct gcry_thread_context): New.
	(_gcry_thread_context_set_fsi, _gcry_thread_context_get_fsi): New.
	* src/gcrypt-int.h (fips_service_indicator_init): New macro.
	(fips_service_indicator_mark_success): New macro.
	* tests/Makefile.am (tests_bin): Add t-thread-local.
	* tests/t-thread-local.c: New.

2024-11-06  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	Add vector register clearing for PowerPC implementations.
	+ commit 022f44b6d894ba631cb20623a1e39267a953dff9
	* cipher/Makefile.am: Add 'simd-common-ppc.h'.
	* cipher/camellia-simd128.h
	[HAVE_GCC_INLINE_ASM_PPC_ALTIVEC]: Include "simd-common-ppc.h".
	[HAVE_GCC_INLINE_ASM_PPC_ALTIVEC] (memory_barrier_with_vec)
	(clear_vec_regs): Remove.
	* cipher/chacha20-p10le-8x.s (clear_vec_regs): New.
	(_gcry_chacha20_p10le_8x): Add clear_vec_regs.
	* cipher/chacha20-ppc.c: Include "simd-common-ppc.h".
	(chacha20_ppc_blocks1, chacha20_ppc_blocks4)
	(chacha20_poly1305_ppc_blocks4): Add clear_vec_regs.
	* cipher/cipher-gcm-ppc.c: Include "simd-common-ppc.h".
	(_gcry_ghash_setup_ppc_vpmsum, _gcry_ghash_ppc_vpmsum): Add
	clear_vec_regs.
	* cipher/poly1305-p10le.s (clear_vec_regs): New.
	(gcry_poly1305_p10le_4blocks): Add clear_vec_regs.
	* cipher/rijndael-p10le.c: Include "simd-common-ppc.h".
	(_gcry_aes_p10le_gcm_crypt): Add clear_vec_regs.
	* cipher/rijndael-ppc-common.h: Include "simd-common-ppc.h".
	* cipher/rijndael-ppc-functions.h (ENCRYPT_BLOCK_FUNC):
	(DECRYPT_BLOCK_FUNC, CFB_ENC_FUNC, ECB_CRYPT_FUNC, CFB_DEC_FUNC)
	(CBC_ENC_FUNC, CBC_DEC_FUNC, CTR_ENC_FUNC, OCB_CRYPT_FUNC)
	(OCB_AUTH_FUNC, XTS_CRYPT_FUNC, CTR32LE_ENC_FUNC): Add
	clear_vec_regs.
	* cipher/rijndael-ppc.c (_gcry_aes_ppc8_setkey)
	(_gcry_aes_ppc8_prepare_decryption): Add clear_vec_regs.
	* cipher/sha256-ppc.c: Include "simd-common-ppc.h".
	(sha256_transform_ppc): Add clear_vec_regs.
	* cipher/sha512-ppc.c: Include "simd-common-ppc.h".
	(sha512_transform_ppc): Add clear_vec_regs.
	* cipher/simd-common-ppc.h: New.
	* cipher/sm4-ppc.c: Include "simd-common-ppc.h".
	(sm4_ppc_crypt_blk1_16): Add clear_vec_regs.

	rijndael-ppc: fix 'may be used uninitialized' warnings.
	+ commit 52bd6fc0c0383c183870966069a7548dc2b8641a
	* cipher/rijndael-ppc-common.h (PRELOAD_ROUND_KEYS_ALL): Load
	rkey10-rkey13 with zero value by default.

	salsa20-amd64: clear vectors registers.
	+ commit 6a128b2380a4deb6086a904f17a1ff40c5af9b64
	* cipher/salsa20-amd64.S (CLEAR_REG): New.
	(_gcry_salsa20_amd64_encrypt_blocks): Clear vectors registers
	at exit.

	whirlpool-sse2-amd64: clear vectors registers.
	+ commit c479b9dd5a3863d81d88c305da1b61e3aa2d274e
	* cipher/whirlpool-sse2-amd64.S (CLEAR_REG): New.
	(_gcry_whirlpool_transform_amd64): Clear vectors registers
	at exit.

	camellia-aarch64-ce: clear volatile vectors registers.
	+ commit 762ccf64429d94530727bf8508e4d499fcfd062c
	* cipher/camellia-simd128.h [__powerpc__] (clear_vec_regs): New.
	[__ARM_NEON]: Include 'simd-common-aarch64.h'.
	[__ARM_NEON] (memory_barrier_with_vec): Remove.
	[__x86_64__] (clear_vec_regs): New.
	(FUNC_ENC_BLK16, FUNC_DEC_BLK16, camellia_setup128)
	(camellia_setup256): Add clear_vec_regs.

	gcm-aarch64-ce: clear volatile vector registers at setup function.
	+ commit 3d3e346cc3f52a423d67118203f0543feb430545
	* cipher/cipher-gcm-armv8-aarch64-ce.S
	(_gcry_ghash_setup_armv8_ce_pmull): Clear used vectors registers
	before function exit.

	sm3-aarch64-ce: clear volatile vector registers.
	+ commit af84aa32427d841eedbad0c2d1e53cf1df6dd732
	* cipher/sm3-armv8-aarch64-ce.S: Add CLEAR_ALL_REGS.

	sm4-aarch64-ce: clear volatile vector registers.
	+ commit 42495ad3a80eadb0b853c95377777fe9435b03ac
	* cipher/sm4-armv8-aarch64-ce.S (_gcry_sm4_armv8_ce_expand_key)
	(_gcry_sm4_armv8_ce_crypt_blk1_8, _gcry_sm4_armv8_ce_crypt)
	(_gcry_sm4_armv8_ce_cbc_dec, _gcry_sm4_armv8_ce_cfb_dec)
	(_gcry_sm4_armv8_ce_ctr_enc, _gcry_sm4_armv8_ce_xts_crypt): Add
	CLEAR_ALL_REGS.

	sm4-aarch64: clear volatile vectors registers.
	+ commit f6cebb330d87b88543949ae36a2bfef8b45c41d8
	* cipher/sm4-aarch64.S (clear_volatile_vec_regs): New.
	(_gcry_sm4_aarch64_crypt_blk1_8, _gcry_sm4_aarch64_crypt)
	(_gcry_sm4_aarch64_cbc_dec, _gcry_sm4_aarch64_cfb_dec)
	(_gcry_sm4_aarch64_ctr_enc): Add clear_volatile_vec_regs.

	sm4-aarch64-sve: clear volatile vectors registers.
	+ commit fb78bc85dfe183f381ad83142e5abf46f4096ca6
	* cipher/asm-common-aarch64.h (CLEAR_ALL_REGS): New.
	* cipher/sm4-armv9-aarch64-sve-ce.S
	(_gcry_sm4_armv9_sve_ce_cbc_dec, _gcry_sm4_armv9_sve_ce_cfb_dec)
	(_gcry_sm4_armv9_sve_ce_ctr_enc): Add CLEAR_ALL_REGS.

	sm4-aarch64-sve: add missing .text section.
	+ commit 341945ae9651b42e07fe5c29d6634b8af110ce4c
	* cipher/sm4-armv9-aarch64-sve-ce.S: Add missing '.text'.

	Add GHASH AArch64/SIMD intrinsics implementation.
	+ commit fec871fd18c73d790ac64a2a3b9e422212c2a6af
	* cipher/Makefile.am: Add 'cipher-gcm-aarch64-simd.c'.
	* cipher/cipher-gcm-aarch64-simd.c: New.
	* cipher/cipher-gcm.c [GCM_USE_AARCH64]: Add function
	prototypes for AArch64/SIMD implementation.
	(setupM) [GCM_USE_AARCH64]: Add setup for AArch64/SIMD
	implementation.
	* cipher/cipher-internal.h (GCM_USE_AARCH64): New.
	* configure.ac: Add 'cipher-gcm-aarch64-simd.c'.

	Add AES Vector Permute intrinsics implementation for AArch64.
	+ commit 94a63aedbbd252305c865912e59400dc6f3bc3b8
	* cipher/Makefile: Add 'rijndael-vp-aarch64.c',
	'rijndael-vp-simd128.h' and 'simd-common-aarch64.h'.
	* cipher/rijndael-internal.h (USE_VP_AARCH64): New.
	* cipher/rijndael-vp-aarch64.c: New.
	* cipher/rijndael-vp-simd128.h: New.
	* cipher/rijndael.c [USE_VP_AARCH64]: Add function prototypes
	for AArch64 vector permutation implementation.
	(do_setkey) [USE_VP_AARCH64]: Setup function pointers for
	AArch64 vector permutation implementation.
	* cipher/simd-common-aarch64.h: New.
	* configure.ac: Add 'rijndael-vp-aarch64.lo'.

2024-10-25  NIIBE Yutaka  <gniibe@fsij.org>

	config: Include Kyber in GCRYPT_PUBKEY_CIPHERS.
	+ commit 7eaa43bf0931494afccbd413d83a3010aa80cee0
	* configure.ac (available_pubkey_ciphers): Add kyber.

2024-09-17  NIIBE Yutaka  <gniibe@fsij.org>

	tests:kyber: Add genkey and encap KAT tests.
	+ commit 4876a1a45c25d7e3ffb45a0af4e7c8995ce3a552
	* tests/t-kem.c (test_kem_sntrup761): Use gcry_kem_genkey API.
	(test_kem_mceliece6688128f): Likewise.
	(test_kem_mlkem512, test_kem_mlkem768, test_kem_mlkem1024): Likewise.
	(test_kem_raw_x25519, test_kem_dhkem_x25519): Likewise.
	* tests/t-mlkem.c (N_TESTS): Update the number of tests.
	(one_genkey_test, one_encap_test): New.
	(one_decap_test): Rename from one_test.
	(check_mlkem_kat): Support KAT tests for genkey ane encap.
	* tests/t-mlkem.inp: Add test data sets for genkey and encap.

	cipher:kyber: Add gcry_kem_genkey to support deterministic op.
	+ commit 38742196c04c99de3366156221dda9e0ceddc0d7
	* cipher/kem.c (_gcry_kem_genkey): Rename from _gcry_kem_keypair,
	adding OPTIONAL argument.
	(_gcry_kem_encap): Allow OPTIONAL for deterministic operation.
	(kem_generate): Use _gcry_kem_genkey instead of _gcry_kem_keypair.
	* cipher/kyber.c (crypto_kem_keypair_derand_2)
	(crypto_kem_keypair_derand_3, crypto_kem_keypair_derand_4): Expose.
	(crypto_kem_enc_derand_2, crypto_kem_enc_derand_3): Likewise.
	(crypto_kem_enc_derand_4): Likewise.
	(kyber_keypair): Allow COINS for deterministic operation.
	(kyber_encap): Likewise.
	* cipher/kyber.h: Allow COINS for deterministic operation.
	(crypto_kem_keypair_derand, crypto_kem_enc_derand): New.
	* src/gcrypt-int.h (_gcry_kem_genkey): Rename from _gcry_kem_keypair.
	* src/gcrypt.h.in (gcry_kem_genkey): New.
	* src/libgcrypt.def (gcry_kem_genkey): New.
	* src/libgcrypt.vers (gcry_kem_genkey): New.
	* src/visibility.c (gcry_kem_genkey): New.
	* src/visibility.h (gcry_kem_genkey): New.

2024-08-27  NIIBE Yutaka  <gniibe@fsij.org>

	cipher:kyber: Apply changes from upstream for final FIPS 203.
	+ commit cc95c36e7f79ac47c201b7cbd375ee37b9689d0d
	* cipher/kyber-kdep.c (gen_matrix): Simplify for the case of
	XOF_BLOCKBYTES%3 == 0.
	(indcpa_keypair_derand): Add domain separation to key generation.

2024-08-26  NIIBE Yutaka  <gniibe@fsij.org>

	Fix previous commit.
	+ commit bfbddd64002d80e2d0a7e62adff2ed57abc99392
	* tests/pkcs1v2.c (check_oaep): Need to specify HASH-ALGO.

2024-08-22  NIIBE Yutaka  <gniibe@fsij.org>

	tests: More fixes for tests/pkcs1v2.c.
	+ commit ced3a39b29af341edb2e025e398c31c177b78bfe
	* tests/pkcs1v2.c (check_oaep): Don't specify SHA1.
	Don't supply SEED for decryption.
	(check_pss): Don't supply SALT for verification.

2024-08-22  Jakub Jelen  <jjelen@redhat.com>

	tests: Remove needless PKCS#1.5 encryption and decryption parameters.
	+ commit 081e18a98f629926bd1306680f6bfa5936345d59
	* tests/pkcs1v2.c (check_v15crypt): Remove needless flags from s-exp.

2024-08-21  Werner Koch  <wk@gnupg.org>

	Return a proper error code on malloc failure in hex2buffer.
	+ commit c51151f5b0b3e5c9ebf6935d85fe1505aa7a124a
	* src/sexp.c (_gcry_hex2buffer): Replace xmalloc by xtrymalloc.

2024-08-21  NIIBE Yutaka  <gniibe@fsij.org>

	Fix memory leaks.
	+ commit 0e186b31d7bcdab793e82e73295804351c3dffd7
	* src/sexp.c (_gcry_hex2buffer): Free buffer on error.
	* cipher/ecc-ecdh.c (_gcry_ecc_curve_keypair): Free buffer on exit path.
	(_gcry_ecc_curve_mul_point): Free buffer on all exit paths.
	* tests/t-common.h (hex2buffer): Free memory on error path.

2024-08-07  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	Add PAC/BTI support for AArch64 assembly.
	+ commit 55e2e23401c64541e88aad84b5f9e8b1e4ab6acb
	* cipher/asm-common-aarch64.h (AARCH64_BTI_PROPERTY_FLAG)
	(AARCH64_HINT_BTI_C, AARCH64_PAC_PROPERTY_FLAG)
	(note.gnu.property): New.
	(CFI_STARTPROC): Add AARCH64_HINT_BTI_C.

	camellia-aarch64: do not store/load link register to/from stack.
	+ commit b73f54fed2c440128982b4ee23e9226768b75681
	* cipher/camellia-aarch64.S (_gcry_camellia_arm_encrypt_block)
	(_gcry_camellia_arm_decrypt_block): Store/load dummy x20 instead
	of x30.

	Do not build 32-bit ARM assembly on Aarch64.
	+ commit 93aad101d5796242558c26b7851624449edeba52
	* configure.ac: Build "serpent-armv7-neon", "salsa20-armv7-neon",
	"chacha20-armv7-neon", "sha512-armv7-neon" and "keccak-armv7-neon"
	only on 32-bit ARM.

2024-08-04  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	mpi/ec-inline: reduce register pressure on 32-bit ARM.
	+ commit 9c93b4607adcf9b3efd53aba43e2d33bf5aef9df
	* mpi/ec-inline.h [HAVE_COMPATIBLE_GCC_ARM_PLATFORM_AS] (ADD4_LIMB32)
	(ADD6_LIMB32, SUB4_LIMB32, SUB6_LIMB32): Reuse input registers
	as output (use just two unique operators).

2024-07-28  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	Add CET support for i386 assembly.
	+ commit 64ec13d11b08fbe31cc6f83e9464e7e251d41019
	* cipher/asm-common-i386.h (ENDBRANCH): New.
	(CFI_STARTPROC): Add ENDBRANCH.
	[__CET__] (note.gnu.property): Add CET property section.

	Add CET support for x86-64 assembly.
	+ commit d69e6a29b986cf1cb21e09d337a0de2564ef34f2
	* cipher/asm-common-amd64.h (ENDBRANCH): New.
	(CFI_STARTPROC): Add ENDBRANCH.
	[__CET__] (note.gnu.property): Add CET property section.

	Do not build amd64 assembly on i386.
	+ commit 5797d75e3b916caf504bed73a8629c6c168be58d
	* configure.ac: Build "serpent-avx2-amd64" and
	"camellia-*-amd64" only on x86-64.

	Do not build i386 assembly on x86-64.
	+ commit dd42a4e03e066c49a6d83e0d3a07e4261d77121a
	* configure.ac: Enable building i386 "rijndael-vaes" only
	on i?86 host instead of x86 MPI arch ("i?86 + x86-64").

	asm-common-amd64: add missing CFI directives for large memory model code
	+ commit 7ee2e73495d051ca09dd57c90132a7a9cc53bc62
	* cipher/asm-common-amd64.h [__code_model_large__]
	(GET_EXTERN_POINTER): Add CFI_PUSH/CFI_POP directives.

2024-07-04  NIIBE Yutaka  <gniibe@fsij.org>

	cipher:blake2: Fix for use_avx512.
	+ commit b42116d6067a5233f72e5598032d4b396bb8eaac
	* cipher/blake2.c (blake2s_init_ctx): Conditional with USE_AVX512.

2024-07-02  NIIBE Yutaka  <gniibe@fsij.org>

	cipher:kyber: Use ct_int16_select of libgcrypt .
	+ commit 8b898670e9150cd04ab57c763e9aedb7091c5e18
	* cipher/kyber-common.c (poly_frommsg): Use ct_int16_select.
	* cipher/kyber.c: Require ct_int16_select for external use case.
	* src/const-time.h: Add ct_int16_select.

	cipher:kyber: Apply a change from upstream.
	+ commit f765778e82b33efa6a9c0ec0b4f97564ac229c46
	* cipher/kyber-common.c (poly_frommsg): Remove secret-dependent
	branch.

2024-06-24  simit.ghane  <simit.ghane@lge.com>

	random:cipher: handle substitution in sed command.
	+ commit e96df0c82e086bf348753d2d0fa37fa6191b4b14
	* cipher/Makefile.am (o_flag_munging): Add 'g' flag for first sed
	expression.
	* random/Makefile.am (o_flag_munging): Likewise.

2024-06-24  NIIBE Yutaka  <gniibe@fsij.org>

	m4: Fix acinclude.m4 for underscore detection in the symbol.
	+ commit bb0895bbb7c6d2b9502cbbf03da14d4ecf27a183
	* acinclude.m4 (GNUPG_SYS_SYMBOL_UNDERSCORE): Fix for a case with
	underscore.

2024-06-23  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	mpi/generic: use longlong.h for carry handling.
	+ commit d37cdd5bcb1e0960c3f4164a8163893438811f29
	* mpi/generic/mpih-add1.c (_gcry_mpih_add_n): Use add_ssaaaa for
	carry handling.
	* mpi/generic/mpih-mul1.c (_gcry_mpih_mul_1): Likewise.
	* mpi/generic/mpih-mul2.c (_gcry_mpih_addmul_1): Likewise.
	* mpi/generic/mpih-mul3.c (_gcry_mpih_submul_1): Use add_ssaaaa
	and sub_ddmmss for carry handling.
	* mpi/generic/mpih-sub1.c (_gcry_mpih_sub_n): Likewise.

	chacha20-ppc: fix implicit conversion between vector types warnings.
	+ commit 414b4251fdb3c701912a0fc56ae8ef6e3fe35ecf
	* cipher/chacha20-ppc.c (chacha20_ppc_blocks4)
	(chacha20_ppc_blocks4, chacha20_poly1305_ppc_blocks4): Explicitly
	convert return values from vec_cmplt.

	chacha20-ppc: silence GCC cast alignment warning.
	+ commit a9f112f36392c87b3d6153b8452cd86211d15ce0
	* cipher/chacha20-ppc.c (vec_load_le, vec_store_le): Cast
	pointers through void pointer type.

	rijndael-p10le: silence incorrect GCC cast alignment warning.
	+ commit 1f8a5aa86dad71c77af9a2b4387e7fc2e5bf015f
	* cipher/rijndael-p10le.c (_gcry_aes_p10le_gcm_crypt): Cast
	context to RIJNDAEL_context type through void pointer.

	src/hwf-x86: disable inline assembly CFI directivies for WIN32.
	+ commit 26a462925e2230de82d5e1b91c9306b1f2668a02
	* src/hwf-x86.c (CFI_ADJUST_CFA_OFFSET, CFI_PUSH4)
	(CFI_POP4): Define only if _WIN32 is not defined.

2024-06-20  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	Disable SHA3 s390x acceleration for CSHAKE.
	+ commit 2486d9b5ae015c1786cb84466a751da4bc0d7122
	* cipher/keccak.c (keccak_final_s390x): Add assert check for
	expected SHAKE suffix.
	(_gcry_cshake_customize, cshake_hash_buffers): Disable s390x
	acceleration when selecting CSHAKE suffix.

2024-06-19  Werner Koch  <wk@gnupg.org>

	Release 1.11.0.
	+ commit 9d94d7846cde272b8b1519ba96e53967bf0b90d2


2024-06-14  NIIBE Yutaka  <gniibe@fsij.org>

	m4: Update gpg-error.m4.
	+ commit 89adba4518d2c7f83a37361f66b3ac290c96525c
	* m4/gpg-error.m4: Update from libgpg-error master.

2024-06-13  NIIBE Yutaka  <gniibe@fsij.org>

	libgcrypt.m4: Fix setting/using GPG_ERROR_CONFIG.
	+ commit 0fd9ec3403ea66d39f32602dce53bc5219e4c158
	libgcrypt.m4 (_AM_PATH_GPGRT_CONFIG): Don't set GPG_ERROR_CONFIG and
	gpg_error_config_version.

2024-06-06  Jakub Jelen  <jjelen@redhat.com>

	cipher:aeswrap: Fix padding length check.
	+ commit dc8d84383a6bfa44f397132eae203efa0bf20e82
	* cipher/cipher-aeswrap.c (_gcry_cipher_keywrap_decrypt_auto): When
	padding length is 8, correctly return GPG_ERR_CHECKSUM.

2024-05-21  Jakub Jelen  <jjelen@redhat.com>

	mpi: Fix loop condition in bad point check.
	+ commit 1875758440158fe1943d1b19b29d77421d269256
	* mpi/ec.c (ec_p_init): Fix loop condition to avoid out-of-range read.

2024-05-17  Werner Koch  <wk@gnupg.org>

	build: Remove cruft from configure.ac.
	+ commit 0526d65afd34f9282e7fd125df6ee9a3c757ae79
	* configure.ac: Remove unused cruft.

2024-05-14  NIIBE Yutaka  <gniibe@fsij.org>

	m4: Include _AM_PATH_GPGRT_CONFIG definition.
	+ commit ad3b599462bdbc459f6c7be867e9a12ab46481b3
	* src/libgcrypt.m4: Find gpgrt-config.

2024-05-09  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	random: fix o_flag_munging for -O1.
	+ commit 5afadba008918d651afefb842ae123cc18454c74
	* random/Makefile.am (o_flag_munging): Also convert -O1 to -O0.

2024-05-08  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	chacha20-aarch64: use local symbols for read-only data.
	+ commit 3f5989014a1b7c01aced88897d878ce5105d15df
	* cipher/chacha20-aarch64.S: Remove '.globl' mark for RODATA section
	objects.

2024-05-07  simit.ghane  <simit.ghane@lge.com>

	Fix building error with '-O2' in sysroot path.
	+ commit b99952adc6ee611641709610d2e4dc90ba9acf37
	* cipher/Makefile.am (o_flag_munging): Tweak the sed script.
	* random/Makefile.am (o_flag_munging): Ditto.

2024-05-07  NIIBE Yutaka  <gniibe@fsij.org>

	cipher:kem: Remove the experimental KEMs (PGP and CMS).
	+ commit c9affe97d20bc958d733206adf350214b32ae0b2
	* src/gcrypt.h.in (enum gcry_kem_algos): Remove
	GCRY_KEM_OPENPGP_X25519, GCRY_KEM_CMS_X25519_X963_SHA256, and
	GCRY_KEM_CMS_X25519_HKDF_SHA256.
	* cipher/kem.c (_gcry_kem_keypair, _gcry_kem_encap): Likewise.
	(_gcry_kem_decap): Likewise.
	* cipher/kem-ecc.c (algo_to_curve): Follow the removal.
	(algo_to_seckey_len): Likewise.
	(openpgp_kem_kdf, _gcry_openpgp_kem_encap): Remove.
	(_gcry_openpgp_kem_decap, cms_kem_kdf): Remove.
	(_gcry_cms_kem_encap, _gcry_cms_kem_decap): Remove.
	* cipher/kem-ecc.h: Follow the removal.
	* tests/t-kem.c (test_kem_openpgp_x25519) Remove.
	(test_kem_cms_x25519): Remove.
	(check_kem, main): Follow the change.

2024-04-30  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	serpent-avx512-x86: fix CBC and CFB decryption with clang-18.
	+ commit 5a653a9129d7cc2f203ab9ad37ccdbcb832337d1
	* cipher/serpent-avx512-x86.c (serpent_avx512_blk32): Avoid
	'_mm512_castsi128_si512' usage to prevent non-initialized
	vector register parts getting XOR into calculations for
	CBC and CFB decryption.

2024-04-26  Werner Koch  <wk@gnupg.org>

	Let gcry_print_config show whether it is amd64 or i686.
	+ commit 0729fb84a6a1c038d4ed10f9c60be7df48558d9e
	* src/global.c (print_config): Append a sub-cpu string.

2024-04-25  Werner Koch  <wk@gnupg.org>

	Require GpgRT 1.49.
	+ commit f895a69d3b4bd5b8f6fab11345c2663947b7e5e3
	* configure.ac (LIBGCRYPT_LT_REVISION): Require 1.49
	* src/global.c (print_config): Repalce gpgrt backward compatibility.
	* src/misc.c (_gcry_set_gpgrt_post_log_handler): Ditto.
	(_gcry_logv): Use new gpgrt_logv_domain.

2024-04-24  NIIBE Yutaka  <gniibe@fsij.org>

	cipher:kem:ecc: Support NIST curves.
	+ commit 005292cf9f41179247918711b2968dd188aae122
	* cipher/kem-ecc (ECC_SECKEY_LEN_MAX): Fix for P521R1.
	(algo_to_curve): Using canonical name, add NIST curves,
	(algo_to_seckey_len): Likewise.
	* cipher/kem.c (_gcry_kem_keypair, _gcry_kem_encap): Likewise.
	(_gcry_kem_decap): Likewise.
	* src/gcrypt.h.in (enum gcry_kem_algos): Likewise.

	cipher:kem:ecc: Fix DHKEM implementation.
	+ commit 118fa95d8d36efb07dbebdbcbc0e3408e69ac5d2
	* cipher/kem-ecc.c (_gcry_ecc_dhkem_decap): Fix the size.

2024-04-23  Werner Koch  <wk@gnupg.org>

	cipher:kem:ecc: Support brainpoolP512r1.
	+ commit 4fb99ec266e5d38e0f6df5c2fd27da71f2fb441f
	* cipher/kem-ecc.c (algo_to_curve): Add GCRY_KEM_RAW_BP512.
	(algo_to_seckey_len): Ditto.
	* cipher/kem.c (_gcry_kem_keypair): Ditto.
	(_gcry_kem_encap): Ditto.
	(_gcry_kem_decap): Ditto.

	Use explicit values for the gcry_kem_algos enum.
	+ commit 66884c2d6b35bf418a267697a2726142a95188be
	* src/gcrypt.h.in (enum gcry_kem_algos): Use explicit values for
	improved ABI stability.
	(GCRY_KEM_RAW_BP512): New.

	cipher:kem:ecc: Fix for Weierstrass.
	+ commit 7ad308434f159952baf578eca60efc1f5bf93019
	* cipher/ecc-ecdh.c (_gcry_ecc_curve_mul_point): Use POINT_LEN and not
	NBYTES to create mpi_u.

	Divert log functions to the gpgrt log functions.
	+ commit ab0bdc72c79d5655e63047f768a202e063d8c18b
	* src/misc.c (my_gpgrt_post_fatal_handler): New.
	(_gcry_set_gpgrt_post_log_handler): New.
	(map_log_level): New.
	(_gcry_logv): Use gcrypt log function unless a handler has been
	installed.
	* src/global.c (global_init): Install post log handler.
	* src/gcrypt.h.in (gcry_set_log_handler): Deprecate.

2024-04-22  NIIBE Yutaka  <gniibe@fsij.org>

	cipher:kem:ecc: Support brainpoolP256r1 and brainpoolP384r1.
	+ commit 9c65260f915f3eeebf10b51ab7c3c9b5f0004d9b
	* cipher/kem.c (_gcry_kem_keypair): Support classic curves.
	(_gcry_kem_encap, _gcry_kem_decap): Likewise.
	* cipher/kem-ecc.c (algo_to_curve, algo_to_seckey_len): New.
	(_gcry_ecc_raw_keypair): Support classic curves.
	(_gcry_ecc_raw_encap, _gcry_ecc_raw_decap): Likewise.
	(ecc_tweak_bits): Move to ...
	* cipher/ecc-ecdh.c (ecc_tweak_bits): here.
	(_gcry_ecc_curve_keypair): New.
	(_gcry_ecc_curve_mul_point): Add length arguments.
	* src/gcrypt-int.h (_gcry_ecc_curve_keypair): New.
	* src/gcrypt.h.in: Add constants for brainpoolP256r1 and
	brainpoolP384r1.

2024-04-19  NIIBE Yutaka  <gniibe@fsij.org>

	cipher:ecc: Return the result in SEC1 point format for Weierstrass.
	+ commit 47f2cb8f6f35cf962158d9cffc79c23fab163585
	* cipher/ecc-ecdh.c (_gcry_ecc_curve_mul_point): Fix for
	MPI_EC_WEIERSTRASS curve.

	cipher:ecc: Add _gcry_ecc_curve_mul_point function with curve name.
	+ commit b1da8247dcbc036a5dc55dc7121ccd537c9b7ff3
	* cipher/ecc-ecdh.c (_gcry_ecc_curve_mul_point): New.  Also support
	Weierstrass curve as well as Montgomery one.
	(_gcry_ecc_mul_point): Use _gcry_ecc_curve_mul_point.

	cipher:kem: Rename Classic McEliece API constants.
	+ commit 72b1b8d447fb8046e5546998619206646dde2ea7
	* src/gcrypt.h.in (GCRY_KEM_CM6688128F): Rename.
	* cipher/kem.c (_gcry_kem_keypair): Follow the change.
	(_gcry_kem_encap, _gcry_kem_decap): Likewise.
	* tests/t-kem.c (test_kem_mceliece6688128f): Likewise.
	(main): Also change CLI option name.

2024-04-18  NIIBE Yutaka  <gniibe@fsij.org>

	cipher: More clean up for Classic McEliece implementation.
	+ commit 9a552b80d6c44a05ab733e441664d19de6f23da3
	* cipher/mceliece6688128f.h: Provide GCC_ATTR_UNUSED.
	* cipher/mceliece6688128f.c: Use GCC_ATTR_UNUSED.

	cipher: Fix comments of Classic McEliece implementation.
	+ commit 6478203e77d173128c4c0810db6f41198c360ca2
	* cipher/mceliece6688128f.c: Don't use C++-style comments for old
	compilers (< C99).

2024-04-17  Simon Josefsson  <simon@josefsson.org>

	cipher: Add Classic McEliece mceliece6688128f.
	+ commit 003367b91272f499d6eecb32ab9a09f383bdc788
	* cipher/Makefile.am (libcipher_la_SOURCES): Add mceliece6688128f.{c,h}.
	* cipher/mceliece6688128f.c, cipher/mceliece6688128f.h: New.
	* tests/t-kem.c: Support mceliece6688128f.

2024-04-16  NIIBE Yutaka  <gniibe@fsij.org>

	cipher: Fix copyright notices for Kyber implementation.
	+ commit eec1a576dbd080eb54ad7c6027271fe3f71c8847
	* cipher/kyber-common.c: Fix copyright notice sentences.
	* cipher/kyber-kdep.c, cipher/kyber.c, cipher/kyber.h: Likewise.

2024-04-09  NIIBE Yutaka  <gniibe@fsij.org>

	cipher: Add X448 based ECC KEM.
	+ commit 40b4781022c5f5ebf1ec6e6d814f9c2a346cb3ca
	* src/gcrypt.h.in (GCRY_KEM_RAW_X448, GCRY_KEM_DHKEM448): New.
	* cipher/kem-ecc.c (_gcry_ecc_raw_encap): Support X448.
	(ecc_dhkem_kdf, _gcry_ecc_dhkem_encap): Likewise.
	(_gcry_ecc_dhkem_decap): Likewise.
	* cipher/kem.c (_gcry_kem_keypair): Add support for GCRY_KEM_RAW_X448
	and GCRY_KEM_DHKEM448.
	(_gcry_kem_encap, _gcry_kem_decap): Likewise.

2024-04-05  Werner Koch  <wk@gnupg.org>

	Trailing comma removal for better portability.
	+ commit 9e6db9d74631e623164319f1fc9713afdf9e3eb9
	* cipher/kem.c (kem_names): Remove trailing comma.
	* src/gcrypt.h.in (enum gcry_kem_algos): Ditto.

	ecc: Add bp256, bp384, bp512 aliases for Brainpool curves.
	+ commit d211e7fe967381bfb19e4f18e0be067c68200c50
	* cipher/ecc-curves.c (curve_aliases): Add new aliases for Brainpool.

2024-04-03  NIIBE Yutaka  <gniibe@fsij.org>

	tests: Fix t-kem for tests with X25519 for FIPS mode.
	+ commit a78dcad69872e1d6e6eb7ead174e398d9c7d4800
	* tests/t-kem.c (test_kem_raw_x25519): It is expected to fail.
	(test_kem_dhkem_x25519, test_kem_openpgp_x25519): Likewise.
	(test_kem_cms_x25519): Likewise.

2024-03-28  NIIBE Yutaka  <gniibe@fsij.org>

	cipher:kem: Add ECC KEM for X25519.
	+ commit 5da6c63fed34f6027a9531780252f0f54087c379
	* cipher/Makefile.am (libcipher_la_SOURCES): Add kem-ecc.{c,h}.
	* cipher/kem-ecc.c: New.
	* cipher/kem-ecc.h: New.
	* cipher/kem.c (_gcry_kem_keypair): Dispatch to _gcry_ecc_raw_keypair.
	(_gcry_kem_encap): Dispatch to _gcry_ecc_raw_encap,
	_gcry_ecc_dhkem_encap, _gcry_openpgp_kem_encap, and
	_gcry_cms_kem_encap.
	(_gcry_kem_decap): Dispatch to _gcry_ecc_raw_decap,
	_gcry_ecc_dhkem_decap, _gcry_openpgp_kem_decap, and
	_gcry_cms_kem_decap.
	* src/gcrypt.h.in: Add constants for ECC KEM.
	* tests/t-kem.c (test_kem_raw_x25519, test_kem_dhkem_x25519)
	(test_kem_openpgp_x25519, test_kem_cms_x25519): New.
	(check_kem, main): Add tests for ECC KEM.

2024-03-27  NIIBE Yutaka  <gniibe@fsij.org>
	    Falko Strenzke  <falko.strenzke@mtg.de>

	tests:basic: Add cSHAKE test vectors.
	+ commit b81076beba280c24923b0259a8973c777204c5df
	* tests/basic.c (check_one_md): Extend with customization N and S.
	(check_one_md_multi): Likewise.
	(check_digests): Add test vectors for GCRY_MD_CSHAKE128 and
	GCRY_MD_CSHAKE256.

2024-03-27  NIIBE Yutaka  <gniibe@fsij.org>

	md: Add cSHAKE digest algorithm and the implementation.
	+ commit 065b3f4e0271cc410c002842ea640f93e56c6a20
	* src/gcrypt.h.in (gcry_ctl_cmds): Add GCRYCTL_MD_CUSTOMIZE.
	(gcry_md_algos): Add GCRY_MD_CSHAKE128 and GCRY_MD_CSHAKE256.
	(struct gcry_cshake_customization): New.
	* cipher/keccak.c (CSHAKE_DELIMITED_SUFFIX): New.
	(keccak_init): Support GCRY_MD_CSHAKE128 and GCRY_MD_CSHAKE256.
	(selftests_keccak): Likewise.
	(cshake_input_n, cshake_input_s, _gcry_cshake_customize): New.
	(cshake128_init, cshake256_init, cshake_hash_buffers): New.
	(_gcry_cshake128_hash_buffers, _gcry_cshake256_hash_buffers): New.
	(_gcry_digest_spec_cshake128, _gcry_digest_spec_cshake256): New.
	* cipher/md.c (digest_list): Add cSHAKE md_specs.
	(digest_list_algo301): Likewise.
	(md_customize): New.
	(_gcry_md_ctl): Support GCRYCTL_MD_CUSTOMIZE.
	* src/cipher.h (_gcry_cshake_customize): New.
	(_gcry_digest_spec_cshake128, _gcry_digest_spec_cshake256): New.
	* src/fips.c (_gcry_fips_indicator_md): Support GCRY_MD_CSHAKE128 and
	GCRY_MD_CSHAKE256.
	* tests/basic.c (check_one_md): Support GCRY_MD_CSHAKE128 and
	GCRY_MD_CSHAKE256 as xof.
	(check_one_md_multi): Exclude GCRY_MD_CSHAKE128 and GCRY_MD_CSHAKE256
	as xof.
	* tests/bench-slope.c (hash_bench, kdf_bench): Exclude
	GCRY_MD_CSHAKE128 and GCRY_MD_CSHAKE256.
	* tests/benchmark.c (md_bench): Exclude GCRY_MD_CSHAKE128 and
	GCRY_MD_CSHAKE256.

2024-03-11  NIIBE Yutaka  <gniibe@fsij.org>

	Add gcry_md_hash_buffers_ext function.
	+ commit 3d48e6e37b040c955a84e58ce3147562fa74d1f3
	* src/gcrypt.h.in (gcry_md_hash_buffers_ext): New.
	* src/libgcrypt.def: Add gcry_md_hash_buffers_ext.
	* src/libgcrypt.vers: Likewise.
	* src/visibility.c: Add gcry_md_hash_buffers_ext.
	* src/visibility.h: Add gcry_md_hash_buffers_ext.

2024-03-05  NIIBE Yutaka  <gniibe@fsij.org>

	kem: Fix the previous commit.
	+ commit f4bcc69c3c9b0c2c948a9944cec7894cb590b211
	* cipher/kem.c (kem_compute_keygrip): Rever the change.

2024-03-04  NIIBE Yutaka  <gniibe@fsij.org>

	cipher: Fix Kyber key in SEXP, and its keygrip computation.
	+ commit 47c594386ebec3f9dea2d091c38cc7768a1840d9
	* cipher/kem.c (kem_generate): Include public key part in SEXP of
	private key.
	(kem_compute_keygrip): Fix keygrip computation.

	mpi: Fix ECC computation on hppa.
	+ commit b757f4130af987bdfc769b754b6e9e27882c349c
	* mpi/ec-inline.h [__hppa] (ADD4_LIMB32, SUB4_LIMB32): New.
	* mpi/longlong.h [__hppa] (add_ssaaaa, sub_ddmmss): Add __CLOBBER_CC.

2024-03-03  NIIBE Yutaka  <gniibe@fsij.org>

	tests: Fix the previous commit.
	+ commit 23ccf8eafbc452fa5cf466bee219846400bd2424
	* tests/keygen.c (check_kem_keys): Those are not yet in the standard.

2024-03-02  NIIBE Yutaka  <gniibe@fsij.org>

	tests: Fix keygen for FIPS mode.
	+ commit 58f93ea56f7173a5fc3f85710dbf167cb0e5e203
	* tests/keygen.c (check_kem_keys): Care about FIPS mode.

2024-02-29  NIIBE Yutaka  <gniibe@fsij.org>

	mpi: Silence warning for some architecture.
	+ commit 813a96de4ffec5d72dbb4473a42bd2b5b3f56b50
	* mpi/mpih-const-time.c (mpih_ct_limb_greater_than): DIFF_LO is not
	used.

2024-02-22  Werner Koch  <wk@gnupg.org>

	cipher: Add a way to get a keygrip for KEM algos.
	+ commit 4db7f3b07be5fc7b4c1c3b2e7548167cb1968533
	* src/gcrypt.h.in (GCRY_PK_KEM): New.
	* cipher/kem.c (kem_infos): New.
	(kem_names): New.
	(kem_generate): New.
	(kem_compute_keygrip): New.
	(kem_get_nbits): New.
	(_gcry_pubkey_spec_kem): New.
	* cipher/pubkey.c (pubkey_list): Add spec for KEM.
	* src/cipher.h (_gcry_pubkey_spec_kem): Declare.
	(_gcry_pubkey_spec_elg_e): Remove this used declaration.

	* tests/keygen.c (check_generated_kem_key): New.
	(check_kem_keys): New.
	(main): Add optional argument kem and all new function.

	cipher: Slight refactoring of kem.c.
	+ commit b36aee33dd00906a98d5d1295bf471140844f737
	* cipher/kem.c (_gcry_kem_keypair): Do not claim used variables.
	Slight refactoring to allow for a enum-case check.
	(_gcry_kem_encap): Ditto.
	(_gcry_kem_decap): Ditto.

	* cipher/kyber.h (crypto_kem_keypair_3) [KYBER_K]: Fix syntax error.

2024-02-09  Clemens Lang  <cllang@redhat.com>

	sha3: Fill OIDs and partial ASN.1 structs.
	+ commit b3750fb42a44760e65d8869bc9a64e79197ae96d
	* cipher/keccak.c (sha3_224_asn): New.
	(oid_spec_sha3_224, oid_spec_sha3_256): Update the OIDs.
	(sha3_256_asn): Have a correct value.
	(sha3_384_asn): Have a correct value.
	(oid_spec_sha3_384, oid_spec_sha3_512): Update the OIDs.
	(sha3_512_asn): Have a correct value.
	(shake128_asn): Have a correct value.
	(oid_spec_shake128, oid_spec_shake256): Update the OIDs.
	(shake256_asn): Have a correct value.

2024-02-06  Werner Koch  <wk@gnupg.org>

	doc: Fix link to the s-expression description.
	+ commit 52f18b9ffe6ce38eba159c39550c10a95bce3d11
	Note that there is also thr description at

	 https://people.csail.mit.edu/rivest/pubs
	 /RL96.ver-1.1.html#secSexpressions

2024-02-04  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	Fix Kyber segfaulting on Win64.
	+ commit 0929a9f1ede27dc6c629a92d92002da14eafa68a
	* cipher/kyber.c (prg, pkprf): Cast variadic parameters to expected
	types ('void *' and 'size_t').

	rijndael-s390x: fix AES256-XTS feature mask.
	+ commit 679b07898897e16029dbf596dbcf0141ebb99792
	* cipher/rijndael-s390x.c (_gcry_aes_s390x_setup_acceleration): Fix
	AES256-XTS feature mask.

2024-01-30  NIIBE Yutaka  <gniibe@fsij.org>

	cipher:kdf: Add X963KDF for use in CMS.
	+ commit 3abac420b30ad4aeef803b23995303ac6bb563fa
	* src/gcrypt.h.in (gcry_kdf_algos): Add GCRY_KDF_X963_KDF.
	* cipher/kdf.c (x963_kdf_open, x963_kdf_compute): New.
	(x963_kdf_final, x963_kdf_close): New.
	(_gcry_kdf_open, _gcry_kdf_final, _gcry_kdf_close): Add
	support for GCRY_KDF_X963_KDF.

	Fix the version script for non-existing symbols.
	+ commit be328b4a3476d5cbe543a761c043c5923ea1e280
	* src/libgcrypt.vers: Remove gcry_md_get and gcry_pk_register.

2024-01-29  NIIBE Yutaka  <gniibe@fsij.org>

	build: Use @FGREP@ by configure for libgcrypt-config.
	+ commit 128121e74b66793fabd24e478df6ea2ab568e24a
	* configure.ac (AC_PROG_FGREP): Add.
	* src/libgcrypt-config.in: Use @FGREP@.

2024-01-16  NIIBE Yutaka  <gniibe@fsij.org>

	tests: Fix tests/basic.
	+ commit 86812491c7541a6e76cc2f2c45538b4715121b88
	* tests/basic.c (check_ecb_cipher): Use 'i' instead of '0'.

	m4: Update acinclude.m4 to use $GREP.
	+ commit 656ca459e3d87f91dc20a2fb1001344f4c872ee3
	* acinclude.m4: Use $GREP, instead of egrep.  Simplify the detection.

2024-01-15  NIIBE Yutaka  <gniibe@fsij.org>

	cipher: Fix copyright notices for LGPL.
	+ commit 2eaaa8846f226ccd54f3165afe10583936d9d940
	* cipher/kem.c: Fix LGPL name, with correct capitalizing..
	* cipher/kyber-common.c: Likewise.
	* cipher/kyber-kdep.c: Likewise.
	* cipher/kyber.c: Likewise.
	* cipher/kyber.h: Likewise.
	* cipher/sntrup761.c: Likewise.
	* cipher/sntrup761.h: Likewise.

	tests: Add known answers test for ML-KEM (Kyber).
	+ commit 6765916e3b55dc45d93123e789973c7528df5232
	* tests/Makefile.am (tests_bin): Add t-mlkem.
	(EXTRA_DIST): Add t-mlkem.inp.
	* tests/t-mlkem.c: New.
	* tests/t-mlkem.inp: New.

	cipher:kyber: Fix comment style.
	+ commit 384638bc4a0dd4315ce2955d08f51f007ba88df9
	* cipher/kyber-common.c: Fix comments.
	* cipher/kyber-kdep.c: Likewise.
	* cipher/kyber.c: Likewise.

	cipher: Add use of the Kyber implementation.
	+ commit f2f9d56358acf3b38764bc4465db627162f42bbf
	* cipher/Makefile.am (EXTRA_DIST): Add kyber-common.c kyber-kdep.c.
	(libcipher_la_SOURCES): Add kyber.c and kyber.h.
	* cipher/kem.c (_gcry_kem_keypair): Add call to kyber_keypair.
	(_gcry_kem_encap): Add call to kyber_encap.
	(_gcry_kem_decap): Add call to kyber_decap.
	* tests/t-common.h (show_note): Factor from existing uses.
	(show_sexp, prepend_srcdir, read_textline, copy_data): Likewise.
	(hex2buffer, reverse_buffer): Likewise.
	* tests/t-kem.c (show_note): Remove.
	(test_kem_sntrup761): Rename from test_kem.
	(test_kem_mlkem512, test_kem_mlkem768, test_kem_mlkem1024): New.
	(check_kem): Add N_LOOPS argument.  Call relevant tests by the
	variable SELECTED_ALGO.
	(main): Add option handling to select testing specific algorithm.

	cipher:kyber: Modify VERIFY function.
	+ commit 5c9c4dca39f2806443aaec60972e648715d3b048
	* cipher/kyber-kdep.c (crypto_kem_dec): Use verify1.
	* cipher/kyber.c (verify1): Return 1 when success.

	cipher:kyber: Modification for xof_ routines.
	+ commit fe3ecf810370086df40f4cc980d0a290e5f3a9a5
	* cipher/kyber-kdep.c (gen_matrix): Remove comment for
	gen_matrix.  Add calls to xof_init and xof_close.

	cipher:kyber: Integrate into libgcrypt, adding glue code.
	+ commit 4e9aa70078c5537f1c56f54e78d769c8b5dc9f0c
	* cipher/kyber-common.c: Add copyright notice.
	* cipher/kyber-kdep.c: Likewise.
	* cipher/kyber.c: Likewise.
	* cipher/kyber-kdep.c: Add #undef to clear the definitions.
	* cipher/kyber.c: Integrate into libgcrypt, also allow standalone use.

	cipher:kyber: Have cipher/kyber.h.
	+ commit 31743c17d7bd1f6dc653e6dfcf76fab5356649ae
	* cipher/kyber.h: New.

	cipher:kyber: Move declarations to kyber-kdep.c.
	+ commit b6e20ed580e08278eb963a87f6355c43ba0d34d2
	* cipher/kyber.c: Move KYBER_K-dependent declarations into...
	* cipher/kyber-kdep.c: ... here, or kyber.h.

	cipher:kyber: Functions in poly for different KYBER_K.
	+ commit efd55d9ecae549318425dc7a867c9698cbc78410
	* cipher/kyber-common.c (load24_littleendian, cbd3): Fix the
	compile-time condition.
	(poly_cbd_eta1, poly_cbd_eta2): Remove.
	(zetas): Don't export.
	(poly_compress): Remove.
	(poly_compress_128, poly_compress_160): New.
	(poly_decompress): Remove.
	(poly_decompress_128, poly_decompress_160): New.
	(poly_getnoise_eta1): Remove.
	(poly_getnoise_eta1_2): New.  Directly call cbd3.
	(poly_getnoise_eta1_3_4): New.  Directly call cbd2.
	(poly_getnoise_eta2):  Directly call cbd2.
	* cipher/kyber.c: Fix declarations for poly_compress,
	poly_decompress and poly_getnoise_eta1.

	cipher:kyber: Make the implementation into three files.
	+ commit 01a14c0df2957900903895a3c49de2bdb708816f
	* cipher/kyber-common.c: New.  Common part.
	* cipher/kyber-kdep.c: New. KYBER_K dependent part.
	* cipher/kyber.c: Move functions and variables to two files.

	cipher:kyber: Constants common and k-dependent.
	+ commit fc35a5372a74c696f45b10dccbb84331673412b4
	* cipher/kyber.c (KYBER_ETA1): Remove.
	(KYBER_ETA1_2, KYBER_ETA1_3_4): New.
	(KYBER_POLYCOMPRESSEDBYTES): Remove.
	(KYBER_POLYCOMPRESSEDBYTES_2_3): New.
	(KYBER_POLYCOMPRESSEDBYTES_4): New.

	cipher:kyber: Export the KEM API only.
	+ commit 34dd0a1a75b2ee37ccd1215235f8b9f00f38bff1
	* cipher/kyber.c: Don't export other functions and data.

	cipher: Editorial clean up cipher/kyber.c for headers.
	+ commit 4b601fe5b3cff021e265df6eb64911e6a8105bd3
	* cipher/kyber.c: Clean up.

	cipher: Add headers to Kyber implementation.
	+ commit 10e9bcd5c67ed40292b06901b38fa9b94ccc09ba
	* cipher/kyber.c: Add headers from the reference implementation.

	cipher: Put the original Kyber implementation.
	+ commit 18e5c0d268b1aeac59f526b9730b39520750ca14
	* cipher/kyber.c: Kyber reference implementation.

	cipher: Allow standalone use of SNTRUP761 implementation.
	+ commit bdadd65d440b7f689f49450530a548c32007f71b
	* cipher/sntrup761.c [HAVE_CONFIG_H]: Conditionalize.

2024-01-08  NIIBE Yutaka  <gniibe@fsij.org>

	Avoid use of C99 feature for enum.
	+ commit dbfb7cc76ef3f98fe62f0549b97d76f395864ae0
	* src/gcrypt.h.in (enum gcry_kdf_algos): Remove last comma.
	(enum gcry_kem_algos): Likewise.

2023-12-21  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	bench-slope: restore compiler barriers for auto-GHZ check.
	+ commit c9cb10f3be226dfd65c670ff2565d81dfc668376
	* tests/bench-slope.c (auto_ghz_bench): Add memory barriers to
	AUTO_GHZ_OPERATION macro when barrier is supported by compiler.

	mpi/ec-inline: refactor i386 assembly to reduce register usage.
	+ commit 956f1ed4ec6ead59dc56f574f943f1fe25dac723
	* mpi/ec-inline.h [__i386__] (ADD2_LIMB32_CARRY_OUT)
	(ADD2_LIMB32_CARRY_IN_OUT, ADD2_LIB32_CARRY_IN, SUB2_LIMB32_CARRY_OUT)
	(SUB2_LIMB32_CARRY_IN_OUT, SUB2_LIB32_CARRY_IN, ADD8_LIMB32)
	(ADD10_LIMB32, ADD14_LIMB32, SUB8_LIMB32, SUB10_LIMB32)
	(SUB14_LIMB32): New.
	[__i386__] (ADD4_LIMB32, ADD6_LIMB32, SUB4_LIMB32, SUB6_LIMB32): Rewrite
	to use new *_CARRY_* macros.
	[BYTES_PER_MPI_LIMB == 4] (ADD4_LIMB64): Use ADD8_LIMB32 if available.
	[BYTES_PER_MPI_LIMB == 4] (ADD5_LIMB64): Use ADD10_LIMB32 if available.
	[BYTES_PER_MPI_LIMB == 4] (ADD7_LIMB64): Use ADD14_LIMB32 if available.
	[BYTES_PER_MPI_LIMB == 4] (SUB4_LIMB64): Use SUB8_LIMB32 if available.
	[BYTES_PER_MPI_LIMB == 4] (SUB5_LIMB64): Use SUB10_LIMB32 if available.
	[BYTES_PER_MPI_LIMB == 4] (SUB7_LIMB64): Use SUB14_LIMB32 if available.

2023-12-16  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	mpi/ec-nist: fix for -Og build failure on i386.
	+ commit 90097bd2f41c217dc5c666570e5680f432cf92d3
	* mpi/ec-nist.c (_gcry_mpi_ec_nist256_mod)
	(_gcry_mpi_ec_nist384_mod): Load p_mult constant with carry offset
	to stack.

2023-12-12  NIIBE Yutaka  <gniibe@fsij.org>

	tests: Update digest values following input changes.
	+ commit 4a104752d8a2f0ca15d7873011a14226925a773b
	* tests/basic.c (check_digests): Update the values.

2023-12-12  Andreas Metzler  <ametzler@bebt.de>

	Point to gnu.org as canonical license location.
	+ commit cd056b4d1614e9e245b66782b54aad1697e22a01


	Fix license header inconsistency.
	+ commit 25e93a02268b9f533b1ffa4f6a5fe47d686e2145


	Unify capitalization of LGPL copyright statements.
	+ commit ca5689367a837b6541307f6ae19e0176b051d06f


2023-12-08  NIIBE Yutaka  <gniibe@fsij.org>

	cipher: Fix sntrup761.h, so that it can be used outside.
	+ commit ebc9aaacd62bbc7f048020531398ccb9f97e4437
	* cipher/sntrup761.h [_GCRYPT_IN_LIBGCRYPT]: Ifdef-out
	libgcrypt specific glue code.  Recover the constants.

	cipher: Minor fix for C90 compiler.
	+ commit 2149888d47afea9946c3a748310ad27dfcda48c3
	* cipher/sntrup761.c (crypto_sort_int32): Declare A, before its use.

2023-12-07  NIIBE Yutaka  <gniibe@fsij.org>

	cipher: Add sntrup761 to KEM API.
	+ commit 947ad42450eadec079a1c50deba90e6453f0113c
	* cipher/kem.c (sntrup761_random): New glue code.
	( _gcry_kem_keypair, _gcry_kem_encap, _gcry_kem_decap): Call sntrup761
	functions.
	* cipher/sntrup761.h: Add glue code to libgcrypt.
	* src/visibility.h: Update for KEM functions.
	* tests/t-kem.c: Fix for the final KEM API.

2023-12-07  Simon Josefsson  <simon@josefsson.org>

	cipher: Add Streamlined NTRU Prime sntrup761.
	+ commit cf9923e1a59f2f535311f3676345d34e593ba108
	* cipher/Makefile.am (libcipher_la_SOURCES): Add sntrup761.c and h.
	* cipher/sntrup761.c: New.
	* tests/Makefile.am (tests_bin): Add t-kem.
	* tests/t-kem.c: New.

2023-12-07  NIIBE Yutaka  <gniibe@fsij.org>

	Add an API for Key Encapsulation Mechanism.
	+ commit 7e503fa9170fd290105714d15a335f7748860e23
	* cipher/Makefile.am (libcipher_la_SOURCES): Add kem.c.
	* cipher/kem.c: New.
	* src/gcrypt-int.h (_gcry_kem_keypair, _gcry_kem_encap)
	(_gcry_kem_decap): New.
	* src/gcrypt.h.in (gcry_kem_keypair, gcry_kem_encap)
	(gcry_kem_decap): New.  Add constants.
	* src/libgcrypt.def (gcry_kem_keypair, gcry_kem_encap)
	(gcry_kem_decap): Add symbols.
	* src/libgcrypt.vers: Likewise.

2023-11-22  NIIBE Yutaka  <gniibe@fsij.org>

	tests: Fix t-x448 for error handling.
	+ commit dc1c916da4ba3960495bca450d8f4bc6897d9167
	* tests/t-x448.c (test_cv_x448): Take the error code from ERR.

2023-11-16  NIIBE Yutaka  <gniibe@fsij.org>

	cipher: Fix return type of _gcry_ecc_mul_point.
	+ commit 354e53558e55fe5bc8fa4be32e1c1bace7623536
	* cipher/ecc-ecdh.c (_gcry_ecc_mul_point): Return gpg_err_code_t.
	* src/gcrypt-int.h (_gcry_ecc_mul_point): Return gpg_err_code_t.
	* src/visibility.c (gcry_ecc_mul_point): Follow the change.

2023-11-04  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	mpih_mod: avoid unintentional conditional branch.
	+ commit 39d5364a9557d6f423de117601cb1e6414814f47
	* mpi/mpih-const-time.c (_gcry_mpih_mod): Avoid conditional branch
	on the_bit extraction.

	mpih-const-time: use constant-time comparisons conditional add/sub/abs.
	+ commit c419a04d529af7b5fb43732ec2b4304166c2579a
	* mpi/mpih-const-time.c (mpih_ct_limb_greater_than)
	(mpih_ct_limb_less_than): New.
	(_gcry_mpih_add_n_cond, _gcry_mpih_sub_n_cond, _gcry_mpih_abs_cond): Use
	mpih_ct_limb_greater_than and mpih_ct_limb_less_than for comparisons.

	const-time: add functions for generating masks from 0/1 input.
	+ commit cf757cf90e9ae966b95dcebfd2f31b9212697f0c
	* mpi/ec-nist.c (_gcry_mpi_ec_nist192_mod, _gcry_mpi_ec_nist224_mod)
	(_gcry_mpi_ec_nist256_mod, _gcry_mpi_ec_nist384_mod): Use mask generating
	functions.
	* mpi/mpi-internal.h (ct_limb_gen_mask, ct_limb_gen_inv_mask): New.
	* mpi/mpih-const-time.c (_gcry_mpih_set_cond, _gcry_mpih_add_n_cond)
	(_gcry_mpih_sub_n_cond, _gcry_mpih_sub_n_cond, _gcry_mpih_swap_cond): Use
	mask generating functions.
	* mpi/mpiutil.c (_gcry_mpi_set_cond, _gcry_mpi_swap_cond): Use mask
	generating functions.
	* src/const-time.h (DEFINE_CT_TYPE_GEN_MASK, ct_uintptr_gen_mask)
	(ct_ulong_gen_mask, DEFINE_CT_TYPE_GEN_INV_MASK, ct_uintptr_gen_inv_mask)
	(ct_ulong_gen_inv_mask): New.
	(DEFINE_CT_TYPE_SELECT_FUNC): Use mask generating functions.
	* src/const-time.c (_gcry_ct_memmov_cond): Use mask generating functions.

	ec: avoid unintentional condition branches for 25519, 448 and 256k1.
	+ commit 305a65c1ede8f78160100478d46efa199d334a64
	* mpi/ec.c (ec_addm_25519, ec_subm_25519, ec_mulm_25519, ec_addm_448)
	(ec_subm_448, ec_mulm_448, ec_secp256k1_mod): Use mpih_limb_is_zero
	and mpih_limb_is_not_zero instead of comparison to zero.

	ec-nist: avoid unintentional conditional branch by comparison.
	+ commit a9e7aa647e4b84964c76230370d71235383e5c2d
	* mpi/ec-nist.c (_gcry_mpi_ec_nist521_mod): Use mpih_limb_is_not_zero.
	* mpi/mpi-internal.h (mpih_limb_is_not_zero): New.

	mpih_cmp_ui: avoid unintentional conditional branch.
	+ commit aab6a42d5f44724b73a02598546a5e7d8b33298e
	* mpi/mpi-internal.h (mpih_limb_is_zero): New.
	* mpi/mpih-const-time.c (_gcry_mpih_cmp_ui): Use mpih_limb_is_zero
	instead of comparison.

	ec-nist: use global vone and vzero.
	+ commit 5c5ba1ec2b505726ee1311339ac9e8b5c62cac4a
	* mpi/ec-nist.c (vzero, vone): Remove.
	(_gcry_mpi_ec_nist192_mod, _gcry_mpi_ec_nist224_mod)
	(_gcry_mpi_ec_nist256_mod, _gcry_mpi_ec_nist384_mod): Use _gcry_ct_vzero
	and _gcry_ct_vone.

	mpiutil: use global vone and vzero.
	+ commit d4aee9ace9a904446b987dddc2999119c4d62dae
	* mpi/mpiutil.c (_gcry_mpi_set_cond, _gcry_mpi_swap_cond): Use
	_gcry_ct_vzero and _gcry_ct_vone.

	mpih-const-time: use global vzero/vone variable.
	+ commit 179df341162c74da312f76363a0ff1f2f303aa78
	* mpi/mpih-const-time.c (vzero, vone): Remove.
	(_gcry_mpih_set_cond, _gcry_mpih_add_n_cond, _gcry_mpih_sub_n_cond)
	(_gcry_mpih_swap_cond, _gcry_mpih_abs_cond): Use _gcry_ct_vzero and
	_gcry_ct_vone.

	const-time: ct_memmov_cond: switch to use dual mask approach.
	+ commit 4d3e0e30b98b2acb90acb2792b8327c26824a66f
	* src/const-time.c (_gcry_ct_memmov_cond): Use dual mask + AND/OR
	instead of single mask + XOR.

	const-time: prefix global symbols with _gcry_
	+ commit 22dde5150ee2be01651410ed9756601ba6a29c93
	* cipher/const-time.c (ct_not_memequal, ct_memequal)
	(ct_memmov_cond): Rename these to ...
	(_gcry_ct_not_memequal, _gcry_ct_memequal)
	(_gcry_ct_memmov_cond): ... these.
	* cipher/const-time.h (ct_not_memequal, ct_memequal)
	(ct_memmov_cond): Rename these to ...
	(_gcry_ct_not_memequal, _gcry_ct_memequal)
	(_gcry_ct_memmov_cond): ... these.
	(ct_not_memequal, ct_memequal, ct_memmov_cond): New macros.

	mpih_set_cond: restore EM leakage mitigation.
	+ commit 0c6ec6bbe788b8c4a6982b2128d442b51323c898
	* mpi/mpih-const-time.c (_gcry_mpih_set_cond): Replace single mask + XOR
	with dual mask + AND/OR; Add comment about reason for dual mask usage.
	(_gcry_mpih_add_n_cond, _gcry_mpih_sub_n_cond, _gcry_mpih_swap_cond)
	(_gcry_mpih_abs_cond): Add comment about reason for dual mask usage.

	rsa, elgamal: avoid logical not operator in constant-time code.
	+ commit 84f934c09afac18b3f4351646c0fe6f93aede277
	* cipher/elgamal.c (elg_decrypt): Replace ! operator with calls to
	ct_is_not_zero/ct_is_zero/ct_ulong_select.
	* cipher/rsa-common.c (_gcry_rsa_pkcs1_decode_for_enc): Replace !
	operator with call to ct_is_zero.
	* cipher/rsa.c (rsa_decrypt): Replace ! operator with calls to
	ct_is_not_zero/ct_is_zero/ct_ulong_select.
	* src/const-time.c (_gcry_ct_vzero, _gcry_ct_vone): New.
	* src/const-time.h (_gcry_ct_vzero, _gcry_ct_vone): New.
	(ct_is_not_zero, ct_is_zero, DEFINE_CT_TYPE_SELECT_FUNC)
	(ct_uintptr_select, ct_ulong_select): New.
	(sexp_null_cond): Use ct_uintptr_select.

	const-time: always avoid comparison operator for byte comparison.
	+ commit 137e35ad47ee8734d0f3ffb6af1d1669c4621e0b
	* configure.ac: Remove POSSIBLE_CONDITIONAL_BRANCH_IN_BYTE_COMPARISON
	macro.
	* src/const-time.h (ct_not_equal_byte): Remove
	POSSIBLE_CONDITIONAL_BRANCH_IN_BYTE_COMPARISON ifdef.

	Use single constant-time memory comparison implementation.
	+ commit 1e9ddbd65c4627235611d75c3198c4ec197c9a05
	* src/const-time.c (ct_not_memequal): Use original 'buf_eq_const'
	implementation here.
	(ct_memequal): New.
	* cipher/bufhelp.h (buf_eq_const): Call to 'ct_memequal'.

2023-11-01  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	bench-slope: update auto-GHZ for alderlake-P.
	+ commit a047a9c7d10824593d5c9ae43d8a3d6319ef3c0b
	* tests/bench-slope.c (vone): New.
	(auto_ghz_bench): Remove memory barrier usage; Generate constant
	values from volatile variable.

2023-10-31  NIIBE Yutaka  <gniibe@fsij.org>

	cipher: Fix ElGamal decryption.
	+ commit 6d1d50ba3aad1850975f717adbedb4cb8b236fa7
	* cipher/elgamal.c (elg_decrypt): Call sexp_build always.
	* cipher/rsa.c (rsa_decrypt): Return an error code of sexp_build
	when RC != 0.

	rsa: Use memmov_independently when unpadding.
	+ commit 58b62be844549ad3d57c507d834027f1e2756567
	* cipher/rsa-common.c (memmov_independently): New.
	(_gcry_rsa_pkcs1_decode_for_enc): Use memmov_independently.
	(_gcry_rsa_oaep_decode): Use memmov_independently.

	const-time: Add ct_memmov_cond, fix _gcry_mpih_set_cond.
	+ commit bd08357436a9559766cd458d25781ee4f94012a2
	* src/const-time.c (ct_memmov_cond): New.
	* src/const-time.h (ct_memmov_cond): New.
	* mpi/mpih-const-time.c (_gcry_mpih_set_cond): Use XOR and a MASK.

2023-10-30  NIIBE Yutaka  <gniibe@fsij.org>

	const-time: Use ct_not_memequal, instead.  Tested with AVR.
	+ commit c31b70b2660c3d24bd54ee08c255c36d867fdea7
	* cipher/rsa-common.c (_gcry_rsa_oaep_decode): Use ct_not_memequal.
	* src/const-time.c (ct_not_memequal): Use ct_not_equal_byte.
	* src/const-time.h (ct_not_memequal): Rename from ct_memequal.

	build: Check if arch is VAX or compiler is MSVC.
	+ commit c848459e512615c1865a23cf24debb3ad4a1e85b
	* configure.ac (AH_BOTTOM): Add check for VAX and MSVC.
	* src/const-time.h (POSSIBLE_CONDITIONAL_BRANCH_IN_BYTE_COMPARISON):
	Rename.

2023-10-27  NIIBE Yutaka  <gniibe@fsij.org>

	rsa: Fix decoding of PKCS#1 v1.5 and OAEP padding.
	+ commit 34c20427926010d6fa95b1666e4b1b60f60a8742
	* src/Makefile.am (libgcrypt_la_SOURCES): Add const-time.h and
	const-time.c.
	* src/const-time.h (ct_not_equal_byte, sexp_null_cond): New.
	(ct_memequal): New from NetBSD, modified return type and name.
	* src/const-time.c: New.
	* cipher/rsa-common.c (_gcry_rsa_pkcs1_decode_for_enc): Examine whole
	sequence of the byte-array.  Use N0 to find the separator position, with
	ct_not_equal_byte.  Return the MPI even when the case of an error.
	* cipher/rsa-common.c (_gcry_rsa_oaep_decode): Use ct_memequal to
	check LHASH.  Examine all the sequence of the byte-array.  Use N1 to
	find the separator of 0x01.  Return the MPI even when the case of an
	error.
	* cipher/rsa.c (rsa_decrypt): Always build a SEXP.

2023-10-06  NIIBE Yutaka  <gniibe@fsij.org>

	sexp: Minor clean-up of sexp output handling.
	+ commit 5e5dff0551fcd9a826db18188fa1e4a6ca45099a
	* src/sexp.c (suitable_encoding): Remove check for starting zero.

2023-10-05  NIIBE Yutaka  <gniibe@fsij.org>

	doc: Minor style fixes.
	+ commit edddc5738e6b1652ccc5db6861888de66112427f


	sexp: String with \0 is considered "binary".
	+ commit ddd41eb6ace02626b0bf7704fdec9b765fb717c4
	* src/sexp.c (suitable_encoding): It's "binary" when
	the buffer contains '\0'.

2023-09-15  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	blake2-avx512: merge some of the gather loads.
	+ commit 325786acd445f9e74e4c44ba86c5b4e06788ea46
	* cipher/blake2b-amd64-avx512.S (GATHER_MSG_2, GATHER_MSG_3)
	(GATHER_MSG_5, GATHER_MSG_6, GATHER_MSG_8, GATHER_MSG_9): New.
	(LOAD_MSG_2, LOAD_MSG_3, LOAD_MSG_5, LOAD_MSG_6, LOAD_MSG_8)
	(LOAD_MSG_9): Use GATHER_MSG_<number>.
	(_blake2b_avx512_data): Add merged load masks ".L[4-7]_mask".
	(_gcry_blake2b_transform_amd64_avx512): Load merged load masks
	to %k[4-7] and clear registers on exit.
	* cipher/blake2s-amd64-avx512.S (VPINSRD_KMASK, GATHER_MSG_2)
	(GATHER_MSG_3, GATHER_MSG_5, GATHER_MSG_6, GATHER_MSG_8)
	(GATHER_MSG_9): New.
	(LOAD_MSG_2, LOAD_MSG_3, LOAD_MSG_5, LOAD_MSG_6, LOAD_MSG_8)
	(LOAD_MSG_9): Use GATHER_MSG_<number>.
	(_blake2s_avx512_data): Add merged load masks ".L[4-7]_mask".
	(_gcry_blake2s_transform_amd64_avx512): Load merged load masks
	to %k[4-7] and clear registers on exit.

2023-09-01  NIIBE Yutaka  <gniibe@fsij.org>

	build: Change the default for --with-libtool-modification.
	+ commit 36d014f919d1c5f00dde4509da9b5e02895467c9
	* configure.ac (--with-libtool-modification): default=never.

2023-08-20  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	blake2b-avx512: replace VPGATHER with manual gather.
	+ commit 59f14c1db37e16aba37af185dd0677f9783536ce
	* cipher/blake2.c (blake2b_init_ctx): Remove HWF_INTEL_FAST_VPGATHER
	check for AVX512 implementation.
	* cipher/blake2b-amd64-avx512.S (R16, VPINSRQ_KMASK, .Lshuf_ror16)
	(.Lk1_mask): New.
	(GEN_GMASK, RESET_KMASKS, .Lgmask*): Remove.
	(GATHER_MSG): Use manual gather instead of VPGATHER.
	(ROR_16): Use vpshufb for small speed improvement on tigerlake.
	(_gcry_blake2b_transform_amd64_avx512): New setup & clean-up for
	kmask registers; Reduce excess loop aligned from 64B to 16B.

	twofish-avx2-amd64: replace VPGATHER with manual gather.
	+ commit ded3a1ec2ec6980750e3e9eabde001cdbebece51
	* cipher/twofish-avx2-amd64.S (do_gather): New.
	(g16): Switch to use 'do_gather' instead of VPGATHER instruction.
	(__twofish_enc_blk16, __twofish_dec_blk16): Prepare stack
	for 'do_gather'.
	* cipher/twofish.c (twofish) [USE_AVX2]: Remove now unneeded
	HWF_INTEL_FAST_VPGATHER check.

	Avoid VPGATHER usage for most of Intel CPUs.
	+ commit f2bf9997d46590e688bad213267b8fb466e95ecd
	* cipher/blake2.c (blake2b_init_ctx): Check for fast VPGATHER
	for AVX512 implementation.
	* src/hwf-x86.c (detect_x86_gnuc): Do not enable
	HWF_INTEL_FAST_VPGATHER for Intel CPUs suffering from
	"Downfall" vulnerability.

2023-08-16  NIIBE Yutaka  <gniibe@fsij.org>

	build: New configure option --with-libtool-modification.
	+ commit 2143503b8f56a4e6909dc8b4f86e20c8ad76aaed
	* Makefile.am (EXTRA_DIST): Add build-aux/libtool-patch.sed.
	* build-aux/libtool-patch.sed: New.
	* configure.ac (--with-libtool-modification): New.
	* build-aux/ltmain.sh: Revert our own local modification.

2023-07-26  NIIBE Yutaka  <gniibe@fsij.org>

	doc: yat2m-stamp should depend on version.texi.
	+ commit f019c98fd418596074ffd2cc755be6c483aac932
	* doc/Makefile.am (yat2m-stamp): Depend on version.texi.

2023-07-17  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	hwf-x86: use CFI statements for 'is_cpuid_available'
	+ commit a5f88f30ce612b0239b946c4424d81cf0d552e96
	* src/hwf-x86.c (FORCE_FUNC_FRAME_POINTER): Remove.
	(CFI_ADJUST_CFA_OFFSET, CFI_PUSH4, CFI_POP4): New.
	(is_cpuid_available): Use CFI statements instead of frame-pointer
	attribute.

	configure: fix HAVE_GCC_ASM_CFI_DIRECTIVES check.
	+ commit 35829d38d61fa3130d88eaeea1af2591a3f07208
	* cipher/camellia-aesni-avx2-amd64.h (enc_blk1_32): Fix dual
	CFI_ENDPROC() usage.
	* configure.ac (gcry_cv_gcc_asm_cfi_directives): Add missing ';'
	after 'void asmfunc(void)'.
	* mpi/asm-common-i386.h: New.
	* mpi/i386/syntax.h: Remove CFI macros and instead include
	"asm-common-i386.h".

	Add VAES/AVX2 accelerated i386 implementation for AES.
	+ commit 4a42a042bcf6b25f13957207c2d13d420f450bb8
	* cipher/Makefile.am: Add 'rijndael-vaes-i386.c' and
	'rijndael-vaes-avx2-i386.S'.
	* cipher/asm-common-i386.h: New.
	* cipher/rijndael-internal.h (USE_VAES_I386): New.
	* cipher/rijndael-vaes-avx2-i386.S: New.
	* cipher/rijndael-vaes-i386.c: New.
	* cipher/rijndael-vaes.c: Update header description (add 'AMD64').
	* cipher/rijndael.c [USE_VAES]: Add 'USE_VAES_I386' to ifdef around
	'_gcry_aes_vaes_*' function prototypes.
	(setkey) [USE_VAES_I386]: Add setup of VAES/AVX2/i386 bulk functions.
	* configure.ac: Add 'rijndael-vaes-i386.lo' and
	'rijndael-vaes-avx2-i386.lo'.
	(gcry_cv_gcc_amd64_platform_as_ok): Rename this to ...
	(gcry_cv_gcc_x86_platform_as_ok): ... this and change to check for
	both AMD64 and i386 assembler compatibility.
	(gcry_cv_gcc_win32_platform_as_ok): New.

	rijndael-vaes-avx2-amd64: avoid extra load in CFB & CBC IV handling.
	+ commit 13f288edd5274880cf6833c80eba24183440a66d
	* cipher/rijndael-vaes-avx2-amd64.S
	(_gcry_vaes_avx2_cbc_dec_amd64, _gcry_vaes_avx2_cfb_dec_amd64): Avoid
	duplicate memory load from source buffer.

	rijndael-vaes-avx2-amd64: acceleration for OCB auth.
	+ commit 6b47e85d65158f3b6b1c3c24476249bfe3a7f943
	* cipher/rijndael-vaes-avx2-amd64.S
	(_gcry_vaes_avx2_ocb_crypt_amd64): Add authentication mode support.
	* cipher/rijndael-vaes.c (_gcry_vaes_avx2_ocb_crypt_amd64): Change
	to return 'size_t' value.
	(_gcry_aes_vaes_ocb_auth): New.
	* cipher/rijndael.c (_gcry_aes_vaes_ocb_auth): New.
	(do_setkey) [USE_VAES]: Add setup for 'bulk_ops->ocb_auth'.

2023-07-14  Bernhard Reiter  <bernhard@intevation.de>

	build: Fix the notice in configure.ac.
	+ commit 77ce5866e06cb5ebd82a0ce34206395aa03b9352
	* configure.ac: Fix typo.

2023-07-12  NIIBE Yutaka  <gniibe@fsij.org>

	Use unsigned int for a bit field.
	+ commit e76e88eef7811ada4c6e1d57520ba8c439139782
	* random/random-drbg.c (struct drbg_state_ops_s): Use unsigned.
	(struct drbg_state_s): Likewise.
	* src/hmac256.c (struct hmac256_context): Likewise.

2023-06-28  NIIBE Yutaka  <gniibe@fsij.org>

	cipher:ecc:fips: Only allow defined digest algo for EdDSA.
	+ commit d15fe6aac10b0ffc2eb8974c23095d8123025e5c
	* cipher/ecc.c (ecc_sign): Add the check if it's proper digest
	algo for EdDSA on FIPS mode.

	cipher:ecc:fips: Reject use of SHAKE when it's ECDSA with RFC6979.
	+ commit f65c30d470f581e4df91a5aff8bb202ff0fd56ad
	* cipher/ecc-ecdsa.c (_gcry_ecc_ecdsa_sign): Check if it's SHAKE.

2023-06-25  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	keccak: add md_read support for SHAKE algorithms.
	+ commit 794695ff45d64f6586d7f08e74c075c098ac3b5d
	* cipher/hash-common.c (_gcry_hash_selftest_check_one): Adjust
	for SHAKE algorithms now returning non-zero for digest length.
	* cipher/keccak.c (KECCAK_CONTEXT_S): Add 'shake_in_extract_mode'
	and 'shake_in_read_mode' flags.
	(keccak_init): Initialize new context fields; set output length
	for SHAKE algorithms.
	(keccak_extract): Rename to ...
	(do_keccak_extract): this and add return value.
	(keccak_extract): New with 'shake_in_???_mode' checks & setup.
	(keccak_shake_read): New.
	(_gcry_sha3_hash_buffers): Adjust for 'spec->mdlen' not being
	zero for SHAKE algorithms, instead check 'suffix' for type.
	(_gcry_digest_spec_shake128): Set mdlen to 32 bytes; Set read
	function.
	(_gcry_digest_spec_shake256): Set mdlen to 64 bytes; Set read
	function.
	* cipher/md.c (md_extract): Pass return value from algo extract
	function.
	(_gcry_md_hash_buffers_extract): Adjust for 'spec->mdlen' not
	being zero for SHAKE algorithms.
	* src/cipher-proto.h (gcry_md_extract_t): Change return type
	from 'void' to 'gpg_err_code_t'.
	* tests/basic.c (check_one_md, check_one_md_multi): Adjust
	for 'gcry_md_get_algo_dlen()' not being zero for SHAKE
	algorithms.
	(check_digests): Add md_read interface test-vectors for SHAKE128
	and SHAKE256.

2023-06-23  NIIBE Yutaka  <gniibe@fsij.org>

	cipher:rsa: Add support of SHAKE as MGF.
	+ commit 8802faadab79ec84714bbaf28eaa882860779cba
	* cipher/rsa-common.c (_gcry_rsa_pss_encode): Support SHAKE.
	(_gcry_rsa_pss_verify): Likewise.

2023-06-16  NIIBE Yutaka  <gniibe@fsij.org>

	tests: Allow KDF measurement in FIPS mode.
	+ commit 70b1b036f3ee06c5894e996cbd742cf3c174ca79
	* tests/bench-slope.c (bench_kdf_init): Tweak the iterations in FIPS
	mode.
	(bench_kdf_do_bench): Use larger values to avoid rejection in FIPS
	mode.

	cipher:kdf: Move FIPS mode check to _gcry_kdf_derive.
	+ commit f4bff832c7f5a54879c1858d7b426cd12088c57c
	* cipher/kdf.c (_gcry_kdf_pkdf2): Move the checks to...
	(_gcry_kdf_derive): ... here.

	Remove out of core handler setting message in FIPS mode.
	+ commit 6c79dcddd151b6b01a760f7aab54e6882ea5a475
	* src/global.c (_gcry_set_outofcore_handler): Don't call log_info.

	cipher:ecc: Implement PCT for EdDSA.
	+ commit 3ac2bba4a4b11388949e235d0d9555478468a379
	* cipher/ecc.c (test_keys_eddsa_fips): New.
	(ecc_generate): Use test_keys_eddsa_fips for EdDSA.

	build: Detect broken GCC for x86/AVX512 intrinsics.
	+ commit 97f4a94d5960bb53b690bbd5cdf87b64311e21cc
	* configure.ac (HAVE_COMPATIBLE_CC_X86_AVX512_INTRINSICS): Check
	the GCC bug 90980.

	cipher:ecc: Add selftests for EdDSA.
	+ commit 547dfb5aecc1ae057e0bc599e8565f8c3fb84894
	* cipher/ecc.c (selftest_hash_sign_eddsa): New.
	(selftests_ecc): Add IS_EDDSA argument.
	(run_selftests): Add tests for Ed25519 and Ed448.
	* src/g10lib.h (_gcry_hex2buffer): New.
	* src/sexp.c (_gcry_hex2buffer): Add.

2023-06-16  Jakub Jelen  <jjelen@redhat.com>

	tests: EdDSA keys work in FIPS mode.
	+ commit 73d2f5d93541747befe9a791991553d691f3a1ae
	* tests/bench-slope.c (ecc_algo_fips_allowed): Adjust list of FIPS
	  allowed algorithms.
	* tests/benchmark.c (ecc_bench): Ditto.
	* tests/curves.c (check_get_params): Ditto.
	* tests/keygrip.c (global): Ditto.
	* tests/pubkey.c (main): Run Ed25519 test in FIPS mode.
	* tests/t-ed25519.c (one_test): Remove FIPS exception.
	  (main): Do not record FIPS status.
	* tests/t-ed448.c (one_test): Remove FIPS exception.
	  (main): Do not record FIPS status.
	* tests/keygen.c (check_ecc_keys): Remove FIPS exceptions.

	ecc: Enable Ed25519 and Ed448 in FIPS mode.
	+ commit c08ea202d91651b7c8f7ed37f5554330deac52b8
	* cipher/ecc-curves.c (domain_parms): Flip the FIPS byte for EdDSA
	  curves to enable them in FIPS mode
	* src/fips.c (valid_string_in_sexp): Mark eddsa flag valid in FIPS mode

2023-06-15  NIIBE Yutaka  <gniibe@fsij.org>

	cipher:ecc: Fix EdDSA secret key check.
	+ commit ed879d832659f51c40bfadcd3b96fb8890b1eefb
	* cipher/ecc.c (check_secret_key): No reason to exclude EdDSA key.

	context: Make the context chain-able.
	+ commit f4019ed225bf4478b06fdb54e01bd7b9264694a9
	* src/context.h (_gcry_ctx_alloc): Add NEXT argurment.
	* src/context.c (struct gcry_context): Add NEXT field.
	(_gcry_ctx_alloc): Support the NEXT field.
	(_gcry_ctx_get_pointer): Allow access to the NEXT field.
	(_gcry_ctx_release): Loop following NEXT.
	* cipher/pubkey.c (struct pk_single_data): Remove CTX_NEXT.
	(release_single_data): Remove.
	(_gcry_pk_single_data_push): Call _gcry_ctx_alloc with NEXT.
	(_gcry_pk_get_single_data): Use _gcry_ctx_get_pointer to
	access NEXT.

2023-06-14  NIIBE Yutaka  <gniibe@fsij.org>

	cipher:pubkey: Fix non-use of flexible array member.
	+ commit c160e1a85f8295e388de7a0b09a351bc271f0d95
	* cipher/pubkey.c (struct pk_single_data): Use 1 as the size.
	(_gcry_pk_single_data_push): Use offsetof.

	cipher:ecc: Support gcry_pk_hash_sign/verify for EdDSA.
	+ commit 86fcf8292208838b47c08e74cd0941694287e7dd
	* cipher/pubkey.c (prepare_datasexp_to_be_signed): Allow HD=NULL,
	and use of CTX for supplying input data and random_override.
	(_gcry_pk_sign_md, _gcry_pk_verify_md): Support the case of HD==NULL.
	(release_single_data): New.
	(_gcry_pk_single_data_push, _gcry_pk_get_single_data): New.
	(_gcry_pk_random_override_new, _gcry_pk_get_random_override): Remove.
	* src/context.h (CONTEXT_TYPE_SINGLE_DATA): New.
	(CONTEXT_TYPE_RANDOM_OVERRIDE): Remove.
	* src/context.c (_gcry_ctx_alloc): Use CONTEXT_TYPE_SINGLE_DATA.
	* src/gcrypt-int.h (_gcry_pk_single_data_push,
	_gcry_pk_get_single_data): New.
	(_gcry_pk_random_override_new, _gcry_pk_get_random_override): Remove.
	* src/gcrypt.h.in (gcry_pk_input_data_push): New.
	* src/visibility.c (gcry_pk_random_override_new): Follow the change.
	* tests/t-ed25519.c (one_test): Use gcry_pk_hash_sign/verify API.
	* tests/t-ed448.c (one_test): Use gcry_pk_hash_sign/verify API.

2023-06-13  NIIBE Yutaka  <gniibe@fsij.org>

	cipher:ecc: Fix public key computation for EdDSA.
	+ commit 469919751d6eb46ceff9df80676416ca8f474459
	* cipher/ecc-misc.c (_gcry_ecc_compute_public): Fix hard-coded length
	for digest lower bits.

2023-06-12  NIIBE Yutaka  <gniibe@fsij.org>

	cipher:pubkey: Factor out data SEXP preparation.
	+ commit 263aa80b39dcf6d98c475784b319cb91b87cec3b
	* cipher/pubkey.c (prepare_datasexp_to_be_signed): New.
	(_gcry_pk_sign_md, _gcry_pk_verify_md): Use the function.

2023-06-09  NIIBE Yutaka  <gniibe@fsij.org>

	cipher: Factor functions for ECC selftests.
	+ commit e0f7e927c594bec46afc23b782526546d0024ff5
	* cipher/ecc.c: Factor out data for ECC selftests.
	(selftest_hash_sign, selftest_sign): Have more arguments.
	(selftests_ecc): Rename from selftests_ecdsa, having more args.
	Follow the change of selftest_hash_sign, selftest_sign with data.
	(run_selftests): Call selftests_ecc with constants of ECDSA.

2023-06-04  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	addm/subm/mulm: fix case when destination is same MPI as divider.
	+ commit f490ffd739f713fcf0be35b7fbbb8502dea40a0c
	* mpi/mpi-add.c (_gcry_mpi_addm, _gcry_mpi_subm): Take copy of M when
	W and M are the same MPI.
	* mpi/mpi-mul.c (_gcry_mpi_mulm): Likewise.
	* tests/mpitests.c (test_addm_subm_mulm): New.
	(main): Run addm/subm/mulm test.

2023-06-01  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	twofish-avx2: de-unroll round function.
	+ commit beeff8eda4a94187ee2c72c4372ab3e634335e45
	* cipher/twofish-avx2-amd64.S (__twofish_enc_blk16)
	(__twofish_dec_blk16): Use loop structure instead of unrolling.

2023-05-28  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	serpent: add x86/AVX512 implementation.
	+ commit ce95b6ec3554aec0e4a26f700889a19d85b5d9ac
	* cipher/Makefile.am: Add `serpent-avx512-x86.c`; Add extra CFLAG
	handling for `serpent-avx512-x86.o` and `serpent-avx512-x86.lo`.
	* cipher/serpent-avx512-x86.c: New.
	* cipher/serpent.c (USE_AVX512): New.
	(serpent_context_t): Add `use_avx512`.
	[USE_AVX512] (_gcry_serpent_avx512_cbc_dec)
	(_gcry_serpent_avx512_cfb_dec, _gcry_serpent_avx512_ctr_enc)
	(_gcry_serpent_avx512_ocb_crypt, _gcry_serpent_avx512_blk32): New.
	(serpent_setkey_internal) [USE_AVX512]: Set `use_avx512` is
	AVX512 HW available.
	(_gcry_serpent_ctr_enc) [USE_AVX512]: New.
	(_gcry_serpent_cbc_dec) [USE_AVX512]: New.
	(_gcry_serpent_cfb_dec) [USE_AVX512]: New.
	(_gcry_serpent_ocb_crypt) [USE_AVX512]: New.
	(serpent_crypt_blk1_16): Rename to...
	(serpent_crypt_blk1_32): ... this; Add AVX512 code-path; Adjust for
	increase from max 16 blocks to max 32 blocks.
	(serpent_encrypt_blk1_16): Rename to ...
	(serpent_encrypt_blk1_32): ... this.
	(serpent_decrypt_blk1_16): Rename to ...
	(serpent_decrypt_blk1_32): ... this.
	(_gcry_serpent_xts_crypt, _gcry_serpent_ecb_crypt): Increase bulk
	block count from 16 to 32.
	* configure.ac (gcry_cv_cc_x86_avx512_intrinsics)
	(ENABLE_X86_AVX512_INTRINSICS_EXTRA_CFLAGS): New.
	(GCRYPT_ASM_CIPHERS): Add `serpent-avx512-x86.lo`.

2023-05-16  NIIBE Yutaka  <gniibe@fsij.org>

	build: Sync libtool from libgpg-error for 64-bit Windows.
	+ commit 01c0185e63605ec7e0b9e90ca99ef9f435b67261
	* build-aux/ltmain.hs: Update from libgpg-error.

2023-05-10  NIIBE Yutaka  <gniibe@fsij.org>

	tests: Use -no-fast-install LDFLAGS for Windows.
	+ commit 33f9f0dec26df64e8184395eb6554ee379a87e3d
	* tests/Makefile.am [HAVE_W32_SYSTEM] (AM_LDFLAGS): Conditionalize.

	w32: Silence GCC warning for -Wcast-function-type.
	+ commit 501dee123efe3d7d9488bb806ac9af5f56053f06
	* random/rndw32.c (init_system_rng): Add (void *).
	(slow_gatherer): Likewise.

2023-04-27  NIIBE Yutaka  <gniibe@fsij.org>

	Update copyright notices to use URL.
	+ commit f5284460ac4c8cc41ad9d39c5d15bd063710d956
	* build-aux/db2any: Update copyright notice.
	* cipher/arcfour.c, cipher/blowfish.ccipher/cast5.c: Likewise.
	* cipher/crc-armv8-ce.c, cipher/crc-intel-pclmul.c: Likewise.
	* cipher/crc-ppc.c, cipher/crc.c, cipher/des.c: Likewise.
	* cipher/md2.c, cipher/md4.c, cipher/md5.c: Likewise.
	* cipher/primegen.c, cipher/rfc2268.c, cipher/rmd160.c: Likewise.
	* cipher/seed.c, cipher/serpent.c, cipher/tiger.c: Likewise.
	* cipher/twofish.c: Likewise.
	* mpi/alpha/mpih-add1.S, mpi/alpha/mpih-lshift.S: Likewise.
	* mpi/alpha/mpih-mul1.S, mpi/alpha/mpih-mul2.S: Likewise.
	* mpi/alpha/mpih-mul3.S, mpi/alpha/mpih-rshift.S: Likewise.
	* mpi/alpha/mpih-sub1.S, mpi/alpha/udiv-qrnnd.S: Likewise.
	* mpi/amd64/mpih-add1.S, mpi/amd64/mpih-lshift.S: Likewise.
	* mpi/amd64/mpih-mul1.S, mpi/amd64/mpih-mul2.S: Likewise.
	* mpi/amd64/mpih-mul3.S, mpi/amd64/mpih-rshift.S: Likewise.
	* mpi/amd64/mpih-sub1.S, mpi/config.links: Likewise.
	* mpi/generic/mpih-add1.c, mpi/generic/mpih-lshift.c: Likewise.
	* mpi/generic/mpih-mul1.c, mpi/generic/mpih-mul2.c: Likewise.
	* mpi/generic/mpih-mul3.c, mpi/generic/mpih-rshift.c: Likewise.
	* mpi/generic/mpih-sub1.c, mpi/generic/udiv-w-sdiv.c: Likewise.
	* mpi/hppa/mpih-add1.S, mpi/hppa/mpih-lshift.S: Likewise.
	* mpi/hppa/mpih-rshift.S, mpi/hppa/mpih-sub1.S: Likewise.
	* mpi/hppa/udiv-qrnnd.S, mpi/hppa1.1/mpih-mul1.S: Likewise.
	* mpi/hppa1.1/mpih-mul2.S, mpi/hppa1.1/mpih-mul3.S: Likewise.
	* mpi/hppa1.1/udiv-qrnnd.S, mpi/i386/mpih-add1.S: Likewise.
	* mpi/i386/mpih-lshift.S, mpi/i386/mpih-mul1.S: Likewise.
	* mpi/i386/mpih-mul2.S, mpi/i386/mpih-mul3.S: Likewise.
	* mpi/i386/mpih-rshift.S, mpi/i386/mpih-sub1.S: Likewise.
	* mpi/i386/syntax.h, mpi/longlong.h: Likewise.
	* mpi/m68k/mc68020/mpih-mul1.S, mpi/m68k/mc68020/mpih-mul2.S: Likewise.
	* mpi/m68k/mc68020/mpih-mul3.S, mpi/m68k/mpih-add1.S: Likewise.
	* mpi/m68k/mpih-lshift.S, mpi/m68k/mpih-rshift.S: Likewise.
	* mpi/m68k/mpih-sub1.S, mpi/m68k/syntax.h: Likewise.
	* mpi/mips3/mpih-add1.S, mpi/mips3/mpih-lshift.S: Likewise.
	* mpi/mips3/mpih-mul1.S, mpi/mips3/mpih-mul2.S: Likewise.
	* mpi/mips3/mpih-mul3.S, mpi/mips3/mpih-rshift.S: Likewise.
	* mpi/mips3/mpih-sub1.S, mpi/mpi-add.c: Likewise.
	* mpi/mpi-bit.c, mpi/mpi-cmp.c, mpi/mpi-div.c: Likewise.
	* mpi/mpi-gcd.c, mpi/mpi-inline.c, mpi/mpi-inline.h: Likewise.
	* mpi/mpi-internal.h, mpi/mpi-mpow.c, mpi/mpi-mul.c: Likewise.
	* mpi/mpi-scan.c, mpi/mpih-div.c, mpi/mpih-mul.c: Likewise.
	* mpi/pa7100/mpih-lshift.S, mpi/pa7100/mpih-rshift.S: Likewise.
	* mpi/power/mpih-add1.S, mpi/power/mpih-lshift.S: Likewise.
	* mpi/power/mpih-mul1.S, mpi/power/mpih-mul2.S: Likewise.
	* mpi/power/mpih-mul3.S, mpi/power/mpih-rshift.S: Likewise.
	* mpi/power/mpih-sub1.S, mpi/powerpc32/mpih-add1.S: Likewise.
	* mpi/powerpc32/mpih-lshift.S, mpi/powerpc32/mpih-mul1.S: Likewise.
	* mpi/powerpc32/mpih-mul2.S, mpi/powerpc32/mpih-mul3.S: Likewise.
	* mpi/powerpc32/mpih-rshift.S, mpi/powerpc32/mpih-sub1.S: Likewise.
	* mpi/powerpc32/syntax.h, mpi/sparc32/mpih-add1.S: Likewise.
	* mpi/sparc32/mpih-lshift.S, mpi/sparc32/mpih-rshift.S: Likewise.
	* mpi/sparc32/udiv.S, mpi/sparc32v8/mpih-mul1.S: Likewise.
	* mpi/sparc32v8/mpih-mul2.S, mpi/sparc32v8/mpih-mul3.S: Likewise.
	* mpi/supersparc/udiv.S: Likewise.
	* random/random.h, random/rndegd.c: Likewise.
	* src/cipher.h, src/libgcrypt.def, src/libgcrypt.vers: Likewise.
	* src/missing-string.c, src/mpi.h, src/secmem.h: Likewise.
	* src/stdmem.h, src/types.h: Likewise.
	* tests/aeswrap.c, tests/curves.c, tests/hmac.c: Likewise.
	* tests/keygrip.c, tests/prime.c, tests/random.c: Likewise.
	* tests/t-kdf.c, tests/testapi.c: Likewise.

	Update m4 files and Makefiles.
	+ commit 17a3394b47cb82535ef7187e8819931b00cf4fa6
	* acinclude.m4: Use URL and add SPDX identifier.
	* m4/noexecstack.m4: Likewise.
	* Makefile.am: Likewise.
	* doc/Makefile.am: Likewise.
	* mpi/Makefile.am: Likewise.
	* tests/Makefile.am: Likewise.

2023-04-23  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	mpi: optimize mpi_rshift and mpi_lshift to avoid extra MPI copying.
	+ commit fdf2e8ba654a4dcfee25586dd7e0749f2b7a92c0
	* mpi/mpi-bit.c (_gcry_mpi_rshift): Refactor so that _gcry_mpih_rshift
	is used to do the copying along with shifting when copying is needed
	and refactor so that same code-path is used for both in-place and
	copying operation.
	(_gcry_mpi_lshift): Refactor so that _gcry_mpih_lshift is used to do
	the copying along with shifting when copying is needed and refactor
	so that same code-path is used for both in-place and copying operation.

	mpi/amd64: optimize add_n and sub_n.
	+ commit ad4ee8d52f7199ba8bdee767044337060529069f
	* mpi/amd64/mpih-add1.S (_gcry_mpih_add_n): New implementation
	with 4x unrolled fast-path loop.
	* mpi/amd64/mpih-sub1.S (_gcry_mpih_sub_n): Likewise.

	mpi/amd64: fix use of 'movd' for 64-bit register move in lshift&rshift.
	+ commit 3e17e819a6a4d505828cf93fc2c258a753f1d38c
	* mpi/amd64/mpih-lshift.S: Use 'movq' instead of 'movd' for moving
	value to %rax.
	* mpi/amd64/mpih-rshift.S: Likewise.

	mpi: avoid MPI copy at gcry_mpi_sub.
	+ commit 8b09db4cce1040f061034ab899cd1369a51dceeb
	* mpi/mpi-add.c (_gcry_mpi_add): Rename function...
	(_gcry_mpi_add_inv_sign): ... to this and add parameter for inverting
	sign of second operand.
	(_gcry_mpi_add): New.
	(_gcry_mpi_sub): Remove mpi_copy and instead use new
	'_gcry_mpi_add_inv_sign' function with inverted sign for second
	operand.

	bench-slope: add MPI benchmarking.
	+ commit e90fbf6f8dacf280d03e557a65528fc2df24f1d7
	* tests/bench-slope.c (MPI_START_SIZE, MPI_END_SIZE, MPI_STEP_SIZE)
	(MPI_NUM_STEPS, bench_mpi_test, mpi_test_names, bench_mpi_mode)
	(bench_mpi_hd, bench_mpi_init, bench_mpi_fre, bench_mpi_do_bench)
	(mpi_ops, mpi_modes, mpi_bench_one, _mpi_bench, mpi_match_test)
	(mpi_bench): New.
	(print_help): Add mention of 'mpi'.
	(main): Add "mpi" tests.

	cipher: restore weak-key error-code after mode specific setkey.
	+ commit 5d18b401f8a780e2465662e88cbac6974033bf3f
	* cipher/cipher.c (cipher_setkey): Restore weak-key error-code
	in case mode specific setkey returned success for the return code.

2023-04-20  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	doc: add documentation for GCRYCTL_SET_ALLOW_WEAK_KEY.
	+ commit f3ca9fa4f7e0aee1bb5012c419deb7b927da844d
	* doc/gcrypt.texi: Add 'GCRYCTL_SET_ALLOW_WEAK_KEY' under
	'gcry_cipher_ctl'.

	Revert "cipher: Fix edge case for SET_ALLOW_WEAK_KEY."
	+ commit 7146b69b490595d654228bae8c3fb5d1525e3b60
	* cipher/cipher.c (cipher_setkey): Do not reset RC.

2023-04-16  Werner Koch  <wk@gnupg.org>

	cipher: Fix edge case for SET_ALLOW_WEAK_KEY.
	+ commit 30840c2c45d718e0fd93cfd40771fbefa50e31f5
	* cipher/cipher.c (cipher_setkey): Reset RC.

2023-04-10  NIIBE Yutaka  <gniibe@fsij.org>

	random: Use getrandom only when it's appropriate.
	+ commit fa21ddc158b5d7b5900856e5b131071302217a51
	* random/rndgetentropy.c (_gcry_rndgetentropy_gather_random)
	[GRND_RANDOM]: Conditionalize the use of getrandom, as it's
	not a portable function.

2023-04-04  NIIBE Yutaka  <gniibe@fsij.org>

	cipher: Enable the fast path to ChaCha20 only when supported.
	+ commit 137f1fd82bc9136d434ca41f58d62091b64df6db
	cipher/cipher-poly1305.c (_gcry_cipher_poly1305_encrypt)
	(_gcry_cipher_poly1305_decrypt) [USE_CHACHA20]: Conditionalize.

2023-04-03  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	cipher-gcm-ppc: tweak loop structure a bit.
	+ commit 278ba98497e126358a6b0ee8b566cc62ebb96ab9
	* cipher/cipher-gcm-ppc.c (_gcry_ghash_ppc_vpmsum): Increament
	'buf' pointer right after use; Use 'for' loop for inner 4-blocks
	loop to allow compiler to better optimize loop.

2023-04-03  NIIBE Yutaka  <gniibe@fsij.org>

	build: Allow build with -Oz.
	+ commit 7edf1abb9a0d892a80cbf7ab42f64b2720671ee9
	* cipher/Makefile.am [ENABLE_O_FLAG_MUNGING]: Support -Oz.
	* random/Makefile.am [ENABLE_O_FLAG_MUNGING]: Support -Oz.

2023-04-01  NIIBE Yutaka  <gniibe@fsij.org>

	m4: Update gpg-error.m4.
	+ commit bcf5922eaac274f5ace991ecace01e718a9fe964
	* m4/gpg-error.m4: Update from libgpg-error master.

2023-03-24  NIIBE Yutaka  <gniibe@fsij.org>

	fips: More elaborate way of getting FIPS pk flags indicators.
	+ commit 1c916b8c99ea0e30f1d81d606fd63b0c45657186
	* src/fips.c (_gcry_fips_indicator_pk_flags): List more allowed string
	in the S-expression.
	* doc/gcrypt.texi: Add document for the FIPS service indicator
	GCRYCTL_FIPS_SERVICE_INDICATOR_PK_FLAGS with example.

2023-03-23  NIIBE Yutaka  <gniibe@fsij.org>

	build: Update gpg-error.m4.
	+ commit 0af15f1fa0ca277fba17b365519f710b41a5b78f
	* m4/gpg-error.m4: Update from libgpg-error master.

2023-03-19  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	camellia-simd128: use 8-bit right shift for rotate function.
	+ commit 79a79d3dc6268f4d72597f7db6c83511dbbef645
	* cipher/camellia-simd128.h (rol32_1_16): Use vpsrlb128 for uint8
	right shift by 7 if available.

	camellia-gfni: use GFNI for uint8 right shift in FLS.
	+ commit 3c98ae9cb60a8a72d3fa6641e59775f98ec78786
	* cipher/camellia-aesni-avx2-amd64.h (IF_GFNI, IF_NOT_GFNI): New.
	[CAMELLIA_GFNI_BUILD] (rol32_1_32): Add GFNI variant which uses
	vgf2p8affineqb for uint8 right shift by 7.
	(fls32): Load 'right shift by 7' bit-matrix on GFNI build.
	[CAMELLIA_GFNI_BUILD] (.Lright_shift_by_7): New.
	* cipher/camellia-gfni-avx512-amd64.S (clear_regs): Don't clear %k1.
	(rol32_1_64): Use vgf2p8affineqb for uint8 right shift by 7.
	(fls64): Adjust for rol32_1_64 changes.
	(.Lbyte_ones): Remove.
	(.Lright_shift_by_7): New.
	(_gcry_camellia_gfni_avx512_ctr_enc): Clear %k1 after use.

2023-03-14  Jakub Jelen  <jjelen@redhat.com>

	tests: Improve test coverage for FIPS service indicators.
	+ commit fae63f517906ba8f46d255f1b5770665f2197ad9
	* tests/basic.c (check_digests): Check the FIPS indicators.
	(check_mac): Ditto.

	fips: Explicitly disable overriding random in FIPS mode.
	+ commit e0a5a9eb8301991c28fae8632add8dacce81aeb4
	* src/fips.c: (_gcry_fips_indicator_function): Mark using random
	override non-approved in FIPS mode.

	fips: Explicitly allow only some PK flags.
	+ commit 4c1c8a707f9652dbfad8f8b531d8b84556f655f1
	* src/fips.c (_gcry_fips_indicator_pk_flags): New function for explicit
	  FIPS indicator for public key algorithm flags.
	* src/g10lib.h (_gcry_fips_indicator_pk_flags): New.
	* src/gcrypt.h.in (GCRYCTL_FIPS_SERVICE_INDICATOR_PK_FLAGS): New.
	* src/global.c (_gcry_vcontrol): Handle the new option.
	* doc/gcrypt.texi: Document new options.

2023-03-14  Tobias Heider  <tobias.heider@canonical.com>

	doc: Document the new FIPS indicators.
	+ commit 0b7ad923978f708b41933d6b91d3159ffc7a84a1
	* doc/gcrypt.texi: Document the new options for FIPS indicators.

2023-03-08  Tobias Heider  <tobias.heider@canonical.com>

	fips: Unblock MD5 in fips mode but mark non-approved in indicator.
	+ commit dc4a60e2d70bc52ba2955f8e676341d675ab89a0
	* cipher/mac-hmac.c (_gcry_mac_type_spec_hmac_md5): Allow in fips mode.
	* cipher/md5.c (_gcry_digest_spec_md5): Allow in fips mode.

	fips: Add explicit indicators for md and mac algorithms.
	+ commit c88672a327f6774a66d75a35f25266eec99b16f4
	* src/fips.c (_gcry_fips_indicator_mac): New function indicating
	non-approved mac algorithms.
	(_gcry_fips_indicator_md): new functions indicating non-approved
	message digest algorithms.
	* src/g10lib.h (_gcry_fips_indicator_mac): New function.
	(_gcry_fips_indicator_md): Ditto.
	* src/gcrypt.h.in (enum gcry_ctl_cmds): New symbols,
	GCRYCTL_FIPS_SERVICE_INDICATOR_MAC and
	GCRYCTL_FIPS_SERVICE_INDICATOR_MD.
	* src/global.c (_gcry_vcontrol): Handle new FIPS indicators.

2023-03-07  Jakub Jelen  <jjelen@redhat.com>

	kdf: Update tests in regards to the allowed parameters in FIPS mode.
	+ commit f5fe94810f3099c9ccc2ca3a5891502922ab0576
	* cipher/kdf.c (check_one): run selftests for more approved parameters
	and check that wrong parameters correctly fail in FIPS mode.

	fips: Check return value from ftell.
	+ commit 3fd3bb31597f80c76a94ea62e42d58d796beabf1
	* src/fips.c (get_file_offset): Check return value of ftell to be able
	  to detect errors.

	random: Remove unused SHA384 DRBGs.
	+ commit 45b80678109e5817b7cd15566a9d6c96b064b95f
	* random/random-drbg.c (global): Remove unused SHA384-based defines.
	(drbg_cores): Remove SHA384 configurations.
	(drbg_sec_strength): Remove unused SHA384.

	visibility: Check FIPS operational status for MD+Sign operation.
	+ commit 654d0dfa04993ebe28c0536d42f4bc6d87c28369
	* src/visibility.c (gcry_pk_hash_sign): Check fips status before
	calling the operation itself.
	(gcry_pk_hash_verify): Ditto.

	ecc: Make the PCT recoverable in FIPS mode and consistent with RSA.
	+ commit 23a2d1285e35b2eb91bb422609eb1c965c8a9bf6
	* cipher/ecc.c (test_keys_fips): Replace calls to log_fatal with
	return code on error.
	(ecc_generate): Signal error when PCT fails in FIPS mode.

	ecc: Do not allow skipping tests in FIPS Mode.
	+ commit 2ddeec574bc1ae90bb4242c4ce9ad9e7975a27bd
	* cipher/ecc.c (ecc_generate): Do not allow skipping tests PCT tests
	in FIPS mode.

2023-03-06  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	rijndael-ppc: use vector registers for key schedule calculations.
	+ commit 855f8c513d6db58cbc9d45f3e0bb2cee3ab5a189
	* cipher/rijndael-ppc.c (_gcry_aes_sbox4_ppc8): Remove.
	(bcast_u32_to_vec, u32_from_vec): New.
	(_gcry_aes_ppc8_setkey): Use vectors for round key calculation
	variables.

	Add PowerPC vector implementation of SM4.
	+ commit 0b2da804ee813eee22c386ba7f253415103b34ea
	* cipher/Makefile.am: Add 'sm4-ppc.c'.
	* cipher/sm4-ppc.c: New.
	* cipher/sm4.c (USE_PPC_CRYPTO): New.
	(SM4_context): Add 'use_ppc8le' and 'use_ppc9le'.
	[USE_PPC_CRYPTO] (_gcry_sm4_ppc8le_crypt_blk1_16)
	(_gcry_sm4_ppc9le_crypt_blk1_16, sm4_ppc8le_crypt_blk1_16)
	(sm4_ppc9le_crypt_blk1_16): New.
	(sm4_setkey) [USE_PPC_CRYPTO]: Set use_ppc8le and use_ppc9le
	based on HW features.
	(sm4_get_crypt_blk1_16_fn) [USE_PPC_CRYPTO]: Add PowerPC
	implementation selection.

2023-03-02  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	camellia-simd128: faster sbox filtering with uint8 right shift.
	+ commit 6c05c808e4e848964f67157e80f1835c5146e2bc
	* cipher/camellia-simd128.h (if_vpsrlb128)
	(if_not_vpsrlb128): New.
	(filter_8bit): Use 'vpsrlb128' when available on target
	architecture (PowerPC and AArch64).

	chacha20-ppc: do not generate p9 code when target attr unavailable.
	+ commit 652598096325c2478d7d033585dadc13bec6fb1d
	* cipher/chacha20-ppc.c (HAVE_FUNC_ATTR_TARGET): New.
	(_gcry_chacha20_ppc9_blocks1, _gcry_chacha20_ppc9_blocks4)
	(_gcry_chacha20_poly1305_ppc8_blocks4): Use inline functions
	only if HAVE_FUNC_ATTR_TARGET is defined.

2023-03-01  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	Fix "'inline' is not at beginning of declaration" warnings.
	+ commit 0a5f7e9543a823034f6dd6dae2f647c4e213f213
	* cipher/chacha20-ppc.c (chacha20_ppc_blocks1)
	(chacha20_ppc_blocks4, chacha20_poly1305_ppc_blocks4): Move
	'ASM_FUNC_ATTR_INLINE' right after 'static'.
	* cipher/sha256-ppc.c (sha256_transform_ppc): Likewise.
	* cipher/sha512-ppc.c (sha512_transform_ppc): Likewise.

	Improve PPC target function attribute checks.
	+ commit 66bae697a853b21e0a2ff2a5031d23e3691a9084
	* configure.ac (gcry_cv_gcc_attribute_ppc_target)
	(gcry_cv_clang_attribute_ppc_target): Add 'always_inline'
	function to test.

2023-02-28  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	camellia: add AArch64 crypto-extension implementation.
	+ commit 898c857206ada06d70c5f46ac5adaa9d7058e672
	* cipher/Makefile.am: Add 'camellia-aarch64-ce.(c|o|lo)'.
	(aarch64_neon_cflags): New.
	* cipher/camellia-aarch64-ce.c: New.
	* cipher/camellia-glue.c (USE_AARCH64_CE): New.
	(CAMELLIA_context): Add 'use_aarch64ce'.
	(_gcry_camellia_aarch64ce_encrypt_blk16)
	(_gcry_camellia_aarch64ce_decrypt_blk16)
	(_gcry_camellia_aarch64ce_keygen, camellia_aarch64ce_enc_blk16)
	(camellia_aarch64ce_dec_blk16, aarch64ce_burn_stack_depth): New.
	(camellia_setkey) [USE_AARCH64_CE]: Set use_aarch64ce if HW has
	HWF_ARM_AES; Use AArch64/CE key generation if supported by HW.
	(camellia_encrypt_blk1_32, camellia_decrypt_blk1_32)
	[USE_AARCH64_CE]: Add AArch64/CE code path.

	camellia: add POWER8/POWER9 vcrypto implementation.
	+ commit 6fa11d8b7070eb7c4c296c879213c9596bd00b1c
	* cipher/Makefile.am: Add 'camellia-simd128.h',
	'camellia-ppc8le.c' and 'camellia-ppc9le.c'.
	* cipher/camellia-glue.c (USE_PPC_CRYPTO): New.
	(CAMELLIA_context) [USE_PPC_CRYPTO]: Add 'use_ppc', 'use_ppc8'
	and 'use_ppc9'.
	[USE_PPC_CRYPTO] (_gcry_camellia_ppc8_encrypt_blk16)
	(_gcry_camellia_ppc8_decrypt_blk16, _gcry_camellia_ppc8_keygen)
	(_gcry_camellia_ppc9_encrypt_blk16)
	(_gcry_camellia_ppc9_decrypt_blk16, _gcry_camellia_ppc9_keygen)
	(camellia_ppc_enc_blk16, camellia_ppc_dec_blk16)
	(ppc_burn_stack_depth): New.
	(camellia_setkey) [USE_PPC_CRYPTO]: Setup 'use_ppc', 'use_ppc8'
	and 'use_ppc9' and use PPC key-generation if HWF is available.
	(camellia_encrypt_blk1_32)
	(camellia_decrypt_blk1_32) [USE_PPC_CRYPTO]: Add 'use_ppc' paths.
	(_gcry_camellia_ocb_crypt, _gcry_camellia_ocb_auth): Enable
	generic bulk path when USE_PPC_CRYPTO is defined.
	* cipher/camellia-ppc8le.c: New.
	* cipher/camellia-ppc9le.c: New.
	* cipher/camellia-simd128.h: New.
	* configure.ac: Add 'camellia-ppc8le.lo' and 'camellia-ppc9le.lo'.

2023-02-26  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	aes-amd64-vaes: fix fast exit path in XTS function.
	+ commit 0d42d9674458a22cfccec419f4c358d743c5effb
	* cipher/rijndael-vaes-avx2-amd64.S
	(_gcry_vaes_avx2_xts_crypt_amd64): On fast exit path, compare
	number of blocks left against '1' instead of '0' as following
	branch is 'less than'.

	ppc: add support for clang target attribute.
	+ commit 937a76a34540bd2558f5b34a98fbe53227000646
	* configure.ac (gcry_cv_clang_attribute_ppc_target): New.
	* cipher/chacha20-ppc.c [HAVE_CLANG_ATTRIBUTE_PPC_TARGET]
	(FUNC_ATTR_TARGET_P8, FUNC_ATTR_TARGET_P9): New.
	* cipher/rijndael-ppc.c [HAVE_CLANG_ATTRIBUTE_PPC_TARGET]
	(FPC_OPT_ATTR): New.
	* cipher/rijndael-ppc9le.c [HAVE_CLANG_ATTRIBUTE_PPC_TARGET]
	(FPC_OPT_ATTR): New.
	* cipher/sha256-ppc.c [HAVE_CLANG_ATTRIBUTE_PPC_TARGET]
	(FUNC_ATTR_TARGET_P8, FUNC_ATTR_TARGET_P9): New.
	* cipher/sha512-ppc.c [HAVE_CLANG_ATTRIBUTE_PPC_TARGET]
	(FUNC_ATTR_TARGET_P8, FUNC_ATTR_TARGET_P9): New.
	(ror64): Remove unused function.

	chacha20-ppc: use target and optimize attributes for P8 and P9.
	+ commit f3d1d4a8c9f0df107a57e2cd3699253766d6e45a
	* cipher/chacha20-ppc.c (_gcry_chacha20_ppc8_blocks1): Rename to...
	(chacha20_ppc_blocks1): ...this; Add 'always inline' attribute.
	(_gcry_chacha20_ppc8_blocks4): Rename to...
	(chacha20_ppc_blocks4): ...this; Add 'always inline' attribute.
	(_gcry_chacha20_poly1305_ppc8_blocks4): Rename to...
	(chacha20_poly1305_ppc_blocks4): ...this; Add 'always inline'
	attribute.
	(FUNC_ATTR_OPT_O2, FUNC_ATTR_TARGET_P8, FUNC_ATTR_TARGET_P9): New.
	(_gcry_chacha20_ppc8_blocks1, _gcry_chacha20_ppc8_blocks4)
	(_gcry_chacha20_poly1305_ppc8_blocks4): New.
	(_gcry_chacha20_ppc9_blocks1, _gcry_chacha20_ppc9_blocks4)
	(_gcry_chacha20_poly1305_ppc9_blocks4): New.
	* cipher/chacha20.c (CHACHA20_context_t): Add 'use_p9'.
	(_gcry_chacha20_ppc9_blocks1, _gcry_chacha20_ppc9_blocks4)
	(_gcry_chacha20_poly1305_ppc9_blocks4): New.
	(chacha20_do_setkey): Set 'use_p9' if HW has HWF_PPC_ARCH_3_00.
	(chacha20_blocks, do_chacha20_encrypt_stream_tail)
	(_gcry_chacha20_poly1305_encrypt)
	(_gcry_chacha20_poly1305_decrypt) [USE_PPC_VEC]: Add 'use_p9' paths.

	aes-ppc: use target and optimize attributes for P8 and P9.
	+ commit 100063cf4e1ca3350f05a343d8fa0ccf305debb1
	* cipher/rijndael-ppc-functions.h: Add PPC_OPT_ATTR attribute
	macro for all functions.
	* cipher/rijndael-ppc.c (FUNC_ATTR_OPT, PPC_OPT_ATTR): New.
	(_gcry_aes_ppc8_setkey, _gcry_aes_ppc8_prepare_decryption): Add
	PPC_OPT_ATTR attribute macro.
	* cipher/rijndael-ppc9le.c (FUNC_ATTR_OPT, PPC_OPT_ATTR): New.

	aes-ppc: add CTR32LE bulk acceleration.
	+ commit 84f2e2d0b51b7b3e75d96d8188ae6a8d8174542b
	* cipher/rijndael-ppc-functions.h (CTR32LE_ENC_FUNC): New.
	* cipher/rijndael-ppc.c (_gcry_aes_ppc8_ctr32le_enc): New.
	* cipher/rijndael-ppc9le.c (_gcry_aes_ppc9le_ctr32le_enc): New.
	* cipher/rijndael.c (_gcry_aes_ppc8_ctr32le_enc)
	(_gcry_aes_ppc9le_ctr32le_enc): New.
	(do_setkey): Setup _gcry_aes_ppc8_ctr32le_enc for POWER8 and
	_gcry_aes_ppc9le_ctr32le_enc for POWER9.

	aes-ppc: add ECB bulk acceleration for benchmarking purposes.
	+ commit a7ebf9d52e67015c0ae175c0a9bbff9da9fe6f32
	* cipher/rijndael-ppc-functions.h (ECB_CRYPT_FUNC): New.
	* cipher/rijndael-ppc.c (_gcry_aes_ppc8_ecb_crypt): New.
	* cipher/rijndael-ppc9le.c (_gcry_aes_ppc9le_ecb_crypt): New.
	* cipher/rijndael.c (_gcry_aes_ppc8_ecb_crypt)
	(_gcry_aes_ppc9le_ecb_crypt): New.
	(do_setkey): Set up _gcry_aes_ppc8_ecb_crypt for POWER8 and
	_gcry_aes_ppc9le_ecb_crypt for POWER9.

	sha2-ppc: better optimization for POWER9.
	+ commit 161614ecc1c20d94a8599888524b1d1fd0eb2754
	* cipher/sha256-ppc.c: Change to use vector registers, generate
	POWER8 and POWER9 from same code with help of 'target' and
	'optimize' attribute.
	* cipher/sha512-ppc.c: Likewise.
	* configure.ac (gcry_cv_gcc_attribute_optimize)
	(gcry_cv_gcc_attribute_ppc_target): New.

2023-02-22  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	camellia-aesni-avx: speed up for round key broadcasting.
	+ commit dd4cb5d75c8e4e666db4352d999b2111b9ddb80d
	* cipher/camellia-aesni-avx2-amd64.h (roundsm16, fls16): Broadcast
	round key bytes directly with 'vpshufb'.

	camellia-avx2: speed up for round key broadcasting.
	+ commit b9a9755742c7bf7ca8c007d33f98aaa076a382c7
	* cipher/camellia-aesni-avx2-amd64.h (roundsm32, fls32): Use
	'vpbroadcastb' for loading round key.
	* cipher/camellia-glue.c (camellia_encrypt_blk1_32)
	(camellia_decrypt_blk1_32): Adjust num_blks thresholds for AVX2
	implementations, 2 blks for GFNI, 4 blks for VAES and 5 blks for AESNI.

	camellia-gfni-avx512: speed up for round key broadcasting.
	+ commit a4c22331f57d23832ddd019ac3108b5fa3dd942b
	* cipher/camellia-gfni-avx512-amd64.S (roundsm64, fls64): Use
	'vpbroadcastb' for loading round key.

	camellia-avx2: add fast path for full 32 block ECB input.
	+ commit 5f25ad09fdb5eb5f83f7cc4cefe79bbeab29fec8
	* cipher/camellia-aesni-avx2-amd64.h (enc_blk1_32, dec_blk1_32): Add
	fast path for 32 block input.

	camellia: add CTR-mode byte addition for AVX/AVX2/AVX512 impl.
	+ commit 87ae2a660d59751ddd7da40da05cfaee73f35ea7
	* cipher/camellia-aesni-avx-amd64.S
	(_gcry_camellia_aesni_avx_ctr_enc): Add byte addition fast-path.
	* cipher/camellia-aesni-avx2-amd64.h (ctr_enc): Likewise.
	* cipher/camellia-gfni-avx512-amd64.S
	(_gcry_camellia_gfni_avx512_ctr_enc): Likewise.
	* cipher/camellia-glue.c (CAMELLIA_context): Add 'use_avx2'.
	(camellia_setkey, _gcry_camellia_ctr_enc, _gcry_camellia_cbc_dec)
	(_gcry_camellia_cfb_dec, _gcry_camellia_ocb_crypt)
	(_gcry_camellia_ocb_auth) [USE_AESNI_AVX2]: Use 'use_avx2' to check
	if any of the AVX2 implementations is enabled.

	camellia-aesni-avx: add acceleration for ECB/XTS/CTR32LE modes.
	+ commit 926cc22058a39c7a931e14590eab6fd7a78ba455
	* cipher/camellia-aesni-avx-amd64.S (_gcry_camellia_aesni_avx_ecb_enc)
	(_gcry_camellia_aesni_avx_ecb_dec): New.
	* cipher/camellia-glue.c (_gcry_camellia_aesni_avx_ecb_enc)
	(_gcry_camellia_aesni_avx_ecb_dec): New.
	(camellia_setkey): Always enable XTS/ECB/CTR32LE bulk functions.
	(camellia_encrypt_blk1_32, camellia_decrypt_blk1_32)
	[USE_AESNI_AVX]: Add AESNI/AVX code-path.

	sm4: add CTR-mode byte addition for AVX/AVX2/AVX512 implementations.
	+ commit 978b02fca682c9ecb71e30cdeeb6922fc8331f6e
	* cipher/sm4-aesni-avx-amd64.S
	(_gcry_sm4_aesni_avx_ctr_enc): Add byte addition fast-path.
	* cipher/sm4-aesni-avx2-amd64.S
	(_gcry_sm4_aesni_avx2_ctr_enc): Likewise.
	* cipher/sm4-gfni-avx2-amd64.S
	(_gcry_sm4_gfni_avx2_ctr_enc): Likewise.
	* cipher/sm4-gfni-avx512-amd64.S
	(_gcry_sm4_gfni_avx512_ctr_enc)
	(_gcry_sm4_gfni_avx512_ctr_enc_blk32): Likewise.

	aes-vaes-avx2: improve case when only CTR needs carry handling.
	+ commit 8f7f5a9fc63968304bacedbc2f22b9f7188bbd53
	* cipher/rijndael-vaes-avx2-amd64.S
	(_gcry_vaes_avx2_ctr_enc_amd64): Add handling for the case when
	only main counter needs carry handling but generated vector counters
	do not.

	aria-avx2: add VAES accelerated implementation.
	+ commit caf402e9b41fff6cf39b914b088ea1e5f8fd3bd1
	* cipher/aria-aesni-avx2-amd64.S (CONFIG_AS_VAES): New.
	[CONFIG_AS_VAES]: Add VAES accelerated assembly macros and functions.
	* cipher/aria.c (USE_VAES_AVX2): New.
	(ARIA_context): Add 'use_vaes_avx2'.
	(_gcry_aria_vaes_avx2_ecb_crypt_blk32)
	(_gcry_aria_vaes_avx2_ctr_crypt_blk32)
	(aria_avx2_ecb_crypt_blk32, aria_avx2_ctr_crypt_blk32): Add VAES/AVX2
	code paths.
	(aria_setkey): Enable VAES/AVX2 implementation based on HW features.

	aria-avx512: small optimization for aria_diff_m.
	+ commit f359a3ec7e845aa446836bd47994fe18d6d41e08
	* cipher/aria-gfni-avx512-amd64.S (aria_diff_m): Use 'vpternlogq' for
	3-way XOR operation.
	---

	Using vpternlogq gives small performance improvement on AMD Zen4. With
	Intel tiger-lake speed is the same as before.

	Benchmark on AMD Ryzen 9 7900X (zen4, turbo-freq off):

	Before:
	 ARIA128        |  nanosecs/byte   mebibytes/sec   cycles/byte  auto Mhz
	        ECB enc |     0.203 ns/B      4703 MiB/s     0.953 c/B      4700
	        ECB dec |     0.204 ns/B      4675 MiB/s     0.959 c/B      4700
	        CTR enc |     0.207 ns/B      4609 MiB/s     0.973 c/B      4700
	        CTR dec |     0.207 ns/B      4608 MiB/s     0.973 c/B      4700

	After (~3% faster):
	 ARIA128        |  nanosecs/byte   mebibytes/sec   cycles/byte  auto Mhz
	        ECB enc |     0.197 ns/B      4847 MiB/s     0.925 c/B      4700
	        ECB dec |     0.197 ns/B      4852 MiB/s     0.924 c/B      4700
	        CTR enc |     0.200 ns/B      4759 MiB/s     0.942 c/B      4700
	        CTR dec |     0.200 ns/B      4772 MiB/s     0.939 c/B      4700

	Cc: Taehee Yoo <ap420073@gmail.com>

	aria-avx: small optimization for aria_ark_8way.
	+ commit 855f1551fd921ced652dc0c3c03601dfcd063f1c
	* cipher/aria-aesni-avx-amd64.S (aria_ark_8way): Use 'vmovd' for
	loading key material and 'vpshufb' for broadcasting from byte
	locations 3, 2, 1 and 0.

	aria: add x86_64 GFNI/AVX512 accelerated implementation.
	+ commit 45351e6474cbbe5baaa4c488222610edc417176e
	* cipher/Makefile.am: Add 'aria-gfni-avx512-amd64.S'.
	* cipher/aria-gfni-avx512-amd64.S: New.
	* cipher/aria.c (USE_GFNI_AVX512): New.
	[USE_GFNI_AVX512] (MAX_PARALLEL_BLKS): New.
	(ARIA_context): Add 'use_gfni_avx512'.
	(_gcry_aria_gfni_avx512_ecb_crypt_blk64)
	(_gcry_aria_gfni_avx512_ctr_crypt_blk64)
	(aria_gfni_avx512_ecb_crypt_blk64)
	(aria_gfni_avx512_ctr_crypt_blk64): New.
	(aria_crypt_blocks) [USE_GFNI_AVX512]: Add 64 parallel block
	AVX512/GFNI processing.
	(_gcry_aria_ctr_enc) [USE_GFNI_AVX512]: Add 64 parallel block
	AVX512/GFNI processing.
	(aria_setkey): Enable GFNI/AVX512 based on HW features.
	* configure.ac: Add 'aria-gfni-avx512-amd64.lo'.

	aria: add x86_64 AESNI/GFNI/AVX/AVX2 accelerated implementations.
	+ commit f4268a8f51a89a7c0374a23f669d7a19cad304ae
	* cipher/Makefile.am: Add 'aria-aesni-avx-amd64.S' and
	'aria-aesni-avx2-amd64.S'.
	* cipher/aria-aesni-avx-amd64.S: New.
	* cipher/aria-aesni-avx2-amd64.S: New.
	* cipher/aria.c (USE_AESNI_AVX, USE_GFNI_AVX, USE_AESNI_AVX2)
	(USE_GFNI_AVX2, MAX_PARALLEL_BLKS, ASM_FUNC_ABI, ASM_EXTRA_STACK): New.
	(ARIA_context): Add 'use_aesni_avx', 'use_gfni_avx',
	'use_aesni_avx2' and 'use_gfni_avx2'.
	(_gcry_aria_aesni_avx_ecb_crypt_blk1_16)
	(_gcry_aria_aesni_avx_ctr_crypt_blk16)
	(_gcry_aria_gfni_avx_ecb_crypt_blk1_16)
	(_gcry_aria_gfni_avx_ctr_crypt_blk16)
	(aria_avx_ecb_crypt_blk1_16, aria_avx_ctr_crypt_blk16)
	(_gcry_aria_aesni_avx2_ecb_crypt_blk32)
	(_gcry_aria_aesni_avx2_ctr_crypt_blk32)
	(_gcry_aria_gfni_avx2_ecb_crypt_blk32)
	(_gcry_aria_gfni_avx2_ctr_crypt_blk32)
	(aria_avx2_ecb_crypt_blk32, aria_avx2_ctr_crypt_blk32): New.
	(aria_crypt_blocks) [USE_AESNI_AVX2]: Add 32 parallel block
	AVX2/AESNI/GFNI processing.
	(aria_crypt_blocks) [USE_AESNI_AVX]: Add 3 to 16 parallel block
	AVX/AESNI/GFNI processing.
	(_gcry_aria_ctr_enc) [USE_AESNI_AVX2]: Add 32 parallel block
	AVX2/AESNI/GFNI processing.
	(_gcry_aria_ctr_enc) [USE_AESNI_AVX]: Add 16 parallel block
	AVX/AESNI/GFNI processing.
	(_gcry_aria_ctr_enc, _gcry_aria_cbc_dec, _gcry_aria_cfb_enc)
	(_gcry_aria_ecb_crypt, _gcry_aria_xts_crypt, _gcry_aria_ctr32le_enc)
	(_gcry_aria_ocb_crypt, _gcry_aria_ocb_auth): Use MAX_PARALLEL_BLKS
	for parallel processing width.
	(aria_setkey): Enable AESNI/AVX, GFNI/AVX, AESNI/AVX2, GFNI/AVX2 based
	on HW features.
	* configure.ac: Add 'aria-aesni-avx-amd64.lo' and
	'aria-aesni-avx2-amd64.lo'.
	---

	This patch adds AVX/AVX2/AESNI/GFNI accelerated ARIA block cipher
	implementations for libgcrypt. This implementation is based on work
	by Taehee Yoo, with following notable changes:
	 - Integration to libgcrypt, use of 'aes-common-amd64.h'.
	 - Use 'vmovddup' for loading GFNI constants.
	 - Use round loop instead of unrolling for smaller code size and
	   increased performance.
	 - Use stack for temporary storage instead of external buffers.
	 - Use merge ECB encryption/decryption to single function.
	 - Add 1 to 15 blocks support for AVX ECB functions.
	 - Add byte-addition fast path for CTR.

	===

	Benchmark on AMD Ryzen 9 7900X (zen4, turbo-freq off):

	 AESNI/AVX:
	 ARIA128        |  nanosecs/byte   mebibytes/sec   cycles/byte  auto Mhz
	        ECB enc |     0.715 ns/B      1333 MiB/s      3.36 c/B      4700
	        ECB dec |     0.712 ns/B      1339 MiB/s      3.35 c/B      4700
	        CTR enc |     0.714 ns/B      1336 MiB/s      3.36 c/B      4700
	        CTR dec |     0.714 ns/B      1335 MiB/s      3.36 c/B      4700

	 GFNI/AVX:
	 ARIA128        |  nanosecs/byte   mebibytes/sec   cycles/byte  auto Mhz
	        ECB enc |     0.516 ns/B      1847 MiB/s      2.43 c/B      4700
	        ECB dec |     0.519 ns/B      1839 MiB/s      2.44 c/B      4700
	        CTR enc |     0.517 ns/B      1846 MiB/s      2.43 c/B      4700
	        CTR dec |     0.518 ns/B      1843 MiB/s      2.43 c/B      4700

	 AESNI/AVX2:
	 ARIA128        |  nanosecs/byte   mebibytes/sec   cycles/byte  auto Mhz
	        ECB enc |     0.416 ns/B      2292 MiB/s      1.96 c/B      4700
	        ECB dec |     0.421 ns/B      2266 MiB/s      1.98 c/B      4700
	        CTR enc |     0.415 ns/B      2298 MiB/s      1.95 c/B      4700
	        CTR dec |     0.415 ns/B      2300 MiB/s      1.95 c/B      4700

	 GFNI/AVX2:
	 ARIA128        |  nanosecs/byte   mebibytes/sec   cycles/byte  auto Mhz
	        ECB enc |     0.235 ns/B      4056 MiB/s      1.11 c/B      4700
	        ECB dec |     0.234 ns/B      4079 MiB/s      1.10 c/B      4700
	        CTR enc |     0.232 ns/B      4104 MiB/s      1.09 c/B      4700
	        CTR dec |     0.233 ns/B      4094 MiB/s      1.10 c/B      4700

	===

	Benchmark on Intel Core i3-1115G4 (tiger-lake, turbo-freq off):

	 AESNI/AVX:
	 ARIA128        |  nanosecs/byte   mebibytes/sec   cycles/byte  auto Mhz
	        ECB enc |      1.26 ns/B     757.6 MiB/s      3.77 c/B      2993
	        ECB dec |      1.27 ns/B     753.1 MiB/s      3.79 c/B      2992
	        CTR enc |      1.25 ns/B     760.3 MiB/s      3.75 c/B      2992
	        CTR dec |      1.26 ns/B     759.1 MiB/s      3.76 c/B      2992

	 GFNI/AVX:
	 ARIA128        |  nanosecs/byte   mebibytes/sec   cycles/byte  auto Mhz
	        ECB enc |     0.967 ns/B     986.6 MiB/s      2.89 c/B      2992
	        ECB dec |     0.966 ns/B     987.1 MiB/s      2.89 c/B      2992
	        CTR enc |     0.972 ns/B     980.8 MiB/s      2.91 c/B      2993
	        CTR dec |     0.971 ns/B     982.5 MiB/s      2.90 c/B      2993

	 AESNI/AVX2:
	 ARIA128        |  nanosecs/byte   mebibytes/sec   cycles/byte  auto Mhz
	        ECB enc |     0.817 ns/B      1167 MiB/s      2.44 c/B      2992
	        ECB dec |     0.819 ns/B      1164 MiB/s      2.45 c/B      2992
	        CTR enc |     0.819 ns/B      1164 MiB/s      2.45 c/B      2992
	        CTR dec |     0.819 ns/B      1164 MiB/s      2.45 c/B      2992

	 GFNI/AVX2:
	 ARIA128        |  nanosecs/byte   mebibytes/sec   cycles/byte  auto Mhz
	        ECB enc |     0.506 ns/B      1886 MiB/s      1.51 c/B      2992
	        ECB dec |     0.505 ns/B      1887 MiB/s      1.51 c/B      2992
	        CTR enc |     0.564 ns/B      1691 MiB/s      1.69 c/B      2992
	        CTR dec |     0.565 ns/B      1689 MiB/s      1.69 c/B      2992

	===

	Benchmark on AMD Ryzen 7 5800X (zen3, turbo-freq off):

	 AESNI/AVX:
	 ARIA128        |  nanosecs/byte   mebibytes/sec   cycles/byte  auto Mhz
	        ECB enc |     0.921 ns/B      1035 MiB/s      3.50 c/B      3800
	        ECB dec |     0.922 ns/B      1034 MiB/s      3.50 c/B      3800
	        CTR enc |     0.923 ns/B      1033 MiB/s      3.51 c/B      3800
	        CTR dec |     0.923 ns/B      1033 MiB/s      3.51 c/B      3800

	 AESNI/AVX2:
	 ARIA128        |  nanosecs/byte   mebibytes/sec   cycles/byte  auto Mhz
	        ECB enc |     0.559 ns/B      1707 MiB/s      2.12 c/B      3800
	        ECB dec |     0.560 ns/B      1703 MiB/s      2.13 c/B      3800
	        CTR enc |     0.570 ns/B      1672 MiB/s      2.17 c/B      3800
	        CTR dec |     0.568 ns/B      1679 MiB/s      2.16 c/B      3800

	===

	Benchmark on AMD EPYC 7642 (zen2):

	 AESNI/AVX:
	 ARIA128        |  nanosecs/byte   mebibytes/sec   cycles/byte  auto Mhz
	        ECB enc |      1.22 ns/B     784.5 MiB/s      4.01 c/B      3298
	        ECB dec |      1.22 ns/B     784.8 MiB/s      4.00 c/B      3292
	        CTR enc |      1.22 ns/B     780.1 MiB/s      4.03 c/B      3299
	        CTR dec |      1.22 ns/B     779.1 MiB/s      4.04 c/B      3299

	 AESNI/AVX2:
	 ARIA128        |  nanosecs/byte   mebibytes/sec   cycles/byte  auto Mhz
	        ECB enc |     0.735 ns/B      1298 MiB/s      2.42 c/B      3299
	        ECB dec |     0.738 ns/B      1292 MiB/s      2.44 c/B      3299
	        CTR enc |     0.732 ns/B      1303 MiB/s      2.41 c/B      3299
	        CTR dec |     0.732 ns/B      1303 MiB/s      2.41 c/B      3299

	===

	Benchmark on Intel Core i5-6500 (skylake):

	 AESNI/AVX:
	 ARIA128        |  nanosecs/byte   mebibytes/sec   cycles/byte  auto Mhz
	        ECB enc |      1.24 ns/B     766.6 MiB/s      4.48 c/B      3598
	        ECB dec |      1.25 ns/B     764.9 MiB/s      4.49 c/B      3598
	        CTR enc |      1.25 ns/B     761.7 MiB/s      4.50 c/B      3598
	        CTR dec |      1.25 ns/B     761.6 MiB/s      4.51 c/B      3598

	 AESNI/AVX2:
	 ARIA128        |  nanosecs/byte   mebibytes/sec   cycles/byte  auto Mhz
	        ECB enc |     0.829 ns/B      1150 MiB/s      2.98 c/B      3599
	        ECB dec |     0.831 ns/B      1147 MiB/s      2.99 c/B      3598
	        CTR enc |     0.829 ns/B      1150 MiB/s      2.98 c/B      3598
	        CTR dec |     0.828 ns/B      1152 MiB/s      2.98 c/B      3598

	===

	Benchmark on Intel Core i5-2450M (sandy-bridge, turbo-freq off):

	 AESNI/AVX:
	 ARIA128        |  nanosecs/byte   mebibytes/sec   cycles/byte  auto Mhz
	        ECB enc |      2.11 ns/B     452.7 MiB/s      5.25 c/B      2494
	        ECB dec |      2.10 ns/B     454.5 MiB/s      5.23 c/B      2494
	        CTR enc |      2.10 ns/B     453.2 MiB/s      5.25 c/B      2494
	        CTR dec |      2.10 ns/B     453.2 MiB/s      5.25 c/B      2494

	[v2]
	 - Optimization for CTR mode: Use CTR byte-addition path when
	   counter carry-overflow happen only on ctr-variable but not in
	   generated counter vector registers.

	Cc: Taehee Yoo <ap420073@gmail.com>

2023-01-21  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	asm-common-aarch64: fix read-only section for Windows target.
	+ commit 833a904faf2b90a1b1d1b58e1e9a12f2e8e2378c
	* cipher/asm-common-aarch64.h (SECTION_RODATA): Use .rdata for
	_WIN32.

2023-01-19  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	aarch64-asm: align functions to 16 bytes.
	+ commit 6f8e750c42ffd34900fad30540e92e382111d567
	* cipher/camellia-aarch64.S: Align functions to 16 bytes.
	* cipher/chacha20-aarch64.S: Likewise.
	* cipher/cipher-gcm-armv8-aarch64-ce.S: Likewise.
	* cipher/crc-armv8-aarch64-ce.S: Likewise.
	* cipher/rijndael-aarch64.S: Likewise.
	* cipher/rijndael-armv8-aarch64-ce.S: Likewise.
	* cipher/sha1-armv8-aarch64-ce.S: Likewise.
	* cipher/sha256-armv8-aarch64-ce.S: Likewise.
	* cipher/sha512-armv8-aarch64-ce.S: Likewise.
	* cipher/sm3-aarch64.S: Likewise.
	* cipher/sm3-armv8-aarch64-ce.S: Likewise.
	* cipher/sm4-aarch64.S: Likewise.
	* cipher/sm4-armv8-aarch64-ce.S: Likewise.
	* cipher/sm4-armv9-aarch64-sve-ce.S: Likewise.
	* cipher/twofish-aarch64.S: Likewise.
	* mpi/aarch64/mpih-add1.S: Likewise.
	* mpi/aarch64/mpih-mul1.S: Likewise.
	* mpi/aarch64/mpih-mul2.S: Likewise.
	* mpi/aarch64/mpih-mul3.S: Likewise.
	* mpi/aarch64/mpih-sub1.S: Likewise.

	aarch64-asm: move constant data to read-only section.
	+ commit b3d7d520a0aab8b3356749fa4765a7f1f5c676d6
	* cipher/asm-common-aarch64.h (SECTION_RODATA)
	(GET_DATA_POINTER): New.
	(GET_LOCAL_POINTER): Remove.
	* cipher/camellia-aarch64.S: Move constant data to read-only data
	section; Remove unneeded '.ltorg'.
	* cipher/chacha20-aarch64.S: Likewise.
	* cipher/cipher-gcm-armv8-aarch64-ce.S: Likewise.
	* cipher/crc-armv8-aarch64-ce.S: Likewise.
	* cipher/rijndael-aarch64.S: Likewise.
	* cipher/sha1-armv8-aarch64-ce.S: Likewise.
	* cipher/sha256-armv8-aarch64-ce.S: Likewise.
	* cipher/sm3-aarch64.S: Likewise.
	* cipher/sm3-armv8-aarch64-ce.S: Likewise.
	* cipher/sm4-aarch64.S: Likewise.
	* cipher/sm4-armv9-aarch64-sve-ce.S: Likewise.
	* cipher/twofish-aarch64.S: Likewise.

	s390x-asm: move constant data to read-only section.
	+ commit 65f52773d4bb59a4ea4b7e373fe79b3559ddf312
	* cipher/chacha20-s390x.S: Move constant data to read-only
	section; Align functions to 16 bytes.
	* cipher/poly1305-s390x.S: Likewise.

	powerpc-asm: move constant data to read-only section.
	+ commit d0a109148b799e6ba24bb0e030009e5ac3eaf5dc
	* cipher/chacha20-p10le-8x.s: Move constant data to read-only
	section.

	mpi/amd64: align functions and inner loops to 16 bytes.
	+ commit 12ad3ea6b49b12ba7ca44bc77e4e87025a6fd095
	* mpi/amd64/mpih-add1.S: Align function and inner loop to 16 bytes.
	* mpi/amd64/mpih-lshift.S: Likewise.
	* mpi/amd64/mpih-mul1.S: Likewise.
	* mpi/amd64/mpih-mul2.S: Likewise.
	* mpi/amd64/mpih-mul3.S: Likewise.
	* mpi/amd64/mpih-rshift.S: Likewise.
	* mpi/amd64/mpih-sub1.S: Likewise.

	amd64-asm: move constant data to read-only section for cipher algos.
	+ commit 208b1f3a7bd8709889aa566ff030bcff57ce1cfd
	* cipher/camellia-aesni-avx-amd64.S: Move constant data to
	read-only section.
	* cipher/camellia-aesni-avx2-amd64.h: Likewise.
	* cipher/camellia-gfni-avx512-amd64.S: Likewise.
	* cipher/chacha20-amd64-avx2.S: Likewise.
	* cipher/chacha20-amd64-avx512.S: Likewise.
	* cipher/chacha20-amd64-ssse3.S: Likewise.
	* cipher/des-amd64.s: Likewise.
	* cipher/rijndael-ssse3-amd64-asm.S: Likewise.
	* cipher/rijndael-vaes-avx2-amd64.S: Likewise.
	* cipher/serpent-avx2-amd64.S: Likewise.
	* cipher/sm4-aesni-avx-amd64.S: Likewise.
	* cipher/sm4-aesni-avx2-amd64.S: Likewise.
	* cipher/sm4-gfni-avx2-amd64.S: Likewise.
	* cipher/sm4-gfni-avx512-amd64.S: Likewise.
	* cipher/twofish-avx2-amd64.S: Likewise.

	amd64-asm: align functions to 16 bytes for cipher algos.
	+ commit 9d62c54de2b0cd3b1849a27f8998e1f0d43f1583
	* cipher/blowfish-amd64.S: Align functions to 16 bytes.
	* cipher/camellia-aesni-avx-amd64.S: Likewise.
	* cipher/camellia-aesni-avx2-amd64.h: Likewise.
	* cipher/camellia-gfni-avx512-amd64.S: Likewise.
	* cipher/cast5-amd64.S: Likewise.
	* cipher/chacha20-amd64-avx2.S: Likewise.
	* cipher/chacha20-amd64-ssse3.S: Likewise.
	* cipher/des-amd64.s: Likewise.
	* cipher/rijndael-amd64.S: Likewise.
	* cipher/rijndael-ssse3-amd64-asm.S: Likewise.
	* cipher/salsa20-amd64.S: Likewise.
	* cipher/serpent-avx2-amd64.S: Likewise.
	* cipher/serpent-sse2-amd64.S: Likewise.
	* cipher/sm4-aesni-avx-amd64.S: Likewise.
	* cipher/sm4-aesni-avx2-amd64.S: Likewise.
	* cipher/sm4-gfni-avx2-amd64.S: Likewise.
	* cipher/twofish-amd64.S: Likewise.
	* cipher/twofish-avx2-amd64.S: Likewise.

	amd64-asm: move constant data to read-only section for hash/mac algos.
	+ commit 14137d685cf8d779ac4656b64b7d5adcdcf90e3a
	* cipher/asm-common-amd64.h (SECTION_RODATA): New.
	* cipher/blake2b-amd64-avx2.S: Use read-only section for constant
	data.
	* cipher/blake2b-amd64-avx512.S: Likewise.
	* cipher/blake2s-amd64-avx.S: Likewise.
	* cipher/blake2s-amd64-avx512.S: Likewise.
	* cipher/poly1305-amd64-avx512.S: Likewise.
	* cipher/sha1-avx-amd64.S: Likewise.
	* cipher/sha1-avx-bmi2-amd64.S: Likewise.
	* cipher/sha1-avx2-bmi2-amd64.S: Likewise.
	* cipher/sha1-ssse3-amd64.S: Likewise.
	* cipher/sha256-avx-amd64.S: Likewise.
	* cipher/sha256-avx2-bmi2-amd64.S: Likewise.
	* cipher/sha256-ssse3-amd64.S: Likewise.
	* cipher/sha512-avx-amd64.S: Likewise.
	* cipher/sha512-avx2-bmi2-amd64.S: Likewise.
	* cipher/sha512-avx512-amd64.S: Likewise.
	* cipher/sha512-ssse3-amd64.S: Likewise.
	* cipher/sha3-avx-bmi2-amd64.S: Likewise.

2023-01-17  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	tests/bench-slope: skip CPU warm-up in regression tests.
	+ commit ec57b50bc60a6a5cc98249e2607b4e31bdcba553
	* tests/bench-slope.c (warm_up_cpu): Skip in regression tests.

	tests/basic: perform x86 vector cluttering only when __SSE2__ is set.
	+ commit 308a70ac9907de136fae86db40ebe25c904167a2
	* tests/basic.c (CLUTTER_VECTOR_REGISTER_AMD64)
	(CLUTTER_VECTOR_REGISTER_I386): Set only if __SSE2__ defined.
	(clutter_vector_registers) [CLUTTER_VECTOR_REGISTER_AMD64]: Remove
	__SSE2__ check for "xmm" clobbers.
	(clutter_vector_registers) [CLUTTER_VECTOR_REGISTER_I386]: Likewise.

	tests/basic: fix clutter vector register asm for amd64 and i386.
	+ commit 1a758b08bba09a7bba72b764d4f7c6c7c8f08cf1
	* tests/basic.c (clutter_vector_registers): Pass data pointers through
	single register for CLUTTER_VECTOR_REGISTER_AMD64 and
	CLUTTER_VECTOR_REGISTER_I386 as compiler might attempt to allocate
	separate pointer register for each "m" operator.

	avx512: tweak zmm16-zmm31 register clearing.
	+ commit 7de2fb66e065a97f121bd16ab37efba32983a6bd
	* cipher/asm-common-amd64.h (spec_stop_avx512): Clear ymm16
	before and after vpopcntb.
	* cipher/camellia-gfni-avx512-amd64.S (clear_zmm16_zmm31): Clear
	YMM16-YMM31 registers instead of XMM16-XMM31.
	* cipher/chacha20-amd64-avx512.S (clear_zmm16_zmm31): Likewise.
	* cipher/keccak-amd64-avx512.S (clear_regs): Likewise.
	(clear_avx512_4regs): Clear all 4 registers with XOR.
	* cipher/cipher-gcm-intel-pclmul.c (_gcry_ghash_intel_pclmul)
	(_gcry_polyval_intel_pclmul): Clear YMM16-YMM19 registers instead of
	ZMM16-ZMM19.
	* cipher/poly1305-amd64-avx512.S (POLY1305_BLOCKS): Clear YMM16-YMM31
	registers after vector processing instead of XMM16-XMM31.
	* cipher/sha512-avx512-amd64.S
	(_gcry_sha512_transform_amd64_avx512): Likewise.

2023-01-06  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	aria: add generic 2-way bulk processing.
	+ commit 5e1a04f77933a8295df69d818e9effc076dc68cd
	* cipher/aria.c (ARIA_context): Add 'bulk_prefetch_ready'.
	(aria_crypt_2blks, aria_crypt_blocks, aria_enc_blocks, aria_dec_blocks)
	(_gcry_aria_ctr_enc, _gcry_aria_cbc_enc, _gcry_aria_cbc_dec)
	(_gcry_aria_cfb_enc, _gcry_aria_cfb_dec, _gcry_aria_ecb_crypt)
	(_gcry_aria_xts_crypt, _gcry_aria_ctr32le_enc, _gcry_aria_ocb_crypt)
	(_gcry_aria_ocb_auth): New.
	(aria_setkey): Setup 'bulk_ops' function pointers.

	Add ARIA block cipher.
	+ commit 316c6d7715d931a0fbe3ebc4e20e6f4d77b716cb
	* cipher/Makefile.am: Add 'aria.c'.
	* cipher/aria.c: New.
	* cipher/cipher.c (cipher_list, cipher_list_algo301): Add ARIA cipher
	specs.
	* cipher/mac-cmac.c (map_mac_algo_to_cipher): Add GCRY_MAC_CMAC_ARIA.
	(_gcry_mac_type_spec_cmac_aria): New.
	* cipher/mac-gmac.c (map_mac_algo_to_cipher): Add GCRY_MAC_GMAC_ARIA.
	(_gcry_mac_type_spec_gmac_aria): New.
	* cipher/mac-internal.h (_gcry_mac_type_spec_cmac_aria)
	(_gcry_mac_type_spec_gmac_aria)
	(_gcry_mac_type_spec_poly1305mac_aria): New.
	* cipher/mac-poly1305.c (poly1305mac_open): Add GCRY_MAC_GMAC_ARIA.
	(_gcry_mac_type_spec_poly1305mac_aria): New.
	* cipher/mac.c (mac_list, mac_list_algo201, mac_list_algo401)
	(mac_list_algo501): Add ARIA MAC specs.
	* configure.ac (available_ciphers): Add 'aria'.
	(GCRYPT_CIPHERS): Add 'aria.lo'.
	(USE_ARIA): New.
	* doc/gcrypt.texi: Add GCRY_CIPHER_ARIA128, GCRY_CIPHER_ARIA192,
	GCRY_CIPHER_ARIA256, GCRY_MAC_CMAC_ARIA, GCRY_MAC_GMAC_ARIA and
	GCRY_MAC_POLY1305_ARIA.
	* src/cipher.h (_gcry_cipher_spec_aria128, _gcry_cipher_spec_aria192)
	(_gcry_cipher_spec_aria256): New.
	* src/gcrypt.h.in (gcry_cipher_algos): Add GCRY_CIPHER_ARIA128,
	GCRY_CIPHER_ARIA192 and GCRY_CIPHER_ARIA256.
	(gcry_mac_algos): GCRY_MAC_CMAC_ARIA, GCRY_MAC_GMAC_ARIA and
	GCRY_MAC_POLY1305_ARIA.
	* tests/basic.c (check_ecb_cipher, check_ctr_cipher)
	(check_cfb_cipher, check_ocb_cipher) [USE_ARIA]: Add ARIA test-vectors.
	(check_ciphers) [USE_ARIA]: Add GCRY_CIPHER_ARIA128, GCRY_CIPHER_ARIA192
	and GCRY_CIPHER_ARIA256.
	(main): Also run 'check_bulk_cipher_modes' for 'cipher_modes_only'-mode.
	* tests/bench-slope.c (bench_mac_init): Add GCRY_MAC_POLY1305_ARIA
	setiv-handling.
	* tests/benchmark.c (mac_bench): Likewise.

2023-01-04  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	sm4: add missing OCB 16-way GFNI-AVX512 path.
	+ commit 30c9a1d101b45908a17c68fa50f4cdf9bd113792
	* cipher/sm4.c (_gcry_sm4_ocb_crypt) [USE_GFNI_AVX512]: Add 16-way
	GFNI-AVX512 handling.

	bulkhelp: change bulk function definition to allow modifying context.
	+ commit 86db4b02c6e5fd41ae958fb5e1fcf3e296a820ad
	* cipher/bulkhelp.h (bulk_crypt_fn_t): Make 'ctx' non-constant and
	change 'num_blks' from 'unsigned int' to 'size_t'.
	* cipher/camellia-glue.c (camellia_encrypt_blk1_32)
	(camellia_encrypt_blk1_64, camellia_decrypt_blk1_32)
	(camellia_decrypt_blk1_64): Adjust to match 'bulk_crypt_fn_t'.
	* cipher/serpent.c (serpent_crypt_blk1_16, serpent_encrypt_blk1_16)
	(serpent_decrypt_blk1_16): Likewise.
	* cipher/sm4.c (crypt_blk1_16_fn_t, _gcry_sm4_aesni_avx_crypt_blk1_8)
	(sm4_aesni_avx_crypt_blk1_16, _gcry_sm4_aesni_avx2_crypt_blk1_16)
	(sm4_aesni_avx2_crypt_blk1_16, _gcry_sm4_gfni_avx2_crypt_blk1_16)
	(sm4_gfni_avx2_crypt_blk1_16, _gcry_sm4_gfni_avx512_crypt_blk1_16)
	(_gcry_sm4_gfni_avx512_crypt_blk32, sm4_gfni_avx512_crypt_blk1_16)
	(_gcry_sm4_aarch64_crypt_blk1_8, sm4_aarch64_crypt_blk1_16)
	(_gcry_sm4_armv8_ce_crypt_blk1_8, sm4_armv8_ce_crypt_blk1_16)
	(_gcry_sm4_armv9_sve_ce_crypt, sm4_armv9_sve_ce_crypt_blk1_16)
	(sm4_crypt_blocks, sm4_crypt_blk1_32, sm4_encrypt_blk1_32)
	(sm4_decrypt_blk1_32): Likewise.
	* cipher/twofish.c (twofish_crypt_blk1_16, twofish_encrypt_blk1_16)
	(twofish_decrypt_blk1_16): Likewise.

	Add GMAC-SM4 and Poly1305-SM4.
	+ commit d1ccc409d4c655f695c7dc042a629a8898bd14eb
	* cipher/cipher.c (cipher_list_algo301): Remove comma at the end
	of last entry.
	* cipher/mac-gmac.c (map_mac_algo_to_cipher): Add SM4.
	(_gcry_mac_type_spec_gmac_sm4): New.
	* cipher/max-internal.h (_gcry_mac_type_spec_gmac_sm4)
	(_gcry_mac_type_spec_poly1305mac_sm4): New.
	* cipher/mac-poly1305.c (poly1305mac_open): Add SM4.
	(_gcry_mac_type_spec_poly1305mac_sm4): New.
	* cipher/mac.c (mac_list, mac_list_algo401, mac_list_algo501): Add
	GMAC-SM4 and Poly1304-SM4.
	(mac_list_algo101): Remove comma at the end of last entry.
	* cipher/md.c (digest_list_algo301): Remove comma at the end of
	last entry.
	* doc/gcrypt.texi: Add GCRY_MAC_GMAC_SM4 and GCRY_MAC_POLY1305_SM4.
	* src/gcrypt.h.in (GCRY_MAC_GMAC_SM4, GCRY_MAC_POLY1305_SM4): New.
	* tests/bench-slope.c (bench_mac_init): Setup IV for
	GCRY_MAC_POLY1305_SM4.
	* tests/benchmark.c (mac_bench): Likewise.

	Fix compiler warnings seen with clang-powerpc64le target.
	+ commit f2153d797f43a5fc8b80c2d908bf7dd6ad1fcc2a
	* cipher/rijndael-ppc-common.h (asm_sbox_be): New.
	* cipher/rijndael-ppc.c (_gcry_aes_sbox4_ppc8): Use 'asm_sbox_be'
	instead of 'vec_sbox_be' since this instrinsics has different
	prototype definition on GCC and Clang ('vector uchar' vs 'vector
	ulong long').
	* cipher/sha256-ppc.c (vec_ror_u32): Remove unused function.

2022-12-14  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	Add clang support for ARM 32-bit assembly.
	+ commit 02d5d1d97b3f281cf9c854d7143e346ab76fa384
	* configure.ac (gcry_cv_gcc_arm_platform_as_ok)
	(gcry_cv_gcc_inline_asm_neon): Remove % prefix from register names.
	* cipher/cipher-gcm-armv7-neon.S (vmull_p64): Prefix constant values
	with # character instead of $.
	* cipher/blowfish-arm.S: Remove % prefix from all register names.
	* cipher/camellia-arm.S: Likewise.
	* cipher/cast5-arm.S: Likewise.
	* cipher/rijndael-arm.S: Likewise.
	* cipher/rijndael-armv8-aarch32-ce.S: Likewise.
	* cipher/sha512-arm.S: Likewise.
	* cipher/sha512-armv7-neon.S: Likewise.
	* cipher/twofish-arm.S: Likewise.
	* mpi/arm/mpih-add1.S: Likewise.
	* mpi/arm/mpih-mul1.S: Likewise.
	* mpi/arm/mpih-mul2.S: Likewise.
	* mpi/arm/mpih-mul3.S: Likewise.
	* mpi/arm/mpih-sub1.S: Likewise.

	rijndael-ppc: fix wrong inline assembly constraint.
	+ commit 3d20308cc529b53d49954e9f0b8d10fa14422303
	* cipher/rijndael-ppc-function.h (CBC_ENC_FUNC): Fix outiv constraint.

	Fix building AVX512 Intel-syntax assembly with x86-64 clang.
	+ commit 31837163fbc36680140a17892374380a214c5d16
	* cipher/asm-common-amd64.h (spec_stop_avx512_intel_syntax): New.
	* cipher/poly1305-amd64-avx512.S: Use spec_stop_avx512_intel_syntax
	instead of spec_stop_avx512.
	* cipher/sha512-avx512-amd64.S: Likewise.

2022-12-14  NIIBE Yutaka  <gniibe@fsij.org>

	build: Fix m4 macros for strict C compiler.
	+ commit e3b441214f93d8f61875b8223480e57afa2a3f10
	* m4/ax_cc_for_build.m4: Fix for no arg.
	* m4/noexecstack.m4: Likewise.

	build: Fix configure.ac for strict C99.
	+ commit f62d5cf9f2683efa867fb04332c84ec899818d22
	* configure.ac: More fixes for other architecture.

2022-12-13  NIIBE Yutaka  <gniibe@fsij.org>

	build: Fix configure.ac for strict C99.
	+ commit 693ffa145378682229473b0e811a9cea7c4d307a
	* configure.ac: Add function declarations for asm functions.

2022-12-12  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	avx512: tweak AVX512 spec stop, use common macro in assembly.
	+ commit 8b4e0e9e9a3696be1404938226f0ec3582f12258
	* cipher/cipher-gcm-intel-pclmul.c: Use xmm registers for AVX512
	spec stop.
	* cipher/asm-common-amd64.h (spec_stop_avx512): New.
	* cipher/blake2b-amd64-avx512.S: Use spec_stop_avx512.
	* cipher/blake2s-amd64-avx512.S: Likewise.
	* cipher/camellia-gfni-avx512-amd64.S: Likewise.
	* cipher/chacha20-avx512-amd64.S: Likewise.
	* cipher/keccak-amd64-avx512.S: Likewise.
	* cipher/poly1305-amd64-avx512.S: Likewise.
	* cipher/sha512-avx512-amd64.S: Likewise.
	* cipher/sm4-gfni-avx512-amd64.S: Likewise.
	---

	chacha20-avx512: add handling for any input block count and tweak 16 block code a bit
	+ commit 996f81dd86ab299f92df581edad49e69ee932139
	* cipher/chacha20-amd64-avx512.S: Add tail handling for 8/4/2/1
	blocks; Rename `_gcry_chacha20_amd64_avx512_blocks16` to
	`_gcry_chacha20_amd64_avx512_blocks`; Tweak 16 parallel block processing
	for small speed improvement.
	* cipher/chacha20.c (_gcry_chacha20_amd64_avx512_blocks16): Rename to ...
	(_gcry_chacha20_amd64_avx512_blocks): ... this.
	(chacha20_blocks) [USE_AVX512]: Add AVX512 code-path.
	(do_chacha20_encrypt_stream_tail) [USE_AVX512]: Change to handle any
	number of full input blocks instead of multiples of 16.

2022-12-06  Jakub Jelen  <jjelen@redhat.com>

	fips,rsa: Prevent usage of X9.31 keygen in FIPS mode.
	+ commit 06ea5b5332ffdb44a0a394d766be8989bcb6a95c
	* cipher/rsa.c (rsa_generate): Do not accept use-x931 or derive-parms
	in FIPS mode.
	* tests/pubkey.c (get_keys_x931_new): Expect failure in FIPS mode.
	(check_run): Skip checking X9.31 keys in FIPS mode.
	* doc/gcrypt.texi: Document "test-parms" and clarify some cases around
	the X9.31 keygen.

2022-11-30  Jakub Jelen  <jjelen@redhat.com>

	rsa: Prevent usage of long salt in FIPS mode.
	+ commit bf1e62e59200b2046680d1d3d1599facc88cfe63
	* cipher/rsa-common.c (_gcry_rsa_pss_encode): Prevent usage of large
	  salt lengths
	  (_gcry_rsa_pss_verify): Ditto.
	* tests/basic.c (check_pubkey_sign): Check longer salt length fails in
	  FIPS mode
	* tests/t-rsa-pss.c (one_test_sexp): Fix function name in error message

2022-11-21  NIIBE Yutaka  <gniibe@fsij.org>

	random:w32: Don't emit message for diskperf when it's not useful.
	+ commit 35abf4d2eb582b78873aa324f6d02976788ffbbc
	* random/rndw32.c (slow_gatherer): Suppress emitting by log_info.

2022-11-18  Jakub Jelen  <jjelen@redhat.com>

	fips: Mark AES key wrapping as approved.
	+ commit c34c9e70055ee43e5ef257384fa15941f064e5a4
	* src/fips.c (_gcry_fips_indicator_cipher): Add key wrapping mode as
	approved.

	pkdf2: Add checks for FIPS.
	+ commit f4a861f3e5ae82f278284061e4829c03edf9c3a7
	* cipher/kdf.c (_gcry_kdf_pkdf2): Require 8 chars passphrase for FIPS.
	Set bounds for salt length and iteration count in FIPS mode.

2022-11-01  NIIBE Yutaka  <gniibe@fsij.org>

	build: Prefer gpgrt-config when available.
	+ commit 0dcb7e05c9e1c9c2a23abe0a0390680741b61414
	* src/libgcrypt.m4: Overriding the decision by
	--with-libgcrypt-prefix, use gpgrt-config libgcrypt when gpgrt-config
	is available.

2022-10-26  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	sha3-avx512: fix for "x32" target.
	+ commit eab1caae7bd529c09d809d4d7c64c97ab7abeab8
	* cipher/keccak.c (_gcry_keccak_absorb_blocks_avx512): Change size_t
	to u64; change 'const byte **new_lanes' to 'u64 *new_lanes'.
	(keccak_absorb_lanes64_avx512): Get new lines pointer from assembly
	through 'u64' type.

	serpent: accelerate XTS and ECB modes.
	+ commit 8a1fe5f78f9fed32cd641b3d9d02197f7ba394d8
	* cipher/serpent-armv7-neon.S (_gcry_serpent_neon_blk8): New.
	* cipher/serpent-avx2-amd64.S (_gcry_serpent_avx2_blk16): New.
	* cipher/serpent-sse2-amd64.S (_gcry_serpent_sse2_blk8): New.
	* cipher/serpent.c (_gcry_serpent_sse2_blk8)
	(_gcry_serpent_avx2_blk16, _gcry_serpent_neon_blk8)
	(_gcry_serpent_xts_crypt, _gcry_serpent_ecb_crypt)
	(serpent_crypt_blk1_16, serpent_encrypt_blk1_16)
	(serpent_decrypt_blk1_16): New.
	(serpent_setkey): Setup XTS and ECB bulk functions.

	serpent: fix compiler warning on 32-bit ARM.
	+ commit b50b7ea5cabaf3729afe370b285d78fff9e27d31
	* cipher/serpent.c (_gcry_serpent_ocb_crypt)
	(_gcry_serpent_ocb_auth) [USE_NEON]: Cast "Ls" to 'const void **'.

	twofish: accelerate XTS and ECB modes.
	+ commit d078a928f5c6024fde89388582b83742d2b8638a
	* cipher/twofish-amd64.S (_gcry_twofish_amd64_blk3): New.
	* cipher/twofish-avx2-amd64.S (_gcry_twofish_avx2_blk16): New.
	(_gcry_twofish_xts_crypt, _gcry_twofish_ecb_crypt)
	(_gcry_twofish_avx2_blk16, _gcry_twofish_amd64_blk3)
	(twofish_crypt_blk1_16, twofish_encrypt_blk1_16)
	(twofish_decrypt_blk1_16): New.
	(twofish_setkey): Setup XTS and ECB bulk functions.

	sm4: accelerate ECB (for benchmarking)
	+ commit 14f39993d632815db68a5dca90e021891c9547ab
	* cipher/sm4.c (_gcry_sm4_ecb_crypt): New.
	(sm4_setkey): Setup ECB bulk function.

	sm4: fix lookup-table prefetching.
	+ commit a43e03ef842b2bb93b10cd2b85230af1f0269ca0
	* cipher/sm4.c (sm4_expand_key): Prefetch sbox table.
	(sm4_get_crypt_blk1_16_fn): Do not prefetch sbox table.
	(sm4_expand_key, _gcry_sm4_ctr_enc, _gcry_sm4_cbc_dec)
	(_gcry_sm4_cfb_dec): Prefetch sbox table if table look-up
	implementation is used.

	camellia: accelerate ECB (for benchmarking)
	+ commit 6475d0915ffecc54a8d1105262edb28ff4026803
	* cipher/bulkhelp.h (bulk_ecb_crypt_128): New.
	* cipher/camellia-glue.c (_gcry_camellia_ecb_crypt): New.
	(camellia_setkey): Select ECB bulk function with AESNI/AVX2, VAES/AVX2
	and GFNI/AVX2.

	rijndael-vaes: align asm functions.
	+ commit 7c1aa4c9452aa1259039680bc1d5ba15124c5f76
	* cipher/rijndael-vaes-avx2-amd64.S: Align functions to 16 bytes.

	rijndael: add ECB acceleration (for benchmarking purposes)
	+ commit 84f3d41acb2377d1ed0c2b9e8268de9d35e90af0
	* cipher/cipher-internal.h (cipher_bulk_ops): Add 'ecb_crypt'.
	* cipher/cipher.c (do_ecb_crypt): Use bulk function if available.
	* cipher/rijndael-aesni.c (do_aesni_enc_vec8): Change asm label
	'.Ldeclast' to '.Lenclast'.
	(_gcry_aes_aesni_ecb_crypt): New.
	* cipher/rijndael-armv8-aarch32-ce.S (_gcry_aes_ecb_enc_armv8_ce)
	(_gcry_aes_ecb_dec_armv8_ce): New.
	* cipher/rijndael-armv8-aarch64-ce.S (_gcry_aes_ecb_enc_armv8_ce)
	(_gcry_aes_ecb_dec_armv8_ce): New.
	* cipher/rijndael-armv8-ce.c (_gcry_aes_ocb_enc_armv8_ce)
	(_gcry_aes_ocb_dec_armv8_ce, _gcry_aes_ocb_auth_armv8_ce): Change
	return value from void to size_t.
	(ocb_crypt_fn_t, xts_crypt_fn_t): Remove.
	(_gcry_aes_armv8_ce_ocb_crypt, _gcry_aes_armv8_ce_xts_crypt): Remove
	indirect function call; Return value from called function (allows tail
	call optimization).
	(_gcry_aes_armv8_ce_ocb_auth): Return value from called function (allows
	tail call optimization).
	(_gcry_aes_ecb_enc_armv8_ce, _gcry_aes_ecb_dec_armv8_ce)
	(_gcry_aes_armv8_ce_ecb_crypt): New.
	* cipher/rijndael-vaes-avx2-amd64.S
	(_gcry_vaes_avx2_ecb_crypt_amd64): New.
	* cipher/rijndael-vaes.c (_gcry_vaes_avx2_ecb_crypt_amd64)
	(_gcry_aes_vaes_ecb_crypt): New.
	* cipher/rijndael.c (_gcry_aes_aesni_ecb_crypt)
	(_gcry_aes_vaes_ecb_crypt, _gcry_aes_armv8_ce_ecb_crypt): New.
	(do_setkey): Setup ECB bulk function for x86 AESNI/VAES and ARM CE.

	mpi/longlong: update powerpc macros from GCC.
	+ commit bf5ec001dfcbd4a293d0bd577fd70a0f8286c4e6
	* mpi/longlong.h [__powerpc__, __powerpc64__]: Update macros.

	hwf-x86: enable VPGATHER usage for AMD CPUs with AVX512.
	+ commit 4b1cb76e3587a8fdf59673a8368d47e4cd2fe151
	* src/hwf-x86.c (detect_x86_gnuc): Move model based checks and
	forced soft hwfeatures enablement at end; Enable VPGATHER for
	AMD CPUs with AVX512.

	sha512-avx512: enable only on Intel CPUs for now.
	+ commit c0f85e0c8657030eb979a465199a07e2819f81e4
	* cipher/sha512.c (sha512_init_common): Enable AVX512 implementation
	only for Intel CPUs.

2022-10-26  Jakub Jelen  <jjelen@redhat.com>

	hmac,hkdf: Check the HMAC key length in FIPS mode.
	+ commit b095ea7559734f519fbe92d570afe567330eb474
	* src/visibility.c (gcry_md_setkey): Add the check here, too.

	Revert "kdf:pkdf2: Require longer input when FIPS mode."
	+ commit 47db7fe3a0c36523d2ccec31705cffff9a2337bc
	* cipher/kdf.c (_gcry_kdf_pkdf2): Remove the length limitation of
	  passphrase input length.

2022-10-24  NIIBE Yutaka  <gniibe@fsij.org>

	build: Update gpg-error.m4.
	+ commit 12b3bc5a0d9c453d02ae229aadfee82808c10220
	* m4/gpg-error.m4: Update from libgpg-error 1.46.

2022-10-19  Jakub Jelen  <jjelen@redhat.com>

	tests: Use proper format string for size_t.
	+ commit b77e7a225bc40ea09fa66969625b97b09a1cbf23


	cipher: Do not run RSA encryption selftest by default.
	+ commit 4e7941587c95fc3ae5fb5686346855395ef6754b
	* cipher/rsa.c (selftests_rsa): Skip encryption selftest as this
	  operation is not claimed as part of the certification.

	Revert "tests: Expect the RSA PKCS #1.5 encryption to fail in FIPS mode"
	+ commit 7468cdfc8b6aa0c6e17c41218d5c5f2b575b16e4
	This reverts commit f736f3c70182d9c948f9105eb769c47c5578df35. The pubkey
	encryption has already separate explicit FIPS service indicator.

	Revert "Do not allow PKCS #1.5 padding for encryption in FIPS"
	+ commit e83280b36be3be3775427c5842f4274d01992763
	This reverts commit c7709f7b23848abf4ba65cb99cb2a9e9c7ebdefc. The pubkey
	encryption has already separate explicit FIPS service indicator.

	Revert "tests: Expect the OEAP tests to fail in FIPS mode."
	+ commit 9d56af04dce0795d30374fd575a8500fcf0ae158
	This reverts commit 249ca431ef881d510b90a5d3db9cd8507c4d697b. The pubkey
	encryption has already separate explicit FIPS service indicator.

	Revert "fips: Disable RSA-OAEP padding in FIPS mode."
	+ commit a7b5cab05f6a7de23c565b1303eb3f198d0b7e2b
	This reverts commit e552e37983da0c54840786eeff34481685fde1e9. The pubkey
	encryption has already separate explicit FIPS service indicator.

	fips: Mark gcry_pk_encrypt/decrypt function non-approved.
	+ commit 05cb8355d3e66f15425ad85ae2203882e80f4792
	* src/fips.c (_gcry_fips_indicator_function): Add
	gcry_pk_encrypt/decrypt as non-approved.

	fips: Fix fips indicator function.
	+ commit c5de9e77fb332939695918710b0842030515cce0
	* src/fips.c (_gcry_fips_indicator_function): Fix typo in sign/verify
	function names.

2022-10-08  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	doc: fix RFC reference for GCM-SIV.
	+ commit 94dcd2cf5cd17244eaa96920218f32b64c0cec44
	* doc/gcrypt.texi: Fix GCM-SIV RFC reference to RFC-8452.

	mpi/longlong.h: i386: use tzcnt instruction for trailing zeros.
	+ commit f01d4b7a601f68e52c7c7b4647bfe97cb60be26e
	* mpi/longlong.h [__i386__] (count_trailing_zeros): Add 'rep' prefix
	for 'bsfq'.

	mpi/longlong.h: x86-64: use tzcnt instruction for trailing zeros.
	+ commit 38bd31bc46b992f68c9455ed50a6280943fe6a75
	* mpi/longlong.h [__x86_64__] (count_trailing_zeros): Add 'rep' prefix
	for 'bsfq'.

	mpi/longlong: fix generic smul_ppmm ifdef.
	+ commit d67f453d1b9de0ddb579de3a14ca8a3801bfead6
	* mpi/longlong.h [!umul_ppmm] (smul_ppmm): Change ifdef
	from !defined(umul_ppmm) to !defined(smul_ppmm).

	mpi/longlong: provide generic implementation using double word type.
	+ commit aef0ddf4d37ae7667cdf49d406e740e8d8d311cd
	* configure.ac: Add check for 'unsigned __int128'.
	* mpi/longlong.h (UDWtype): Define for 32-bit or 64-bit when
	'unsigned long long' or 'unsigned __int128' is available.
	(add_ssaaaa, sub_ddmmss, umul_ppmm, udiv_qrnnd) [UDWtype]: New.

2022-10-06  Jakub Jelen  <jjelen@redhat.com>

	tests: Reproducer for short dklen in FIPS mode.
	+ commit efdc87b305ff326f37acd3a9c2606de24a706cce
	* tests/t-kdf.c (check_pbkdf2): Add test vector with short dklen and
	  verify it fails in FIPS mode

	random: Extend the comment about FIPS specifics.
	+ commit 6e832840a8b7cdd30f77e66685ad0de863d7e84d
	* random/rndgetentropy.c (_gcry_rndgetentropy_gather_random): Clarify
	  description of the chainging DRBG in FIPS mode.

2022-10-04  Jakub Jelen  <jjelen@redhat.com>

	random: Get maximum 32B of entropy at once in FIPS Mode.
	+ commit a6a6e94027abf18a51f5f93bf9fb2cfe5496bdf8
	* random/rndgetentropy.c (_gcry_rndgetentropy_gather_random): In fips
	mode, gather max 32 B of strong entropy for initialization.

2022-10-02  Jakub Jelen  <jjelen@redhat.com>

	tests: Avoid memory leak.
	+ commit 567bc62e1c3046594088de7209fee7c545ece1e3
	* tests/hashtest.c (run_longtest): Avoid memory leak on error

2022-10-02  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	t-rsa-testparm: fix 'function declaration isn’t a prototype' warning.
	+ commit 0909186b9e66aa3a8fac7b2571915c45a7bfaeb3
	* cipher/t-rsa-testparm.c (check_rsa_testparm): Define parameters as
	void.

	tests/benchmark: remove VLA usage.
	+ commit 6419fbb1d3dd365a89623a94448a0335ae4a8554
	* cipher/benchmark.c (ccm_aead_init): Avoid VLA in stack array.

	tests/bench-slope: remove VLA usage.
	+ commit 335b8eb1211b3b67541c689da949101db3b669fd
	* tests/bench-slope.c (bench_set_cipher_key): New.
	(bench_encrypt_init, bench_xts_encrypt_init): Use
	'bench_set_cipher_key' to remove VLA usage.

	cipher-ccm: remove VLA usage.
	+ commit ce60a68a1172ea20c1ff72e27e4b0115d805bf48
	* cipher/cipher-ccm.c (do_cbc_mac): Avoid VLA for stack array.

	mpi/ec: remove VLA usage.
	+ commit 9978fc22045ca7623a6e0cbf704fb48ab1550419
	* mpi/ec-nist.c (_gcry_mpi_ec_nist192_mod, _gcry_mpi_ec_nist224_mod)
	(_gcry_mpi_ec_nist256_mod, _gcry_mpi_ec_nist384_mod)
	(_gcry_mpi_ec_nist521_mod): Avoid VLA for arrays.
	* mpi/ec.c (ec_secp256k1_mod): Avoid VLA for arrays.

2022-09-27  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	tests/hashtest: add hugeblock & disable-hwf options and 6 gig test vectors
	+ commit 0cb29a5736cfcd6bce4ce2495cd0481f0bdb34a4
	* .gitignore: Add 'tests/hashtest-6g'.
	* configure.ac: Add 'tests/hashtest-6g'.
	* tests/Makefile: Add 'hashtest-6g'.
	* tests/hashtest-6g.in: New.
	* tests/hashtest-256g.in: Add SHA3-512 to algos.
	* tests/hashtest.c (use_hugeblock): New.
	(testvectors): Add 256 GiB test vectors for BLAKE2S, BLAKE2B and
	whirlpool; Add 6 GiB test vectors for SHA1, SHA256, SHA512, SHA3, SM3,
	BLAKE2S, BLAKE2B, WHIRLPOOL, CRC32 and CRC24.
	(run_longtest); Use huge 5 GiB pattern block when requested.
	(main): Add '--hugeblock' and '--disable-hwf' options.
	* tests/testdrv.c: Add 'hashtest-6g'; Add SHA3 to 'hashtest-256g'.

2022-09-27  Jakub Jelen  <jjelen@redhat.com>

	keccak: Use size_t to avoid integer overflow.
	+ commit 9c828129b2058c3f36e07634637929a54e8377ee
	* cipher/keccak-armv7-neon.S: Fix function name in comment and change
	  parameter type to size_t.
	* cipher/keccak.c (keccak_ops_t): Change absorb function signature to
	  use size_t.
	  (keccak_absorb_lanes64_avx512): Change nlanes type to size_t.
	  (_gcry_keccak_absorb_lanes64_armv7_neon): Ditto.
	  (keccak_absorb_lanes64_armv7_neon): Ditto.
	  (keccak_absorb_lanes32bi): Ditto.
	  (keccak_absorb_lanes32bi_bmi2): Ditto.
	  (keccak_write): Change nlanes variable to use size_t and avoid
	  overflow when calculating count.
	* cipher/keccak_permute_64.h (KECCAK_F1600_ABSORB_FUNC_NAME): Change
	  nlanes argument to use size_t.

2022-09-27  Tobias Heider  <tobias.heider@canonical.com>

	kdf:pkdf2: Check minimum allowed key size when running in FIPS mode.
	+ commit 3c04b692de1e7b45b764ff8d66bf84609b012e3a
	* cipher/kdf.c (_gcry_kdf_pkdf2): Add output length check.

2022-09-27  NIIBE Yutaka  <gniibe@fsij.org>

	kdf:pkdf2: Require longer input when FIPS mode.
	+ commit 857e6f467d0fc9fd858a73d84122695425970075
	* cipher/kdf.c (_gcry_kdf_pkdf2): Add length check.

2022-09-22  Clemens Lang  <cllang@redhat.com>

	fips: Skip PCT if RSA keygen test-parms specified.
	+ commit c20022ffd4ad2cea51928a109dfa102d711d30ac
	* cipher/rsa.c (rsa_generate): Skip PCT is test-parms were specified.
	* tests/t-rsa-testparm.c: Add test for this functionality
	* tests/Makefile.am: Add test to build system

2022-09-16  NIIBE Yutaka  <gniibe@fsij.org>

	More clean up.
	+ commit 82226dad7ae0effa0d96645476f0401f94361141
	* cipher/cipher-ccm.c (_gcry_cipher_ccm_tag): Add static qualifier.
	* mpi/ec-ed25519.c: Include ec-internal.h.
	* src/secmem.c (MB_WIPE_OUT): Remove extra semicolon.

	Move function prototype to cipher.h.
	+ commit f97b2f706dd0a8820828e9015340a895539ed216
	* cipher/kdf-internal.h: Move from here.
	* src/cipher.h (blake2b_vl_hash): To here.

	Minor clean up.
	+ commit 984d94fa9ffff69bd1bdb5d418889d2e6b2745e2
	* mpi/mpi-internal.h: Remove extra semicolon from the macro.
	* mpi/mpih-mul.c: Likewise.
	* src/cipher-proto.h: Remove duplication for enum pk_encoding.
	* mpi/mpi-pow.c (_gcry_mpi_powm): Initialize XSIZE.

	Fix _gcry_err_code_to_errno.
	+ commit 3962623fe6de5c6d6604db90c8c0869fc3d3b7cf
	* src/gcrypt-int.h: Use gpg_err_code_to_errno.

	Fix use of noreturn.
	+ commit 000c50e0781920d691cc60c345a7bd4d770e92d5
	* doc/yat2m.c: Use __noreturn__.
	* src/g10lib.h: Likewise.

2022-09-08  NIIBE Yutaka  <gniibe@fsij.org>

	Silence compiler warnings for unused internal value.
	+ commit 37dc9f8fd00a3aff175f34f094557899207d7ef8
	* cipher/primegen.c (gen_prime): Fix write only variable.
	* src/dumpsexp.c (parse_and_print): Likewise.

	Fix function prototypes.
	+ commit 10d9878dd84fe89a598b6d5ac313869e5f8ffdae
	* random/random-csprng.c (random_poll): It's no args.
	* src/secmem.c (_gcry_secmem_module_init): Likewise.
	(_gcry_secmem_term): Likewise.

2022-08-26  NIIBE Yutaka  <gniibe@fsij.org>

	cipher: Check arguments for setup_geniv.
	+ commit c9008345c114ddf2f2ecbfe8dbab03c6d0649408
	* cipher/cipher.c (_gcry_cipher_setup_geniv): Validate the lengths.

2022-08-25  NIIBE Yutaka  <gniibe@fsij.org>

	cipher: Support internal generation of IV for AEAD cipher mode.
	+ commit 373b1f6c17948fa7d31880c3705391bef08a0471
	* cipher/cipher-gcm.c (_gcry_cipher_gcm_setiv_zero): New.
	(_gcry_cipher_gcm_encrypt, _gcry_cipher_gcm_decrypt)
	(_gcry_cipher_gcm_authenticate): Use _gcry_cipher_gcm_setiv_zero.
	* cipher/cipher-internal.h (struct gcry_cipher_handle): Add aead field.
	* cipher/cipher.c (_gcry_cipher_setiv): Check calling setiv to reject
	direct invocation in FIPS mode.
	(_gcry_cipher_setup_geniv, _gcry_cipher_geniv): New.
	* doc/gcrypt.texi: Add explanation for two new functions.
	* src/gcrypt-int.h (_gcry_cipher_setup_geniv, _gcry_cipher_geniv): New.
	* src/gcrypt.h.in (enum gcry_cipher_geniv_methods): New.
	(gcry_cipher_setup_geniv, gcry_cipher_geniv): New.
	* src/libgcrypt.def (gcry_cipher_setup_geniv, gcry_cipher_geniv): Add.
	* src/libgcrypt.vers: Likewise.
	* src/visibility.c (gcry_cipher_setup_geniv, gcry_cipher_geniv): Add.
	* src/visibility.h: Likewise.

2022-08-23  Jakub Jelen  <jjelen@redhat.com>

	tests: Expect the OEAP tests to fail in FIPS mode.
	+ commit 249ca431ef881d510b90a5d3db9cd8507c4d697b
	* tests/basic.c (check_pubkey_crypt): Expect the OAEP padding encryption
	  to fail in FIPS mode
	* tests/pkcs1v2.c (check_oaep): Expect the OAEP tests to fail in FIPS
	  mode

	fips: Disable RSA-OAEP padding in FIPS mode.
	+ commit e552e37983da0c54840786eeff34481685fde1e9
	* cipher/pubkey-util.c (_gcry_pk_util_data_to_mpi): Block OAEP padding
	  in FIPS mode for encryption
	* cipher/rsa.c (rsa_decrypt): Block OAEP padding in FIPS mode for
	  decryption

	gcrypt.h: Fix function name in comment.
	+ commit 0d69847e41e1803654180544fffd4cba3f49cb12


	random: Use getrandom (GRND_RANDOM) in FIPS mode.
	+ commit aab1d63e4def41593312f76de016c885ffafecde
	* random/rndgetentropy.c (_gcry_rndgetentropy_gather_random): Use
	  GRND_RANDOM in FIPS Mode

	Simplify the PCT for RSA and ECDSA.
	+ commit a527d252b89958864153da9ad149e97bb96e1692
	Could be squashed.

	* cipher/ecc.c (test_keys_fips): Simplify to accept key in SEXP format
	  (nist_generate_key): Skip call to test keys
	  (ecc_generate): Call test keys in FIPS mode later, when we have
	  complete SEXP key structure.
	* cipher/rsa.c (test_keys_fips): Simplify to accept key in SEXP format
	  (generate_fips): Skip selftest at this stage
	  (rsa_generate): Test the keys later when we already have key in SEXP
	  format

	ecc: Run PCT also with the digest step.
	+ commit d259993b9456c7abe465f234c4a6f9688a16db40
	* cipher/ecc.c (test_keys_fips): New function
	  (nist_generate_key): In FIPS mode, execute new PCT test
	---

	rsa: Run PCT in FIPS mode also with digest step.
	+ commit 505f048cac8e5af92d3431bd97ade492d1a30bc2
	* cipher/rsa.c (test_keys_fips): New.
	(generate_fips): Call test_keys_fips.

	fips: Add function-name based FIPS indicator.
	+ commit 05a9c9d1ba1db6c1cd160fba979e9ddf4700a0c0
	* doc/gcrypt.texi: Document the new function-based fips indicator
	  GCRYCTL_FIPS_SERVICE_INDICATOR_FUNCTION
	* src/fips.c (_gcry_fips_indicator_function): New function indicating
	  non-approved functions.
	* src/gcrypt.h.in (enum gcry_ctl_cmds): New symbol
	  GCRYCTL_FIPS_SERVICE_INDICATOR_FUNCTION
	* src/global.c (_gcry_vcontrol): Handle new FIPS indicator.

	fips: Run digest&sign self tests for RSA and ECC in FIPS mode.
	+ commit 1fc7bfc351ba1d7fa31c0c62a24ad78e9e1cfd5b
	* cipher/ecc.c (selftest_hash_sign): Implement digest & sign KAT
	 (selftests_ecdsa): Run the original basic test only with extended tests
	 (run_selftests): Pass-through the extended argument
	* cipher/rsa.c (selftest_hash_sign_2048): Implement digest & sign KAT
	 (selftests_rsa): Run the original basic test only with extended tests
	 (run_selftests): Pass-through the extended argument

2022-08-18  Milan Broz  <gmazyland@gmail.com>

	kdf: Allow empty password for Argon2.
	+ commit a20700c55f0eb8dbb8368b756a571c116163a0bc
	* cipher/kdf.c (_gcry_kdf_open) allow empty password for Argon2.

	kdf: Restructure KDF test vectors.
	+ commit 8a1f50e66364389b8a867801ead8327a663b0c03
	* tests/t-kdf.c: Restructure KDF test vectors to allow easy addition
	  new vectors. Also remove some ugly C code like goto again.

2022-08-02  Clemens Lang  <cllang@redhat.com>

	tests/basic: Add ifdefs for SM4 and CAMELLIA tests.
	+ commit 97e2c237f15dcdb44152887f4773f1f212b529bd
	* tests/basic.c (check_gcm_siv_cipher): Do not run test vectors that
	  are known to fail when compiled without support for SM4 or CAMELLIA.

2022-08-01  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	basic: gcm-siv: add fips checks for SM4 and CAMELLIA128.
	+ commit a8f66410ca0ded040abea4790efaeb36bb4ccc91
	* tests/basic.c (check_gcm_siv_cipher): Add 'flags' for test vectors
	and set FLAG_NOFIPS for SM4 and CAMELLIA128 test vectors; Add FIPS check
	for test vectors; Change printing "aes-gcm-siv" on fail messages to
	"algo %d GCM-SIV".

2022-07-31  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	sm4: fix unused parameter compiler warning.
	+ commit a0c933f6fed0612558ff75fb23cbf78e2dea1f16
	* cipher/sm4.c (sm4_get_crypt_blk1_16_fn): '(void)'-access ctx
	parameter to avoid compiler warning on powerpc.

2022-07-31  Tianjia Zhang  <tianjia.zhang@linux.alibaba.com>

	sm4: add ARMv8 CE accelerated implementation for XTS mode.
	+ commit 8287dea8379fa9e43dc331c6bd444dd25a962e4b
	* cipher/sm4-armv8-aarch64-ce.S (_gcry_sm4_armv8_ce_xts_crypt): New.
	* cipher/sm4.c (_gcry_sm4_armv8_ce_xts_crypt): New.
	(_gcry_sm4_xts_crypt) [USE_ARM_CE]: Add ARMv8 CE implementation for XTS.

2022-07-31  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	Simplify AES key schedule implementation.
	+ commit db5136c4d9331c001bbe91cfe6625ae7738f8575
	* cipher/rijndael-armv8-ce.c (_gcry_aes_armv8_ce_setkey): New key
	schedule with simplified structure and less stack usage.
	* cipher/rijndael-internal.h (RIJNDAEL_context_s): Add
	'keyschedule32b'.
	(keyschenc32b): New.
	* cipher/rijndael-ppc-common.h (vec_u32): New.
	* cipher/rijndael-ppc.c (vec_bswap32_const): Remove.
	(_gcry_aes_sbox4_ppc8): Optimize for less instructions emitted.
	(keysched_idx): New.
	(_gcry_aes_ppc8_setkey): New key schedule with simplified structure.
	* cipher/rijndael-tables.h (rcon): Remove.
	* cipher/rijndael.c (sbox4): New.
	(do_setkey): New key schedule with simplified structure and less
	stack usage.

	rijndael-ppc: small speed-up for CBC and CFB encryption.
	+ commit 2ac6c24aa53024eb415d49f52229e868f72f47f8
	* cipher/rijndael-ppc-common.h (AES_ENCRYPT_ALL): Remove
	* cipher/rijndael-ppc-functions.h (CFB_ENC_FUNC)
	(CBC_ENC_FUNC): Removed two block unrolled loop; Optimized single
	block loop for shorter critical-path.

2022-07-25  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	sha512: add AArch64 crypto/SHA512 extension implementation.
	+ commit e51d3b8330a1d4b15e3484df90646e075c02f54b
	* cipher/Makefile.am: Add 'sha512-armv8-aarch64-ce.S'.
	* cipher/sha512-armv8-aarch64-ce.S: New.
	* cipher/sha512.c (ATTR_ALIGNED_64, USE_ARM64_SHA512): New.
	(k): Make array aligned to 64 bytes.
	[USE_ARM64_SHA512] (_gcry_sha512_transform_armv8_ce): New.
	[USE_ARM64_SHA512] (do_sha512_transform_armv8_ce): New.
	(sha512_init_common) [USE_ARM64_SHA512]: Use ARMv8-SHA512 accelerated
	implementation if HW feature available.
	* configure.ac: Add 'sha512-armv8-aarch64-ce.lo'.
	(gcry_cv_gcc_inline_asm_aarch64_sha3_sha512_sm3_sm4)
	(HAVE_GCC_INLINE_ASM_AARCH64_SHA3_SHA512_SM3_SM4): New.

	blake2: add AVX512 accelerated implementations.
	+ commit 909daa700e4b45d75469df298ee564b8fc2f4b72
	* cipher/Makefile.am: Add 'blake2b-amd64-avx512.S' and
	'blake2s-amd64-avx512.S'.
	* cipher/blake2.c (USE_AVX512): New.
	(ASM_FUNC_ABI): Setup attribute if USE_AVX2 or USE_AVX512 enabled in
	addition to USE_AVX.
	(BLAKE2B_CONTEXT_S, BLAKE2S_CONTEXT_S): Add 'use_avx512'.
	(_gcry_blake2b_transform_amd64_avx512)
	(_gcry_blake2s_transform_amd64_avx512): New.
	(blake2b_transform, blake2s_transform) [USE_AVX512]: Add AVX512 path.
	(blake2b_init_ctx, blake2s_init_ctx) [USE_AVX512]: Use AVX512 if HW
	feature available.
	* cipher/blake2b-amd64-avx512.S: New.
	* cipher/blake2s-amd64-avx512.S: New.
	* configure.ac: Add 'blake2b-amd64-avx512.lo' and
	'blake2s-amd64-avx512.lo'.

	sha3: Add x86-64 AVX512 accelerated implementation.
	+ commit beaad75f4655e5316ce24f75ef172c231fd47fc1
	* LICENSES: Add 'cipher/keccak-amd64-avx512.S'.
	* configure.ac: Add 'keccak-amd64-avx512.lo'.
	* cipher/Makefile.am: Add 'keccak-amd64-avx512.S'.
	* cipher/keccak-amd64-avx512.S: New.
	* cipher/keccak.c (USE_64BIT_AVX512, ASM_FUNC_ABI): New.
	[USE_64BIT_AVX512] (_gcry_keccak_f1600_state_permute64_avx512)
	(_gcry_keccak_absorb_blocks_avx512, keccak_f1600_state_permute64_avx512)
	(keccak_absorb_lanes64_avx512, keccak_avx512_64_ops): New.
	(keccak_init) [USE_64BIT_AVX512]: Enable x86-64 AVX512 implementation
	if supported by HW features.

2022-07-21  Jussi Kivilinna  <jussi.kivilinna@iki.fi>

	sm4-arm-sve-ce: use 32 parallel blocks for XTS and CTR32LE.
	+ commit dca0bd133dd08ec88e0b4c454cfc26c9093572a9
	* cipher/sm4.c (sm4_crypt_blk1_32) [USE_ARM_SVE_CE]: Add SVE-SM4 code
	path.

	sm4 & camellia: add generic bulk acceleration for CTR32LE mode (GCM-SIV)
	+ commit cf956793afc2cdbd3b20caa3d186ccb8023b804c
	* cipher/bulkhelp.h (bulk_ctr32le_enc_128): New.
	* cipher/camellia-glue.c (_gcry_camellia_ctr32le_enc): New.
	(camellia_setkey): Setup `bulk_ops->ctr32le_enc` if any AVX2
	implementation is available.
	* cipher/sm4.c (_gcry_sm4_ctr32le_enc): New.
	(sm4_setkey): Setup `bulk_ops->ctr32le_enc`.
	* tests/basic.c (check_gcm_siv_cipher): Add large bulk encryption
	test vectors for SM4 and CAMELLIA128.

	sm4: add amd64 GFNI/AVX512 implementation.
	+ commit eaed633c1662d8a98042ac146c981113f2807b22
	* cipher/Makefile.am: Add 'sm4-gfni-avx512-amd64.S'.
	* cipher/sm4-gfni-avx512-amd64.S: New.
	* cipher/sm4-gfni.c (USE_GFNI_AVX512): New.
	(SM4_context): Add 'use_gfni_avx512' and 'crypt_blk1_16'.
	(_gcry_sm4_gfni_avx512_expand_key, _gcry_sm4_gfni_avx512_ctr_enc)
	(_gcry_sm4_gfni_avx512_cbc_dec, _gcry_sm4_gfni_avx512_cfb_dec)
	(_gcry_sm4_gfni_avx512_ocb_enc, _gcry_sm4_gfni_avx512_ocb_dec)
	(_gcry_sm4_gfni_avx512_ocb_auth, _gcry_sm4_gfni_avx512_ctr_enc_blk32)
	(_gcry_sm4_gfni_avx512_cbc_dec_blk32)
	(_gcry_sm4_gfni_avx512_cfb_dec_blk32)
	(_gcry_sm4_gfni_avx512_ocb_enc_blk32)
	(_gcry_sm4_gfni_avx512_ocb_dec_blk32)
	(_gcry_sm4_gfni_avx512_crypt_blk1_16)
	(_gcry_sm4_gfni_avx512_crypt_blk32, sm4_gfni_avx512_crypt_blk1_16)
	(sm4_crypt_blk1_32, sm4_encrypt_blk1_32, sm4_decrypt_blk1_32): New.
	(sm4_expand_key): Add GFNI/AVX512 code-path
	(sm4_setkey): Use GFNI/AVX512 if supported by CPU; Setup
	`ctx->crypt_blk1_16`.
	(sm4_encrypt, sm4_decrypt, sm4_get_crypt_blk1_16_fn, _gcry_sm4_ctr_enc)
	(_gcry_sm4_cbc_dec, _gcry_sm4_cfb_dec, _gcry_sm4_ocb_crypt)
	(_gcry_sm4_ocb_auth) [USE_GFNI_AVX512]: Add GFNI/AVX512 code path.
	(_gcry_sm4_xts_crypt): Change parallel block size from 16 to 32.
	* configure.ac: Add 'sm4-gfni-avx512-amd64.lo'.

2022-07-21  Tianjia Zhang  <tianjia.zhang@linux.alibaba.com>

	Add SM4 ARMv9 SVE CE assembly implementation.
	+ commit 2dc2654006746a25f9cb6b24786867f1725ac244
	* cipher/Makefile.am: Add 'sm4-armv9-aarch64-sve-ce.S'.
	* cipher/sm4-armv9-aarch64-sve-ce.S: New.
	* cipher/sm4.c (USE_ARM_SVE_CE): New.
	(SM4_context) [USE_ARM_SVE_CE]: Add 'use_arm_sve_ce'.
	(_gcry_sm4_armv9_sve_ce_crypt, _gcry_sm4_armv9_sve_ce_ctr_enc)
	(_gcry_sm4_armv9_sve_ce_cbc_dec, _gcry_sm4_armv9_sve_ce_cfb_dec)
